#ifndef COMPONENT_H 
#define COMPONENT_H

#include "xrmtypes.h"

extern int NewComponentID(GCD *CircuitData, int SetComponentID);

extern ErrorCheck AddComponent(GCD *CircuitData, int CompID, int SubFunctionID);
extern ErrorCheck EditComponent(GCD *CircuitData, int CompiD,Component Comp, Boolean AddAttachPointUnder);
extern ErrorCheck ReplaceAttachForComp( GCD *CircuitData, int CompID);
extern ErrorCheck GetLinkUsingComponent(GCD *CircuitData, int CompID, int *LinkIDTab, int *LinkNb);

extern ErrorCheck DeleteComponentAttachPoint(GCD *CircuitData, int CompID);

extern ErrorCheck DisplayComponent(GCD *CircuitData);
extern ErrorCheck DisplayComponentBuffer(GCD *CircuitData);
extern ErrorCheck DeleteComponent(GCD *CircuitData, int CompID);
extern ErrorCheck CutComponent(GCD *CircuitData, int CompID);
extern ErrorCheck CopyComponent(GCD *CircuitData, int CompID);
extern ErrorCheck PasteComponent(GCD *CircuitData, int SubFunctionID, int *PasteID, int x, int y);

extern ErrorCheck AddComponentToBuffer(GCD *CircuitData, int CompID);

extern ErrorCheck GetComponentProperties(GCD *CircuitData, int CompID, Component *Comp, Boolean WithAttachIDTab);
extern ErrorCheck GetComponentAttachNb(GCD *CircuitData, int CompID, int *AttachNb);
extern ErrorCheck SetIIDForComponent(GCD *CircuitData, int CompID, void *InterfaceID);
extern ErrorCheck GetIIDForComponent(GCD *CircuitData, int CompID, void **InterfaceID);
extern ErrorCheck GetCompOccupation( GCD  *CircuitData, int CompID, int  *Occupation);
extern ErrorCheck GetComponentIDFromCoordinates(GCD *CircuitData, int x, int y, int *CompID);
extern ErrorCheck SelectComponentFromID(GCD *CircuitData, int ComponentID);
extern ErrorCheck GetComponentLinkNumber(GCD *CircuitData, int CompID, int *LinkNb, Boolean Internal);

#endif /* COMPONENT_H */
