
#include "computecircuit.h"
#include <stdlib.h>
#include <stdio.h>
#include "misc.h"

ErrorCheck  ComputeCircuit (Circuit *pPlate)
{
  int Counter, Counter2, ConnectionCounter, ConnectionNb, NbOfLink,FirstAttach, AttachCounter, Attach, *EquiAttachment;
  Boolean *SamePot, NewFound;
  
  EquiAttachment = (int *) malloc ( pPlate->AttachNb * sizeof (int));
  SamePot = (Boolean *) malloc ( pPlate->LinkNb * sizeof (int));
  for (FirstAttach = 0 ; FirstAttach < pPlate->AttachNb ; FirstAttach++)
    if (pPlate->AttachTab[FirstAttach].Size == NoAttach)
      {
	for (Counter = 0; Counter < pPlate->LinkNb; Counter++)
	  SamePot[Counter] = False;
	ConnectionNb = 1;
	EquiAttachment[0] = FirstAttach;
	do
	  {
	    NewFound = False;
	    for (Counter = 0 ;  (Counter < pPlate->LinkNb) && (NewFound == False) ; Counter++)
	      {
		for (ConnectionCounter = 0;(SamePot[Counter] == False) &&  (ConnectionCounter < ConnectionNb)
		       && (NewFound == False); ConnectionCounter++)
		  {
		    if (( pPlate->LinkTab[Counter].Start == EquiAttachment[ConnectionCounter])
			|| (pPlate->LinkTab[Counter].End == EquiAttachment[ConnectionCounter]))
		      {
 			SamePot[Counter] = True;
			if (FindNbInTab ( pPlate->LinkTab[Counter].Start, EquiAttachment, ConnectionNb) == NotFound)
			  {
			    NewFound = True;
			    EquiAttachment[ConnectionNb] = pPlate->LinkTab[Counter].Start;
			    ConnectionNb++;
			  }
			if (FindNbInTab ( pPlate->LinkTab[Counter].End, EquiAttachment, ConnectionNb) == NotFound)
			  {
			    NewFound = True;
			    EquiAttachment[ConnectionNb] = pPlate->LinkTab[Counter].End;
			    ConnectionNb++;
			  }
		      }
		  }
	      }
	  }
	while (NewFound == True);
	/* on a dans EquiAttachment les numeros de points d attache equipotentiels a FirstAttach */
	/* Samepot = True si le lien est connecte a l equipot */
	NbOfLink = 0;
	for (Counter = 0; Counter < pPlate->LinkNb; Counter++)
	  if (SamePot[Counter] == True)
	    NbOfLink++;
	
	for (AttachCounter = 0 ; AttachCounter < ConnectionNb; AttachCounter++)
	  {
	    pPlate->AttachTab[EquiAttachment[AttachCounter]].Size =  NbOfLink;
	    if (NbOfLink != 0)
	      pPlate->AttachTab[EquiAttachment[AttachCounter]].Attach2Link =  (int *) malloc (sizeof(int) * NbOfLink);
	    Counter2 = 0;
	    for (Counter = 0; Counter < pPlate->LinkNb; Counter++)
	      if (SamePot[Counter] == True)
		{
		  pPlate->AttachTab[EquiAttachment[AttachCounter]].Attach2Link[Counter2] = Counter;
		  Counter2++;
		}
	  }
      }
  /* tout est ok pour AttachTab */
  for (Counter = 0 ; Counter < pPlate->LinkNb ; Counter++)
    {
      /* start */
      Attach = pPlate->LinkTab[Counter].Start;
      
      pPlate->LinkTab[Counter].LinkSize =  pPlate->AttachTab[Attach].Size;
      if (pPlate->AttachTab[Attach].Size != 0)
	pPlate->LinkTab[Counter].Link2Link = (int *) malloc(sizeof(int) * pPlate->AttachTab[Attach].Size);
    
      for (Counter2 = 0 ; Counter2 < pPlate->AttachTab[Attach].Size ; Counter2++)
	pPlate->LinkTab[Counter].Link2Link[Counter2] =  pPlate->AttachTab[Attach].Attach2Link[Counter2];
    }
  free(EquiAttachment);
  free(SamePot);
  return AllOk;
}

