
#include <stdio.h>
#include "editwindows.h"
#include "xrmtypes.h"
#include "liste.h"
#include "interface.h"
#include "circuitviewwindow.h"
#include "mainwindow.h"
#include "component.h"
#include "link.h"
#include "layout.h"
#include "compdesc.h"
#include "attachpoint.h"
#include "subfunction.h"
#include "linkwindow.h"
#include "componentwindow.h"
#include "optionfile.h"
#include "math.h"

void EditWithID(int NewID, int x, int y)
{
  GCD *CircuitData;
  char Buffer[BufferLength];

  CircuitData = GetCircuitData();
  if ( IsCircuitID(NewID)) 
    {
      GtkWidget *DesignerEntry, *SocietyEntry, *DescriptionEntry, *ProjectEntry, *VersionEntry, *DateEntry, 
	*WidthEntry, *HeightEntry, *EditCircuit; 
      Header DataHeader;
      
      EditCircuit = create_CircuitEditWindow();
      GetCircuitInfo(CircuitData, &DataHeader);
      
      DesignerEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "DesignerEntry");
      SocietyEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "SocietyEntry");
      ProjectEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "ProjectEntry");
      VersionEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "VersionEntry");
      DescriptionEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "DescriptionEntry");
      DateEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "DateEntry");
      WidthEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "SizeXEntry");
      HeightEntry = gtk_object_get_data(GTK_OBJECT(EditCircuit), "SizeYEntry");
      
      gtk_entry_set_text(GTK_ENTRY(ProjectEntry),  CircuitData->DataHeader.Name);
      gtk_entry_set_text(GTK_ENTRY(DesignerEntry),  CircuitData->DataHeader.Designer);
      gtk_entry_set_text(GTK_ENTRY(SocietyEntry),  CircuitData->DataHeader.Society);
      gtk_entry_set_text(GTK_ENTRY(DescriptionEntry),  CircuitData->DataHeader.Description);
      gtk_entry_set_text(GTK_ENTRY(VersionEntry),  CircuitData->DataHeader.Version);
      gtk_entry_set_text(GTK_ENTRY(DateEntry),  CircuitData->DataHeader.RevisionDate);
      sprintf(Buffer,"%d", CircuitData->DataHeader.Height);
      gtk_entry_set_text(GTK_ENTRY(HeightEntry), Buffer);
      sprintf(Buffer,"%d", CircuitData->DataHeader.Width);
      gtk_entry_set_text(GTK_ENTRY(WidthEntry), Buffer);
  
      gtk_widget_show(EditCircuit);
      UpdateCircuitView(UCVModification);
      CircuitData->Info.NewModification = True;
    }

  if (IsComponentID(NewID))
    {
      Component ComponentProperties;
      CompDescDef CompDescProp;
      LayoutDef LayoutProp;
      GtkWidget *EditCompo, *IDLabel, *NameEntry, *XEntry, *YEntry, *DescNameEntry, *DescClassEntry,
	*LeftRadio, *RightRadio, *TopRadio, *BottomRadio, *BetweenPinsCheck, *CompoInCheck, *CompoOutCheck,
	*LayoutNameEntry, *LayoutClassEntry;
      
      EditCompo = create_ComponentEditWindow();
      LeftRadio = gtk_object_get_data(GTK_OBJECT(EditCompo), "LeftRadio");
      RightRadio = gtk_object_get_data(GTK_OBJECT(EditCompo), "RightRadio");
      TopRadio = gtk_object_get_data(GTK_OBJECT(EditCompo), "TopRadio");
      BottomRadio = gtk_object_get_data(GTK_OBJECT(EditCompo), "BottomRadio");
      BetweenPinsCheck = gtk_object_get_data(GTK_OBJECT(EditCompo), "BetweenPinsCheck");
      CompoInCheck = gtk_object_get_data(GTK_OBJECT(EditCompo), "CompoInCheck");
      CompoOutCheck = gtk_object_get_data(GTK_OBJECT(EditCompo), "CompoOutCheck");
      
      gtk_object_set_data( GTK_OBJECT(EditCompo), ObjID, GINT_TO_POINTER(NewID));
      
      GetComponentProperties(CircuitData,NewID, &ComponentProperties, False);
      GetLayoutProperties(CircuitData->CompLib, ComponentProperties.LayoutName, ComponentProperties.LayoutClass, 
			  &LayoutProp, False, False);
      GetCompDescProperties(CircuitData->CompLib, ComponentProperties.CompDescName, &CompDescProp, False);
      printf("Component |%s| |%s| |%s|\n", ComponentProperties.CompDescName, ComponentProperties.LayoutName, ComponentProperties.LayoutClass);
 printf("Layout : |%s| |%s| \nCompDesc |%s| |%s|\n", LayoutProp.LayoutName, LayoutProp.LayoutClass, CompDescProp.CompDescName, CompDescProp.CompDescClass);

      if (IsComponentToLeft(ComponentProperties.State))
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(LeftRadio), TRUE);
      if (IsComponentToRight(ComponentProperties.State))
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(RightRadio), TRUE);
      if (IsComponentToTop(ComponentProperties.State))
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(TopRadio), TRUE);
      if (IsComponentToBottom(ComponentProperties.State))
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(BottomRadio), TRUE);
      if (IsComponentBetweenPins(ComponentProperties.State))
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(BetweenPinsCheck), TRUE);
      if (IsComponentCompoIn(ComponentProperties.State))
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(CompoInCheck), TRUE);
      if (IsComponentCompoOut(ComponentProperties.State))
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(CompoOutCheck), TRUE);
      
      IDLabel = gtk_object_get_data(GTK_OBJECT(EditCompo), "IDLabel");
      sprintf(Buffer, "%d", NewID);
      gtk_label_set_text(GTK_LABEL(IDLabel), Buffer);

      NameEntry = gtk_object_get_data(GTK_OBJECT(EditCompo), "NameEntry");
      gtk_entry_set_text(GTK_ENTRY(NameEntry), ComponentProperties.ComponentName);

      DescNameEntry = gtk_object_get_data(GTK_OBJECT(EditCompo), "DescriptionEntry");
      gtk_entry_set_text(GTK_ENTRY(DescNameEntry), CompDescProp.CompDescName);

      DescClassEntry = gtk_object_get_data(GTK_OBJECT(EditCompo), "DescriptionClassEntry");
      gtk_entry_set_text(GTK_ENTRY(DescClassEntry), CompDescProp.CompDescClass);

      LayoutNameEntry = gtk_object_get_data(GTK_OBJECT(EditCompo), "LayoutEntry");
      gtk_entry_set_text(GTK_ENTRY(LayoutNameEntry), LayoutProp.LayoutName);
      
      LayoutClassEntry = gtk_object_get_data(GTK_OBJECT(EditCompo), "LayoutClassEntry");
      gtk_entry_set_text(GTK_ENTRY(LayoutClassEntry), LayoutProp.LayoutClass);

      XEntry = gtk_object_get_data(GTK_OBJECT(EditCompo), "XPositionEntry");
      if (x == NoX)
	sprintf(Buffer,"%d", ComponentProperties.Reference.x);
      else 
	sprintf(Buffer,"%d",x);
      gtk_entry_set_text(GTK_ENTRY(XEntry), Buffer);

      YEntry = gtk_object_get_data(GTK_OBJECT(EditCompo), "YPositionEntry");
      if (y == NoY)
	sprintf(Buffer,"%d", ComponentProperties.Reference.y);
      else
	sprintf(Buffer,"%d",y);
      gtk_entry_set_text(GTK_ENTRY(YEntry), Buffer);

      gtk_widget_show(EditCompo);
      UpdateCircuitView(UCVModification);
      CircuitData->Info.NewModification = True;
    }
  if (IsAttachID(NewID))
    {
      AttachPoint AttachProp;
      Component CompProp;
      SubFunction SubFProp;
      GtkWidget *EditAttachPoint, *NameEntry, *XEntry, *YEntry, *IDLabel, *SpotTypeLabel, *Xmm_Label, *Xin_Label,
	*Ymm_Label, *Yin_Label;
      int x, y;

      EditAttachPoint = create_AttachEditWindow();

      GetAttachPointProperties(CircuitData, NewID, &AttachProp);
      GetComponentProperties(CircuitData, AttachProp.ComponentID, &CompProp, False);
      GetSubFunctionProperties(CircuitData, CompProp.SubFunctionID, &SubFProp);
      
      IDLabel = gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "IDLabel");
      sprintf(Buffer, "%d", NewID);
      gtk_label_set_text(GTK_LABEL(IDLabel), Buffer);
      
      SpotTypeLabel = gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "SpotTypeLabel");
      gtk_label_set_text(GTK_LABEL(SpotTypeLabel), AttachProp.SpotName);
         
      NameEntry = gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "NameEntry");
      gtk_entry_set_text(GTK_ENTRY(NameEntry), AttachProp.AttachPointName);

      XEntry = gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "XReferenceEntry");
      sprintf(Buffer,"%d", AttachProp.Reference.x);
      gtk_entry_set_text(GTK_ENTRY(XEntry), Buffer);

      YEntry = gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "YReferenceEntry");
      sprintf(Buffer,"%d", AttachProp.Reference.y);
      gtk_entry_set_text(GTK_ENTRY(YEntry), Buffer);
      
      x = SubFProp.Reference.x + CompProp.Reference.x + AttachProp.Reference.x;
      y = SubFProp.Reference.y + CompProp.Reference.y + AttachProp.Reference.y;
  
      Xmm_Label =  gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "XMillimeterLabel");
      sprintf(Buffer,"%6.2f",  SquareToMillimeter(x));
      gtk_label_set_text(GTK_LABEL(Xmm_Label), Buffer);
      
      Xin_Label =  gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "XInchLabel");
      sprintf(Buffer,"%6.2f",  SquareToInch(x));
      gtk_label_set_text(GTK_LABEL(Xin_Label), Buffer);
      
      Ymm_Label =  gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "YMillimeterLabel");
      sprintf(Buffer,"%6.2f",  SquareToMillimeter(y));
      gtk_label_set_text(GTK_LABEL(Ymm_Label), Buffer);
      
      Yin_Label =  gtk_object_get_data(GTK_OBJECT(EditAttachPoint), "YInchLabel");
      sprintf(Buffer,"%6.2f",  SquareToInch(y));
      gtk_label_set_text(GTK_LABEL(Yin_Label), Buffer);
 
      gtk_object_set_data( GTK_OBJECT(EditAttachPoint), ObjID, GINT_TO_POINTER(NewID));
      
      gtk_widget_show(EditAttachPoint);
    }
  if (IsSubFunctionID(NewID))
    {
      SubFunction SubFunctionProperties;
      GtkWidget *EditSubFunc, *NameEntry, *XEntry, *YEntry, *IDLabel;

      EditSubFunc = create_SubFunctionEditWindow();

      GetSubFunctionProperties(CircuitData, NewID, &SubFunctionProperties);

      IDLabel = gtk_object_get_data(GTK_OBJECT(EditSubFunc), "IDLabel");
      sprintf(Buffer, "%d", NewID);
      gtk_label_set_text(GTK_LABEL(IDLabel), Buffer);
      
      NameEntry = gtk_object_get_data(GTK_OBJECT(EditSubFunc), "NameEntry");
      gtk_entry_set_text(GTK_ENTRY(NameEntry),SubFunctionProperties.Name);

      XEntry = gtk_object_get_data(GTK_OBJECT(EditSubFunc), "XReferenceEntry");
      if (x == NoX)
	sprintf(Buffer,"%d", SubFunctionProperties.Reference.x);
      else
	sprintf(Buffer,"%d", x);
      gtk_entry_set_text(GTK_ENTRY(XEntry), Buffer);

      YEntry = gtk_object_get_data(GTK_OBJECT(EditSubFunc), "YReferenceEntry");
      if (y == NoY)
	sprintf(Buffer,"%d", SubFunctionProperties.Reference.y);
      else
	sprintf(Buffer,"%d", y);
      gtk_entry_set_text(GTK_ENTRY(YEntry), Buffer);

      gtk_object_set_data( GTK_OBJECT(EditSubFunc), ObjID, GINT_TO_POINTER(NewID));
      
      gtk_widget_show(EditSubFunc);
      UpdateCircuitView(UCVModification);
      CircuitData->Info.NewModification = True;
    }
}

void cb_SetCircuitProperty(GtkWidget *Button, GtkWidget *Window)
{
  char *Name, *Description, *Society, *Designer, *Version, *RevisionDate, *Buffer;
  int Width, Height, ArgNb;
  GtkWidget *Label, *TreeItem, *ProjectEntry, *DesignerEntry, *VersionEntry, *RevisionDateEntry, 
    *DescriptionEntry, *SocietyEntry, *WidthEntry, *HeightEntry;
  GCD *CircuitData;
  Header DataHeader;

  CircuitData = GetCircuitData();

  ProjectEntry = gtk_object_get_data(GTK_OBJECT(Window), "ProjectEntry");
  DesignerEntry = gtk_object_get_data(GTK_OBJECT(Window), "DesignerEntry");
  DescriptionEntry = gtk_object_get_data(GTK_OBJECT(Window), "DescriptionEntry");
  SocietyEntry = gtk_object_get_data(GTK_OBJECT(Window), "SocietyEntry");
  VersionEntry = gtk_object_get_data(GTK_OBJECT(Window), "VersionEntry");
  RevisionDateEntry = gtk_object_get_data(GTK_OBJECT(Window),"DateEntry");
  WidthEntry = gtk_object_get_data(GTK_OBJECT(Window),"SizeXEntry");
  HeightEntry = gtk_object_get_data(GTK_OBJECT(Window),"SizeYEntry");

  Name = gtk_entry_get_text(GTK_ENTRY(ProjectEntry));
  Designer = gtk_entry_get_text(GTK_ENTRY(DesignerEntry));
  Description = gtk_entry_get_text(GTK_ENTRY(DescriptionEntry));
  Society = gtk_entry_get_text(GTK_ENTRY( SocietyEntry));
  Version = gtk_entry_get_text(GTK_ENTRY( VersionEntry));
  RevisionDate = gtk_entry_get_text(GTK_ENTRY( RevisionDateEntry));
  
  Buffer = gtk_entry_get_text(GTK_ENTRY( WidthEntry));
  ArgNb = sscanf(Buffer,"%d", &Width);
  if (ArgNb != 1)
    {
      printf("Error in Width Entry\nLeaving Unchanged\n");
      Width = NoX;
    }

  Buffer = gtk_entry_get_text(GTK_ENTRY( HeightEntry));
  ArgNb = sscanf(Buffer,"%d", &Height);
  if (ArgNb != 1)
    {
      printf("Error in Height Entry\nLeaving Unchanged\n");
      Height = NoY;
    }
 
  TreeItem = CircuitData->Info.CTRootItem;
  Label = gtk_object_get_data( GTK_OBJECT(TreeItem), "Label");
  gtk_label_set_text( GTK_LABEL(Label), Name);

  if (Width != NoX)
    DataHeader.Width = Width;
  if (Height != NoY)
    DataHeader.Height = Height;

  strncpy( DataHeader.Name, Name, NameLength);
  strncpy( DataHeader.Version, Version, VersionLength);
  strncpy( DataHeader.Designer, Designer, DesignerLength);
  strncpy( DataHeader.Description, Description, DescriptionLength);
  strncpy( DataHeader.Society, Society, SocietyLength);
  strncpy( DataHeader.RevisionDate, RevisionDate, RevisionDateLength);

  DataHeader.Name[NameLength-1] = '\0';
  DataHeader.Version[ VersionLength-1] = '\0';
  DataHeader.Designer[ DesignerLength-1] = '\0';
  DataHeader.Description[DescriptionLength-1] = '\0';
  DataHeader.Society[SocietyLength-1] = '\0';
  DataHeader.RevisionDate[RevisionDateLength-1] = '\0';

  EditCircuitInfo(CircuitData, DataHeader);
  UpdateCircuitView(UCVModification);
  CircuitData->Info.NewModification = True;
}

void cb_SetSubFunctionProperty(GtkWidget *Button, GtkWidget *Window)
{
  SubFunction SF;
  GCD *CircuitData;
  GtkWidget *NameEntry, *XEntry, *YEntry,*Label, *TreeItem;
  char *Name, *Buffer;
  int x, y, ArgNb, ID;

  CircuitData = GetCircuitData();

  NameEntry = gtk_object_get_data(GTK_OBJECT(Window), "NameEntry");
  Name = gtk_entry_get_text(GTK_ENTRY(NameEntry)); 

  XEntry = gtk_object_get_data(GTK_OBJECT(Window), "XReferenceEntry");
  Buffer = gtk_entry_get_text(GTK_ENTRY(XEntry)); 
  ArgNb = sscanf(Buffer,"%d", &x);
  if (ArgNb != 1)
    {
      printf("Error in X Reference Entry\nLeaving Unchanged\n");
      x = NoX;
    }

  YEntry = gtk_object_get_data(GTK_OBJECT(Window), "YReferenceEntry");
  Buffer = gtk_entry_get_text(GTK_ENTRY(YEntry)); 
  ArgNb = sscanf(Buffer,"%d", &y);
  if (ArgNb != 1)
    {
      printf("Error in Y Reference Entry\nLeaving Unchanged\n");
      y = NoY;
    }

  ID =  GPOINTER_TO_INT( gtk_object_get_data( GTK_OBJECT(Window), ObjID) );
  GetIIDForSubFunction(CircuitData, ID, (void **)&TreeItem);
  
  Label = gtk_object_get_data( GTK_OBJECT(TreeItem), "Label");
  gtk_label_set_text( GTK_LABEL(Label), Name);

  GetSubFunctionProperties(CircuitData, ID, &SF);
  strncpy(SF.Name, Name, SubFunctionNameLength);
  SF.Name[SubFunctionNameLength-1] = '\0';
  if (x != NoX)
    SF.Reference.x = x;
  if (y != NoY)
    SF.Reference.y = y;

  EditSubFunction(CircuitData, ID, SF);
  UpdateLLClist();
  UpdateDLClist();
  UpdateCircuitView(UCVModification);
  CircuitData->Info.NewModification = True;
}

void cb_SetComponentProperty(GtkWidget *Button, GtkWidget *Window)
{
  GtkWidget *TreeItem, *Label, *NameEntry, *XEntry, *YEntry, *DescNameEntry, *DescClassEntry, 
    *LayoutNameEntry, *LayoutClassEntry, *ErrorWindow, *BetweenPinsCheck, *CompoInCheck, *CompoOutCheck,
    *LeftRadio, *RightRadio, *TopRadio, *BottomRadio;
  int x,y, ID, ArgNb;
  GCD *CircuitData;
  Component Comp;
  ErrorCheck Check;
  char *Buffer, *Name, *DescName, *DescClass, *LayoutName, *LayoutClass;

  CircuitData = GetCircuitData();
 
  LeftRadio = gtk_object_get_data(GTK_OBJECT(Window), "LeftRadio");
  RightRadio = gtk_object_get_data(GTK_OBJECT(Window), "RightRadio");
  TopRadio = gtk_object_get_data(GTK_OBJECT(Window), "TopRadio");
  BottomRadio = gtk_object_get_data(GTK_OBJECT(Window), "BottomRadio");
  BetweenPinsCheck = gtk_object_get_data(GTK_OBJECT(Window), "BetweenPinsCheck");
  CompoInCheck = gtk_object_get_data(GTK_OBJECT(Window), "CompoInCheck");
  CompoOutCheck = gtk_object_get_data(GTK_OBJECT(Window), "CompoOutCheck");
      
  NameEntry = gtk_object_get_data(GTK_OBJECT(Window), "NameEntry");
  Name = gtk_entry_get_text(GTK_ENTRY( NameEntry));
  
  DescNameEntry = gtk_object_get_data(GTK_OBJECT(Window), "DescriptionEntry");
  DescName = gtk_entry_get_text(GTK_ENTRY( DescNameEntry));

  DescClassEntry = gtk_object_get_data(GTK_OBJECT(Window), "DescriptionClassEntry");
  DescClass = gtk_entry_get_text(GTK_ENTRY( DescClassEntry));
  
  LayoutNameEntry = gtk_object_get_data(GTK_OBJECT(Window), "LayoutEntry");
  LayoutName = gtk_entry_get_text(GTK_ENTRY( LayoutNameEntry));
  
  LayoutClassEntry = gtk_object_get_data(GTK_OBJECT(Window), "LayoutClassEntry");
  LayoutClass = gtk_entry_get_text(GTK_ENTRY( LayoutClassEntry));
  
  XEntry  =  gtk_object_get_data(GTK_OBJECT(Window), "XPositionEntry");
  Buffer = gtk_entry_get_text(GTK_ENTRY( XEntry));
  
  ArgNb = sscanf(Buffer,"%d", &x);
  if (ArgNb != 1) /* un element affecte */
    {
      printf("Error in X Position Entry\nLeaving Unchanged\n");
      x = NoX;
    }

  YEntry  =  gtk_object_get_data(GTK_OBJECT(Window), "YPositionEntry");
  Buffer = gtk_entry_get_text(GTK_ENTRY( YEntry));
  ArgNb = sscanf(Buffer,"%d", &y);
  if (ArgNb != 1) /* un element affecte */
    {
      printf("Error in Y Position Entry\nLeaving Unchanged\n");
      y = NoY;
    }
  ID = GPOINTER_TO_INT( gtk_object_get_data( GTK_OBJECT(Window), ObjID));
  GetIIDForComponent(CircuitData, ID, (void **) &TreeItem);

  Label = gtk_object_get_data( GTK_OBJECT(TreeItem), "Label");
  gtk_label_set_text( GTK_LABEL(Label), Name);

  GetComponentProperties(CircuitData, ID, &Comp, False);
  strncpy(Comp.ComponentName, Name, ComponentNameLength);
  Comp.ComponentName[ComponentNameLength-1] = '\0';

  strncpy(Comp.CompDescName, DescName, CompDescNameLength);
  Comp.CompDescName[CompDescNameLength-1] ='\0';

  strncpy(Comp.LayoutName, LayoutName, LayoutNameLength);
  Comp.LayoutName[LayoutNameLength-1] ='\0';
  strncpy(Comp.LayoutClass, LayoutClass, LayoutClassLength);
  Comp.LayoutClass[LayoutClassLength-1] ='\0';
  
  if (x != NoX) 
    Comp.Reference.x = x;
  if (y != NoY)
    Comp.Reference.y = y;
    
  InitState(Comp.State);
  if (GTK_TOGGLE_BUTTON(TopRadio)->active)
    SetComponentToTop(Comp.State);
  if (GTK_TOGGLE_BUTTON(BottomRadio)->active)
    SetComponentToBottom(Comp.State);
  if (GTK_TOGGLE_BUTTON(LeftRadio)->active)
    SetComponentToLeft(Comp.State);
  if (GTK_TOGGLE_BUTTON(RightRadio)->active)
    SetComponentToRight(Comp.State);

  if (GTK_TOGGLE_BUTTON(BetweenPinsCheck)->active)
    SetComponentBetweenPins(Comp.State);
  if (GTK_TOGGLE_BUTTON(CompoInCheck)->active)
    SetComponentCompoIn(Comp.State);
  if (GTK_TOGGLE_BUTTON(CompoOutCheck)->active)
    SetComponentCompoOut(Comp.State);

  printf("EditWindow component %s %s %s \n", Comp.CompDescName, Comp.LayoutName, Comp.LayoutClass);
  Check = EditComponent ( CircuitData, ID,  Comp, True); 
  if (Check == ArgumentError)
    {
      UpdateLLClist();
      UpdateDLClist();
      UpdateCircuitView(UCVModification);
      ErrorWindow = create_NotEnoughPin();
      gtk_widget_show(ErrorWindow);
      return;
    }
  if (Check == Forbidden)
    {
      UpdateLLClist();
      UpdateDLClist();
      UpdateCircuitView(UCVModification);
      ErrorWindow = create_EditionForbidden();
      gtk_widget_show(ErrorWindow);
      return;
    }
  
  AddAttachPointUnderComponent(ID);              /* cree les points d attaches dans l interface */
  UpdateLLClist();
  UpdateDLClist();
  UpdateCircuitView(UCVModification);
  CircuitData->Info.NewModification = True;
}

void cb_ChooseDescription (GtkButton *button, GtkWidget *CEWindow)
{
  GtkWidget *ChooseDescWindow, *DescriptionEntry, *DescriptionClassEntry, *DescClassList, 
    *LayoutEntry, *LayoutClassEntry;
  int ClassTabSize, Counter, NewRow;
  char **ClassTab;
  gchar *NewDescClass[1] = {"Default"} ;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  
  ChooseDescWindow = create_ChooseDescriptionWindow();
  
  DescriptionEntry = gtk_object_get_data(GTK_OBJECT(CEWindow),"DescriptionEntry");
  DescriptionClassEntry = gtk_object_get_data(GTK_OBJECT(CEWindow),"DescriptionClassEntry");
  LayoutEntry = gtk_object_get_data(GTK_OBJECT(CEWindow),"LayoutEntry");
  LayoutClassEntry = gtk_object_get_data(GTK_OBJECT(CEWindow),"LayoutClassEntry");

  if ( (DescriptionEntry == NULL) || (DescriptionClassEntry == NULL))
    printf("GetData Return NULL Pointer ");
  
  gtk_object_set_data(GTK_OBJECT(ChooseDescWindow), "DescriptionEntry", DescriptionEntry);
  gtk_object_set_data(GTK_OBJECT(ChooseDescWindow), "DescriptionClassEntry", DescriptionClassEntry);
  gtk_object_set_data(GTK_OBJECT(ChooseDescWindow), "LayoutEntry", LayoutEntry);
  gtk_object_set_data(GTK_OBJECT(ChooseDescWindow), "LayoutClassEntry", LayoutClassEntry);

  DescClassList = gtk_object_get_data(GTK_OBJECT(ChooseDescWindow),"DescriptionClassList");

  /* on cree la class liste */
  GetCompDescClassNumber(CircuitData->CompLib, &ClassTabSize);
  if (ClassTabSize == 0)
    printf("No Class Found... Errors may occur!!! -> it should not happen!\n");
  
  ClassTab = (char **) malloc(sizeof(char *) * ClassTabSize);
  for (Counter = 0 ; Counter < ClassTabSize ; Counter++)
    ClassTab[Counter] = (char *) malloc(sizeof(char) * CompDescClassLength);
  
  GetCompDescClassTab(CircuitData->CompLib, ClassTab);

  gtk_clist_freeze( GTK_CLIST( DescClassList));
  gtk_clist_clear( GTK_CLIST( DescClassList));
  for (Counter = 0 ; Counter < ClassTabSize ; Counter++)
    {
      NewDescClass[0] = ClassTab[Counter];
      NewRow = gtk_clist_append( GTK_CLIST(DescClassList), NewDescClass); 
      if (Counter == 0)
	gtk_clist_select_row(GTK_CLIST(DescClassList), 0, 0);
    }
  
  gtk_clist_thaw( GTK_CLIST(DescClassList));
  gtk_widget_show(ChooseDescWindow);
  
  for (Counter = 0 ; Counter < ClassTabSize ; Counter++)
    free( ClassTab[Counter] );
  free(ClassTab);
}

void cb_SetDescription (GtkButton *button, GtkWidget *CDWindow)     
{
  GtkWidget *DescList, *DescClassList, *DescEntry, *DescClassEntry, *LayoutEntry, *LayoutClassEntry;
  char *DescName, *DescClass;
  int Row;
  CompDescDef CompDescProp;
  LayoutDef LayoutProp;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  DescList = gtk_object_get_data(GTK_OBJECT(CDWindow), "DescriptionList");
  Row = gtk_clist_find_row_from_data( GTK_CLIST(DescList), GINT_TO_POINTER(DescSelected));
  gtk_clist_get_text(GTK_CLIST(DescList), Row, 0, &DescName);

  DescClassList = gtk_object_get_data(GTK_OBJECT(CDWindow), "DescriptionClassList");
  Row = gtk_clist_find_row_from_data( GTK_CLIST(DescClassList), GINT_TO_POINTER(DescClassSelected));
  gtk_clist_get_text(GTK_CLIST(DescClassList), Row, 0, &DescClass);
  
  GetCompDescProperties(CircuitData->CompLib, DescName, &CompDescProp, False);
  GetLayoutProperties(CircuitData->CompLib, CompDescProp.LayoutName,CompDescProp.LayoutClass, &LayoutProp, False, False);
  
  DescEntry = gtk_object_get_data(GTK_OBJECT(CDWindow), "DescriptionEntry");
  gtk_entry_set_text(GTK_ENTRY(DescEntry), DescName);

  DescClassEntry = gtk_object_get_data(GTK_OBJECT(CDWindow), "DescriptionClassEntry");
  gtk_entry_set_text(GTK_ENTRY(DescClassEntry), DescClass);

  LayoutEntry = gtk_object_get_data(GTK_OBJECT(CDWindow), "LayoutEntry");
  gtk_entry_set_text(GTK_ENTRY(LayoutEntry), LayoutProp.LayoutName);

  LayoutClassEntry = gtk_object_get_data(GTK_OBJECT(CDWindow), "LayoutClassEntry");
  gtk_entry_set_text(GTK_ENTRY(LayoutClassEntry), LayoutProp.LayoutClass);
  CircuitData->Info.NewModification = True;
}

void on_DescriptionClassList_select_row (GtkCList *DescClassList, gint row, gint column, GdkEvent *event, GtkWidget *CDWindow)
{
  GtkWidget *DescList;
  int Counter, DescTabSize, NewRow;
  char **DescTab, *ClassName;
  GCD *CircuitData;
  gchar *NewDesc[1]= {"Default Patin"};
  
  CircuitData = GetCircuitData();
  gtk_clist_set_row_data( GTK_CLIST(DescClassList), row, GINT_TO_POINTER( DescClassSelected));
  gtk_clist_get_text( GTK_CLIST(DescClassList), row, 0, &ClassName);

  /* on cree la liste */
  GetCompDescNumber(CircuitData->CompLib, ClassName, &DescTabSize);
  if (DescTabSize == 0)
    printf("Empty  Class Found... Errors may occur!!! --> empty class cannot exist!!!\n");

  
  DescTab = (char **) malloc(sizeof(char *) * DescTabSize);
  for (Counter = 0 ; Counter < DescTabSize ; Counter++)
    DescTab[Counter] = (char *) malloc(sizeof(char) * CompDescNameLength);
  
  GetCompDescTab(CircuitData->CompLib, ClassName, DescTab);
  
  DescList = gtk_object_get_data(GTK_OBJECT(CDWindow), "DescriptionList");
  if (DescList == NULL)
    printf("GetData Return NULL Pointer ");
  
  gtk_clist_freeze( GTK_CLIST( DescList));
  gtk_clist_clear( GTK_CLIST( DescList));
  
  for (Counter = 0 ; Counter < DescTabSize ; Counter++)
    {
      NewDesc[0] = DescTab[Counter];
      NewRow = gtk_clist_append( GTK_CLIST(DescList), NewDesc); 
    }
  
  gtk_clist_thaw( GTK_CLIST(DescList));
  for (Counter = 0 ; Counter < DescTabSize ; Counter++)
    free( DescTab[Counter] );
  free(DescTab);
}

void on_DescriptionClassList_unselect_row(GtkCList *DescClassList, gint row, gint column, GdkEvent *event, GtkWidget *CDWindow)
{
  GtkWidget *DescList;

  gtk_clist_set_row_data( GTK_CLIST(DescClassList), row, GINT_TO_POINTER( DescClassUnSelected));
  DescList = gtk_object_get_data(GTK_OBJECT(CDWindow), "DescriptionList");
  
  gtk_clist_clear( GTK_CLIST( DescList));
}

void on_DescriptionList_select_row(GtkCList *DescList, gint row, gint column, GdkEvent *event, gpointer CDWindow)
{
  GtkWidget *DescClassList, *LayoutInfoEntry, *LayoutClassInfoEntry;
  char *DescName, *DescClass;
  int ClassRow;
  CompDescDef CompDescProp;
  LayoutDef LayoutProp;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();

  gtk_clist_set_row_data( GTK_CLIST(DescList), row, GINT_TO_POINTER( DescSelected));
  gtk_clist_get_text(GTK_CLIST(DescList), row, 0, &DescName);
  
  DescClassList = gtk_object_get_data(GTK_OBJECT(CDWindow), "DescriptionClassList");
  ClassRow = gtk_clist_find_row_from_data( GTK_CLIST(DescClassList), GINT_TO_POINTER(DescClassSelected));
  gtk_clist_get_text(GTK_CLIST(DescClassList), ClassRow, 0, &DescClass);
  
  GetCompDescProperties(CircuitData->CompLib, DescName, &CompDescProp, False);
  GetLayoutProperties(CircuitData->CompLib, CompDescProp.LayoutName,CompDescProp.LayoutClass, &LayoutProp, False, False);
  
  LayoutInfoEntry = gtk_object_get_data(GTK_OBJECT(CDWindow), "LayoutInfoEntry");
  gtk_entry_set_text(GTK_ENTRY(LayoutInfoEntry), LayoutProp.LayoutName);

  LayoutClassInfoEntry = gtk_object_get_data(GTK_OBJECT(CDWindow), "LayoutClassInfoEntry");
  gtk_entry_set_text(GTK_ENTRY(LayoutClassInfoEntry), LayoutProp.LayoutClass);
}


void on_DescriptionList_unselect_row(GtkCList *DescList, gint row, gint column, GdkEvent *event, gpointer user_data)
{
  gtk_clist_set_row_data( GTK_CLIST(DescList), row, GINT_TO_POINTER( DescUnSelected));
}

void cb_EditPreferences (GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget *EditPrefs, *ProjectEntry, *DesignerEntry, *VersionEntry, *DateEntry, *SocietyEntry, 
    *DescriptionEntry, *WidthEntry, *HeightEntry, *CompColor, *CompColorU, 
    *SpotColorU, *SpotColor, *CoreSpotColor, *CoreSpotColorU, *InvisibleSpotColorU, *InvisibleSpotColor,
    *BetweenPinsColor, *BetweenPinsColorU, *CompoInColorU, *CompoInColor, *CompoOutColorU, *CompoOutColor,
    *SubFColor, *SubFColorU, *LinkColor, *LinkColorU,  *AlternateColor, *ScaleSpin, *ContinuallyRadio, 
    *ClickedRadio,    *DemandRadio, *CircuitDirectoryEntry,
    *AllowEditComponent, *AllowDeleteComponent, *AllowDeleteSubFunction,
    *DefaultSubFunctionName, *DefaultComponentName,
    *LinkColorDefault, *NoLinkIcon, *NoLinkColor, *ShortRadio, *LongRadio, *IndifferentLengthRadio,
    *ThinRadio, *LargeRadio, *IndifferentWidthRadio, *WidthFirstCheck, 
    *MillimeterCheck, *SwapMax, *RoutingMax, *UseMagic,
    *OpenInformation, *RevertInformation, *SaveInformation,
    *LogFileEntry, *LogToFileCheck, *UnRoutableDeleteCheck, *UnRoutableSwapMax, *FirstRadio[3],
    *SecondRadio[3], *ThirdRadio[3], *SelectionFollowCheck;
  char Buffer[BufferLength];
  float SpinValue;
  DirectionPref DirPref;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  EditPrefs = create_PreferencesWindow();
  DesignerEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "DesignerEntry");
  SocietyEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SocietyEntry");
  ProjectEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ProjectEntry");
  VersionEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "VersionEntry");
  DescriptionEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "DescriptionEntry");
  DateEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "DateEntry");
  WidthEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SizeXEntry");
  HeightEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SizeYEntry");
  
  gtk_entry_set_text(GTK_ENTRY(ProjectEntry),  CircuitData->Info.Opt.DataHeader.Name);
  gtk_entry_set_text(GTK_ENTRY(DesignerEntry),  CircuitData->Info.Opt.DataHeader.Designer);
  gtk_entry_set_text(GTK_ENTRY(SocietyEntry),  CircuitData->Info.Opt.DataHeader.Society);
  gtk_entry_set_text(GTK_ENTRY(DescriptionEntry),  CircuitData->Info.Opt.DataHeader.Description);
  gtk_entry_set_text(GTK_ENTRY(VersionEntry),  CircuitData->Info.Opt.DataHeader.Version);
  gtk_entry_set_text(GTK_ENTRY(DateEntry),  CircuitData->Info.Opt.DataHeader.RevisionDate);
  sprintf(Buffer,"%d", CircuitData->Info.Opt.DataHeader.Height);
  gtk_entry_set_text(GTK_ENTRY(HeightEntry), Buffer);
  sprintf(Buffer,"%d", CircuitData->Info.Opt.DataHeader.Width);
  gtk_entry_set_text(GTK_ENTRY(WidthEntry), Buffer);
  printf("5\n");

  CompColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ComponentColor");
  CompColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ComponentColorU");
  SubFColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SubFunctionColor");
  SubFColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SubFunctionColorU");
  LinkColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LinkColor");
  LinkColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LinkColorU");
  LinkColorDefault = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LinkDefaultColor");
  AlternateColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "AlternateColor");
  SpotColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SpotColor");
  SpotColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SpotColorU");
  CoreSpotColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CoreSpotColor");
  CoreSpotColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CoreSpotColorU");
  InvisibleSpotColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "InvisibleSpotColor");
  InvisibleSpotColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "InvisibleSpotColorU");
  BetweenPinsColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "BetweenPinsColor");
  BetweenPinsColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "BetweenPinsColorU");
  CompoInColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoInColor");
  CompoInColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoInColorU");
  CompoOutColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoOutColor");
  CompoOutColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoOutColorU");
  printf("5\n");
  
  AllowEditComponent =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "AllowEditComponent");
  AllowDeleteComponent =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "AllowDeleteComponent");
  AllowDeleteSubFunction =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "AllowDeleteSubFunction");
  DefaultSubFunctionName =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "DefaultSubFunctionName");
  DefaultComponentName =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "DefaultComponentName");
  OpenInformation =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "OpenInformation");
  RevertInformation =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "RevertInformation");
  SaveInformation =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "SaveInformation");
  CircuitDirectoryEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CircuitDirectoryEntry");
  printf("5\n");
  
  ContinuallyRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ContinuallyRadio");
  ClickedRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ClickedRadio");
  DemandRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "DemandRadio");
  ScaleSpin = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ScaleSpin");
  NoLinkIcon =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "NoLinkIcon");
  NoLinkColor =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "NoLinkColor");
  ShortRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ShortRadio");
  LongRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "LongRadio");
  IndifferentLengthRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "IndifferentLengthRadio");
  ThinRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThinRadio");
  LargeRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "LargeRadio");
  IndifferentWidthRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "IndifferentWidthRadio");
  WidthFirstCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "WidthFirstCheck");
  printf("5\n");

  MillimeterCheck  = gtk_object_get_data(GTK_OBJECT(EditPrefs), "MillimeterCheck");
  SwapMax  = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SwapMax");
  RoutingMax  = gtk_object_get_data(GTK_OBJECT(EditPrefs), "RoutingMax");
  LogFileEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LogFileEntry");
  LogToFileCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LogToFileCheck");
  UnRoutableDeleteCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UnRoutableDeleteCheck");
  UnRoutableSwapMax = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UnRoutableSwapMax");
  SelectionFollowCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SelectionFollowCheck");
  UseMagic = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UseMagic");
  printf("5\n");
  FirstRadio[0] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "FirstHVRadio");
  FirstRadio[1] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "FirstDRadio");
  FirstRadio[2] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "FirstPRadio");

  SecondRadio[0] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SecondHVRadio");
  SecondRadio[1] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SecondDRadio");
  SecondRadio[2] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SecondPRadio");

  ThirdRadio[0] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThirdHVRadio");
  ThirdRadio[1] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThirdDRadio");
  ThirdRadio[2] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThirdPRadio");

  SetColor(CompColor, CircuitData->Info.Opt.ColorPalette[ComponentPalette]);
  SetColor(CompColorU, CircuitData->Info.Opt.ColorPalette[ComponentUnSelectedPalette]);
  SetColor(SubFColor, CircuitData->Info.Opt.ColorPalette[SubFunctionPalette]);
  SetColor(SubFColorU, CircuitData->Info.Opt.ColorPalette[SubFunctionUnSelectedPalette]);
  SetColor(LinkColor, CircuitData->Info.Opt.ColorPalette[LinkPalette]);
  SetColor(LinkColorU, CircuitData->Info.Opt.ColorPalette[LinkUnSelectedPalette]);

  SetColor(LinkColorDefault, CircuitData->Info.Opt.ColorPalette[LinkDefaultPalette]);
  SetColor(AlternateColor, CircuitData->Info.Opt.ColorPalette[AlternatePalette]);

  SetColor(SpotColor, CircuitData->Info.Opt.ColorPalette[SpotPalette]);
  SetColor(SpotColorU, CircuitData->Info.Opt.ColorPalette[SpotUnSelectedPalette]);
  SetColor(CoreSpotColor, CircuitData->Info.Opt.ColorPalette[CoreSpotPalette]);
  SetColor(CoreSpotColorU, CircuitData->Info.Opt.ColorPalette[CoreSpotUnSelectedPalette]);
  SetColor(InvisibleSpotColor, CircuitData->Info.Opt.ColorPalette[InvisibleSpotPalette]);
  SetColor(InvisibleSpotColorU, CircuitData->Info.Opt.ColorPalette[InvisibleSpotUnSelectedPalette]);
  SetColor(BetweenPinsColor, CircuitData->Info.Opt.ColorPalette[BetweenPinsPalette]);
  SetColor(BetweenPinsColorU, CircuitData->Info.Opt.ColorPalette[BetweenPinsUnSelectedPalette]);
  SetColor(CompoInColor, CircuitData->Info.Opt.ColorPalette[CompoInPalette]);
  SetColor(CompoInColorU, CircuitData->Info.Opt.ColorPalette[CompoInUnSelectedPalette]);
  SetColor(CompoOutColor, CircuitData->Info.Opt.ColorPalette[CompoOutPalette]);
  SetColor(CompoOutColorU, CircuitData->Info.Opt.ColorPalette[CompoOutUnSelectedPalette]);
 
  if (CircuitData->Info.Opt.AllowEditComponent == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(AllowEditComponent), TRUE);
  if (CircuitData->Info.Opt.AllowDeleteComponent == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(AllowDeleteComponent), TRUE);
  if (CircuitData->Info.Opt.AllowDeleteSubFunction == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(AllowDeleteSubFunction), TRUE);
  printf("6\n");
  gtk_entry_set_text(GTK_ENTRY(DefaultSubFunctionName), CircuitData->Info.Opt.DefaultSubFunctionName);
  gtk_entry_set_text(GTK_ENTRY(DefaultComponentName), CircuitData->Info.Opt.DefaultComponentName);

  if (CircuitData->Info.Opt.OpenInformation == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(OpenInformation), TRUE);
  if (CircuitData->Info.Opt.RevertInformation == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(RevertInformation), TRUE);
  if (CircuitData->Info.Opt.SaveInformation == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(SaveInformation), TRUE);
  printf("6\n");

  gtk_entry_set_text(GTK_ENTRY(CircuitDirectoryEntry), CircuitData->Info.Opt.CircuitDirectory);

  if (CircuitData->Info.Opt.UpdateDemand == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(DemandRadio), TRUE);

  if (CircuitData->Info.Opt.UpdateClicked == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(ClickedRadio), TRUE);

  if (CircuitData->Info.Opt.UpdateContinually == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(ContinuallyRadio), TRUE);
  printf("6\n");

 if (CircuitData->Info.Opt.SelectionFollowMouse == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(SelectionFollowCheck), TRUE);

  if (CircuitData->Info.Opt.NoLinkIcon == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(NoLinkIcon), TRUE);

  if (CircuitData->Info.Opt.NoLinkColor == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(NoLinkColor), TRUE);
  printf("6\n");

  if (CircuitData->Info.Opt.LengthOrder == AscendantOrder)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(ShortRadio), TRUE);
  if (CircuitData->Info.Opt.LengthOrder == DescendantOrder)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(LongRadio), TRUE);
  if (CircuitData->Info.Opt.LengthOrder == IndifferentOrder)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(IndifferentLengthRadio), TRUE);
  printf("6\n");

  if (CircuitData->Info.Opt.WidthOrder == AscendantOrder)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(ThinRadio), TRUE);
  if (CircuitData->Info.Opt.WidthOrder == DescendantOrder)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(LargeRadio), TRUE);
  if (CircuitData->Info.Opt.WidthOrder == IndifferentOrder)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(IndifferentWidthRadio), TRUE);

  printf("6\n");
  if (CircuitData->Info.Opt.SortWidthFirst == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(WidthFirstCheck), TRUE);

  if (CircuitData->Info.Opt.Millimeter == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(MillimeterCheck), TRUE);

  SpinValue = CircuitData->Info.Opt.ScaleFactor;
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(ScaleSpin), SpinValue);

  SpinValue = CircuitData->Info.Opt.SwapMax;
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(SwapMax), SpinValue);

  SpinValue = CircuitData->Info.Opt.RoutingMax;
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(RoutingMax), SpinValue);
   printf("6\n");
 
  if (CircuitData->Info.Opt.LogToFile == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(LogToFileCheck), TRUE);

  gtk_entry_set_text(GTK_ENTRY(LogFileEntry), CircuitData->Info.Opt.LogFileName);

  SpinValue = CircuitData->Info.Opt.UnRoutableSwapMax;
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(UnRoutableSwapMax), SpinValue);

  if (CircuitData->Info.Opt.UnRoutableDelete == True)
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(UnRoutableDeleteCheck), TRUE);

  if (CircuitData->Info.Opt.UseMagic == True)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(UseMagic), TRUE);
  
  DirPref = CircuitData->Info.Opt.DirectionPrefTab[0];
  printf("DirPrefs %d\n", DirPref);
  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(FirstRadio[DirPref]), TRUE);
  DirPref = CircuitData->Info.Opt.DirectionPrefTab[1];
  printf("DirPrefs %d\n", DirPref);
  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(SecondRadio[DirPref]), TRUE);
  DirPref = CircuitData->Info.Opt.DirectionPrefTab[2];
  printf("DirPrefs %d\n", DirPref);
  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(ThirdRadio[DirPref]), TRUE);
  printf("6\n");

  gtk_widget_show(EditPrefs);
}

void cb_SetPreferences (GtkButton *button, GtkWidget *EditPrefs)
{
  GtkWidget *ProjectEntry, *DesignerEntry, *VersionEntry, *DateEntry, *SocietyEntry, 
    *DescriptionEntry, *WidthEntry, *HeightEntry, *CompColor, *CompColorU, 
    *SubFColor, *SubFColorU, *LinkColor, *LinkColorU, *ScaleSpin, *ContinuallyRadio, *ClickedRadio, *DemandRadio,
    *SpotColorU, *SpotColor, *CoreSpotColor, *CoreSpotColorU, *InvisibleSpotColorU, *InvisibleSpotColor,
    *BetweenPinsColor, *BetweenPinsColorU, *CompoInColorU, *CompoInColor, *CompoOutColorU, *CompoOutColor,
    *AllowEditComponent, *AllowDeleteComponent, *AllowDeleteSubFunction,
    *DefaultSubFunctionName, *DefaultComponentName, *OpenInformation, *RevertInformation, *SaveInformation,
    *LinkColorDefault, *AlternateColor, *CircuitDirectoryEntry,
    *NoLinkIcon,  *NoLinkColor, *ShortRadio, *LongRadio, *IndifferentLengthRadio,
    *ThinRadio, *LargeRadio, *IndifferentWidthRadio, *WidthFirstCheck, *MillimeterCheck, *SwapMax, *RoutingMax,
    *LogToFileCheck, *LogFileEntry, *UnRoutableDeleteCheck, *UnRoutableSwapMax, *UseMagic, *FirstRadio[3],
    *SecondRadio[3], *ThirdRadio[3], *SelectionFollowCheck;
  DirectionPref FirstPref = NoDirection, SecondPref = NoDirection, ThirdPref = NoDirection;
  char *Name, *Description, *Society, *Designer, *Version, *Buffer, *Date;
  int Width, Height, ArgNb, Counter;
  guint8  Dummy;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  ProjectEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ProjectEntry");
  DesignerEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "DesignerEntry");
  DescriptionEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "DescriptionEntry");
  SocietyEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SocietyEntry");
  VersionEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "VersionEntry");
  DateEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs),"DateEntry");
  WidthEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs),"SizeXEntry");
  HeightEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs),"SizeYEntry");

  Name = gtk_entry_get_text(GTK_ENTRY(ProjectEntry));
  Designer = gtk_entry_get_text(GTK_ENTRY(DesignerEntry));
  Society = gtk_entry_get_text(GTK_ENTRY( SocietyEntry));
  Description = gtk_entry_get_text(GTK_ENTRY( DescriptionEntry));
  Version = gtk_entry_get_text(GTK_ENTRY( VersionEntry));
  Date = gtk_entry_get_text(GTK_ENTRY( DateEntry));
  
  Buffer = gtk_entry_get_text(GTK_ENTRY( WidthEntry));
  ArgNb = sscanf(Buffer,"%d", &Width);
  if (ArgNb != 1)
    {
      printf("Error in Width Entry\nLeaving Unchanged\n");
      Width = NoX;
    }

  Buffer = gtk_entry_get_text(GTK_ENTRY( HeightEntry));
  ArgNb = sscanf(Buffer,"%d", &Height);
  if (ArgNb != 1)
    {
      printf("Error in Height Entry\nLeaving Unchanged\n");
      Height = NoY;
    }
  strncpy( CircuitData->Info.Opt.DataHeader.Name, Name, NameLength);
  strncpy( CircuitData->Info.Opt.DataHeader.Version, Version, VersionLength);
  strncpy( CircuitData->Info.Opt.DataHeader.Designer, Designer, DesignerLength);
  strncpy( CircuitData->Info.Opt.DataHeader.Description, Description, DescriptionLength);
  strncpy( CircuitData->Info.Opt.DataHeader.Society, Society, SocietyLength);
  strncpy( CircuitData->Info.Opt.DataHeader.RevisionDate, Date, RevisionDateLength);
  
  CircuitData->Info.Opt.DataHeader.Name[NameLength-1] = '\0';
  CircuitData->Info.Opt.DataHeader.Version[ VersionLength-1] = '\0';
  CircuitData->Info.Opt.DataHeader.Designer[ DesignerLength-1] = '\0';
  CircuitData->Info.Opt.DataHeader.Description[DescriptionLength-1] = '\0';
  CircuitData->Info.Opt.DataHeader.Society[SocietyLength-1] = '\0';
  CircuitData->Info.Opt.DataHeader.RevisionDate[RevisionDateLength-1] = '\0'; 
  
  if (Width != NoX)
    CircuitData->Info.Opt.DataHeader.Width = Width;
  if (Height != NoY)
    CircuitData->Info.Opt.DataHeader.Height = Height;
  
  CompColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ComponentColor");
  CompColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ComponentColorU");
  SubFColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SubFunctionColor");
  SubFColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SubFunctionColorU");
  LinkColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LinkColor");
  LinkColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LinkColorU");
  LinkColorDefault = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LinkDefaultColor");
  AlternateColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "AlternateColor");
  SpotColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SpotColor");
  SpotColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SpotColorU");
  CoreSpotColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CoreSpotColor");
  CoreSpotColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CoreSpotColorU");
  InvisibleSpotColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "InvisibleSpotColor");
  InvisibleSpotColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "InvisibleSpotColorU");
  BetweenPinsColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "BetweenPinsColor");
  BetweenPinsColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "BetweenPinsColorU");
  CompoInColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoInColor");
  CompoInColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoInColorU");
  CompoOutColor = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoOutColor");
  CompoOutColorU = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CompoOutColorU");

  AllowEditComponent =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "AllowEditComponent");
  AllowDeleteComponent =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "AllowDeleteComponent");
  AllowDeleteSubFunction =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "AllowDeleteSubFunction");
  DefaultSubFunctionName =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "DefaultSubFunctionName");
  DefaultComponentName =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "DefaultComponentName");
  OpenInformation =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "OpenInformation");
  RevertInformation =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "RevertInformation");
  SaveInformation =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "SaveInformation");
  CircuitDirectoryEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "CircuitDirectoryEntry");
  
  ContinuallyRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ContinuallyRadio");
  ClickedRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ClickedRadio");
  DemandRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "DemandRadio");
  ScaleSpin = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ScaleSpin");
  NoLinkIcon =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "NoLinkIcon");
  NoLinkColor =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "NoLinkColor");
  ShortRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ShortRadio");
  LongRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "LongRadio");
  IndifferentLengthRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "IndifferentLengthRadio");
  ThinRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThinRadio");
  LargeRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "LargeRadio");
  IndifferentWidthRadio =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "IndifferentWidthRadio");
  WidthFirstCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "WidthFirstCheck");

  MillimeterCheck =  gtk_object_get_data(GTK_OBJECT(EditPrefs), "MillimeterCheck");
  SwapMax  = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SwapMax");
  RoutingMax  = gtk_object_get_data(GTK_OBJECT(EditPrefs), "RoutingMax");
  LogFileEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LogFileEntry");
  LogToFileCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LogToFileCheck");
  UnRoutableDeleteCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UnRoutableDeleteCheck");
  UnRoutableSwapMax = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UnRoutableSwapMax");
  SelectionFollowCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SelectionFollowCheck");
  UseMagic = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UseMagic");

  FirstRadio[0] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "FirstHVRadio");
  FirstRadio[1] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "FirstDRadio");
  FirstRadio[2] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "FirstPRadio");

  SecondRadio[0] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SecondHVRadio");
  SecondRadio[1] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SecondDRadio");
  SecondRadio[2] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SecondPRadio");

  ThirdRadio[0] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThirdHVRadio");
  ThirdRadio[1] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThirdDRadio");
  ThirdRadio[2] = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ThirdPRadio");

  GetColor(CompColor, CircuitData->Info.Opt.ColorPalette[ComponentPalette], Dummy);
  GetColor(CompColorU, CircuitData->Info.Opt.ColorPalette[ComponentUnSelectedPalette], Dummy);
  GetColor(SubFColor, CircuitData->Info.Opt.ColorPalette[SubFunctionPalette], Dummy);
  GetColor(SubFColorU, CircuitData->Info.Opt.ColorPalette[SubFunctionUnSelectedPalette], Dummy);
  GetColor(LinkColor, CircuitData->Info.Opt.ColorPalette[LinkPalette], Dummy);
  GetColor(LinkColorU, CircuitData->Info.Opt.ColorPalette[LinkUnSelectedPalette], Dummy);

  GetColor(LinkColorDefault, CircuitData->Info.Opt.ColorPalette[LinkDefaultPalette], Dummy);
  GetColor(AlternateColor, CircuitData->Info.Opt.ColorPalette[AlternatePalette], Dummy);

  GetColor(SpotColor, CircuitData->Info.Opt.ColorPalette[SpotPalette], Dummy);
  GetColor(SpotColorU, CircuitData->Info.Opt.ColorPalette[SpotUnSelectedPalette], Dummy);
  GetColor(CoreSpotColor, CircuitData->Info.Opt.ColorPalette[CoreSpotPalette], Dummy);
  GetColor(CoreSpotColorU, CircuitData->Info.Opt.ColorPalette[CoreSpotUnSelectedPalette], Dummy);
  GetColor(InvisibleSpotColor, CircuitData->Info.Opt.ColorPalette[InvisibleSpotPalette], Dummy);
  GetColor(InvisibleSpotColorU, CircuitData->Info.Opt.ColorPalette[InvisibleSpotUnSelectedPalette], Dummy);
  GetColor(BetweenPinsColor, CircuitData->Info.Opt.ColorPalette[BetweenPinsPalette], Dummy);
  GetColor(BetweenPinsColorU, CircuitData->Info.Opt.ColorPalette[BetweenPinsUnSelectedPalette], Dummy);
  GetColor(CompoInColor, CircuitData->Info.Opt.ColorPalette[CompoInPalette], Dummy);
  GetColor(CompoInColorU, CircuitData->Info.Opt.ColorPalette[CompoInUnSelectedPalette], Dummy);
  GetColor(CompoOutColor, CircuitData->Info.Opt.ColorPalette[CompoOutPalette], Dummy);
  GetColor(CompoOutColorU, CircuitData->Info.Opt.ColorPalette[CompoOutUnSelectedPalette], Dummy);
 
  if (GTK_TOGGLE_BUTTON (AllowEditComponent)->active)
    CircuitData->Info.Opt.AllowEditComponent = True;
  else
    CircuitData->Info.Opt.AllowEditComponent = False;
  if (GTK_TOGGLE_BUTTON (AllowDeleteComponent)->active)
    CircuitData->Info.Opt.AllowDeleteComponent = True;
  else
    CircuitData->Info.Opt.AllowDeleteComponent = False;
  if (GTK_TOGGLE_BUTTON (AllowDeleteSubFunction)->active)
    CircuitData->Info.Opt.AllowDeleteSubFunction = True;
  else
    CircuitData->Info.Opt.AllowDeleteSubFunction = False;

  Buffer = gtk_entry_get_text(GTK_ENTRY(DefaultSubFunctionName));
  strncpy(CircuitData->Info.Opt.DefaultSubFunctionName, Buffer, SubFunctionNameLength);
  CircuitData->Info.Opt.DefaultSubFunctionName[SubFunctionNameLength-1] = '\0';

  Buffer = gtk_entry_get_text(GTK_ENTRY(DefaultComponentName));
  strncpy(CircuitData->Info.Opt.DefaultComponentName, Buffer, ComponentNameLength);
  CircuitData->Info.Opt.DefaultComponentName[ComponentNameLength-1] = '\0';

  if (GTK_TOGGLE_BUTTON (OpenInformation)->active)
    CircuitData->Info.Opt.OpenInformation = True;
  else
    CircuitData->Info.Opt.OpenInformation = False;
  if (GTK_TOGGLE_BUTTON (RevertInformation)->active)
    CircuitData->Info.Opt.RevertInformation = True;
  else
    CircuitData->Info.Opt.RevertInformation = False;
  if (GTK_TOGGLE_BUTTON (SaveInformation)->active)
    CircuitData->Info.Opt.SaveInformation = True;
  else
    CircuitData->Info.Opt.SaveInformation = False;
  
  Buffer = gtk_entry_get_text(GTK_ENTRY(CircuitDirectoryEntry));
  strncpy(CircuitData->Info.Opt.CircuitDirectory, Buffer, FileNameLength);
  CircuitData->Info.Opt.CircuitDirectory[FileNameLength-1] = '\0';

  if (GTK_TOGGLE_BUTTON (DemandRadio)->active)
    CircuitData->Info.Opt.UpdateDemand = True;
  else
    CircuitData->Info.Opt.UpdateDemand = False;
  
  if (GTK_TOGGLE_BUTTON (ClickedRadio)->active)
    CircuitData->Info.Opt.UpdateClicked = True;
  else
    CircuitData->Info.Opt.UpdateClicked = False;
  
  if (GTK_TOGGLE_BUTTON (ContinuallyRadio)->active)
    CircuitData->Info.Opt.UpdateContinually = True;
  else
    CircuitData->Info.Opt.UpdateContinually = False;

  if (GTK_TOGGLE_BUTTON (SelectionFollowCheck)->active)
    CircuitData->Info.Opt.SelectionFollowMouse = True;
  else
    CircuitData->Info.Opt.SelectionFollowMouse = False;

/*   CircuitData->Info.Opt.ScaleFactor = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(ScaleSpin)); */

  if (GTK_TOGGLE_BUTTON (NoLinkIcon)->active)
    CircuitData->Info.Opt.NoLinkIcon = True;
  else
    CircuitData->Info.Opt.NoLinkIcon = False;

  if (GTK_TOGGLE_BUTTON (NoLinkColor)->active)
    CircuitData->Info.Opt.NoLinkColor = True;
  else
    CircuitData->Info.Opt.NoLinkColor = False;

  if (GTK_TOGGLE_BUTTON (ShortRadio)->active)
    CircuitData->Info.Opt.LengthOrder = AscendantOrder;
  if (GTK_TOGGLE_BUTTON (LongRadio)->active)
    CircuitData->Info.Opt.LengthOrder = DescendantOrder;
  if (GTK_TOGGLE_BUTTON (IndifferentLengthRadio)->active)
    CircuitData->Info.Opt.LengthOrder = IndifferentOrder;

  if (GTK_TOGGLE_BUTTON (ThinRadio)->active)
    CircuitData->Info.Opt.WidthOrder = AscendantOrder;
  if (GTK_TOGGLE_BUTTON (LargeRadio)->active)
    CircuitData->Info.Opt.WidthOrder = DescendantOrder;
  if (GTK_TOGGLE_BUTTON (IndifferentWidthRadio)->active)
    CircuitData->Info.Opt.WidthOrder = IndifferentOrder;

  if (GTK_TOGGLE_BUTTON (WidthFirstCheck)->active)
    CircuitData->Info.Opt.SortWidthFirst = True;
  else
    CircuitData->Info.Opt.SortWidthFirst = False;
  
  
  if (GTK_TOGGLE_BUTTON (MillimeterCheck)->active)
    CircuitData->Info.Opt.Millimeter = True;
  else
    CircuitData->Info.Opt.Millimeter = False;
  
  Buffer = gtk_entry_get_text(GTK_ENTRY(LogFileEntry));
  strncpy(CircuitData->Info.Opt.LogFileName, Buffer, FileNameLength);
  CircuitData->Info.Opt.LogFileName[FileNameLength-1] = '\0';

  if (GTK_TOGGLE_BUTTON (LogToFileCheck)->active)
    CircuitData->Info.Opt.LogToFile = True;
  else
    CircuitData->Info.Opt.LogToFile = False;

  CircuitData->Info.Opt.SwapMax = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(SwapMax));
  CircuitData->Info.Opt.RoutingMax = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(RoutingMax));

  if (GTK_TOGGLE_BUTTON (UnRoutableDeleteCheck)->active)
    CircuitData->Info.Opt.UnRoutableDelete = True;
  else
    CircuitData->Info.Opt.UnRoutableDelete = False;
 
  if (GTK_TOGGLE_BUTTON (UseMagic)->active)
    CircuitData->Info.Opt.UseMagic = True;
  else
    CircuitData->Info.Opt.UseMagic = False;
  
  CircuitData->Info.Opt.UnRoutableSwapMax = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(UnRoutableSwapMax));
 
  for (Counter = 0 ; Counter < 3 ; Counter++)
    {
      if ( GTK_TOGGLE_BUTTON(FirstRadio[Counter])->active)
	FirstPref = Counter;
      if ( GTK_TOGGLE_BUTTON(SecondRadio[Counter])->active)
	SecondPref = Counter;
      if ( GTK_TOGGLE_BUTTON(ThirdRadio[Counter])->active)
	ThirdPref = Counter;
    }

  CircuitData->Info.Opt.DirectionPrefTab[0] = FirstPref;
  CircuitData->Info.Opt.DirectionPrefTab[1] = SecondPref;
  CircuitData->Info.Opt.DirectionPrefTab[2] = ThirdPref;
      
  SaveConfigFile(CircuitData);
  UpdateLLClist();
  UpdateDLClist();
  UpdateCircuitView(UCVModification);
}
void on_UseMagic_toggled (GtkToggleButton *UseMagic, GtkWidget *EditPrefs)
{
  GtkWidget *SwapMax, *RoutingMax, *LogFileEntry, *LogToFileCheck, *UnRoutableDeleteCheck, *UnRoutableSwapMax,
    *LogToFileLabel, *ChooseLogFileButton;
  gboolean SensitiveState, NotSensitiveState;
  
  SwapMax  = gtk_object_get_data(GTK_OBJECT(EditPrefs), "SwapMax");
  RoutingMax  = gtk_object_get_data(GTK_OBJECT(EditPrefs), "RoutingMax");
  LogFileEntry = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LogFileEntry");
  LogToFileCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LogToFileCheck");
  UnRoutableDeleteCheck = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UnRoutableDeleteCheck");
  UnRoutableSwapMax = gtk_object_get_data(GTK_OBJECT(EditPrefs), "UnRoutableSwapMax");
  LogToFileLabel = gtk_object_get_data(GTK_OBJECT(EditPrefs), "LogToFileLabel");
  ChooseLogFileButton = gtk_object_get_data(GTK_OBJECT(EditPrefs), "ChooseLogFileButton");
  if (GTK_TOGGLE_BUTTON(UseMagic)->active)
    {
      SensitiveState = TRUE;
      NotSensitiveState = FALSE;
    }
  else
    {
      SensitiveState = FALSE;
      NotSensitiveState = TRUE;  
    }

  gtk_widget_set_sensitive(SwapMax, SensitiveState);
  gtk_widget_set_sensitive(RoutingMax, SensitiveState);
  gtk_widget_set_sensitive(LogFileEntry, SensitiveState);
  gtk_widget_set_sensitive(LogToFileCheck, SensitiveState);
  gtk_widget_set_sensitive(UnRoutableDeleteCheck, SensitiveState);
  gtk_widget_set_sensitive(UnRoutableSwapMax, SensitiveState);
  gtk_widget_set_sensitive(LogToFileLabel, SensitiveState);
  gtk_widget_set_sensitive(ChooseLogFileButton, SensitiveState);
}
  

void on_XEntryCircuit_changed (GtkEditable *editable, GtkWidget *CircuitEditWindow)
{
  GtkWidget *mm_Label, *in_Label;
  int Value, ArgNb;
  char *Buffer, LabelValue[BufferLength];

  Buffer = gtk_entry_get_text(GTK_ENTRY(editable));
  ArgNb = sscanf(Buffer, "%d", &Value);
  if (ArgNb == 1)
    {
      mm_Label = gtk_object_get_data(GTK_OBJECT(CircuitEditWindow), "XMillimeterLabel");
      in_Label = gtk_object_get_data(GTK_OBJECT(CircuitEditWindow), "XInchLabel");
      
      sprintf(LabelValue,"%6.2f", SquareToMillimeter(Value));
      gtk_label_set_text(GTK_LABEL(mm_Label), LabelValue);
      sprintf(LabelValue,"%6.2f", SquareToInch(Value));
      gtk_label_set_text(GTK_LABEL(in_Label), LabelValue);
    }
}

void on_YEntryCircuit_changed (GtkEditable *editable, GtkWidget *CircuitEditWindow)
{
  GtkWidget *mm_Label, *in_Label;
  int Value, ArgNb;
  char *Buffer, LabelValue[BufferLength];

  Buffer = gtk_entry_get_text(GTK_ENTRY(editable));
  ArgNb = sscanf(Buffer, "%d", &Value);
  if (ArgNb == 1)
    {
      mm_Label = gtk_object_get_data(GTK_OBJECT(CircuitEditWindow), "YMillimeterLabel");
      in_Label = gtk_object_get_data(GTK_OBJECT(CircuitEditWindow), "YInchLabel");
      
      sprintf(LabelValue,"%6.2f", SquareToMillimeter(Value));
      gtk_label_set_text(GTK_LABEL(mm_Label), LabelValue);
      sprintf(LabelValue,"%6.2f", SquareToInch(Value));
      gtk_label_set_text(GTK_LABEL(in_Label), LabelValue);
    }
}
void on_XEntrySubFunction_changed (GtkEditable *editable, GtkWidget *SubFunctionEditWindow)
{
  GtkWidget *mm_Label, *in_Label;
  int Value, ArgNb;
  char *Buffer, LabelValue[BufferLength];

  Buffer = gtk_entry_get_text(GTK_ENTRY(editable));
  ArgNb = sscanf(Buffer, "%d", &Value);
  if (ArgNb == 1)
    {
      mm_Label = gtk_object_get_data(GTK_OBJECT(SubFunctionEditWindow), "XMillimeterLabel");
      in_Label = gtk_object_get_data(GTK_OBJECT(SubFunctionEditWindow), "XInchLabel");
      
      sprintf(LabelValue,"%6.2f", SquareToMillimeter(Value));
      gtk_label_set_text(GTK_LABEL(mm_Label), LabelValue);
      sprintf(LabelValue,"%6.2f", SquareToInch(Value));
      gtk_label_set_text(GTK_LABEL(in_Label), LabelValue);
    }
}
  
void on_YEntrySubFunction_changed (GtkEditable *editable, GtkWidget *SubFunctionEditWindow)
{
  GtkWidget *mm_Label, *in_Label;
  int Value, ArgNb;
  char *Buffer, LabelValue[BufferLength];

  Buffer = gtk_entry_get_text(GTK_ENTRY(editable));
  ArgNb = sscanf(Buffer, "%d", &Value);
  if (ArgNb == 1)
    {
      mm_Label = gtk_object_get_data(GTK_OBJECT(SubFunctionEditWindow), "YMillimeterLabel");
      in_Label = gtk_object_get_data(GTK_OBJECT(SubFunctionEditWindow), "YInchLabel");
      
      sprintf(LabelValue,"%6.2f", SquareToMillimeter(Value));
      gtk_label_set_text(GTK_LABEL(mm_Label), LabelValue);
      sprintf(LabelValue,"%6.2f", SquareToInch(Value));
      gtk_label_set_text(GTK_LABEL(in_Label), LabelValue);
    }
}

void on_XEntryComponent_changed (GtkEditable *editable, GtkWidget *ComponentEditWindow)
{
  GtkWidget *mm_Label, *in_Label;
  int Value, ArgNb;
  char *Buffer, LabelValue[BufferLength];

  Buffer = gtk_entry_get_text(GTK_ENTRY(editable));
  ArgNb = sscanf(Buffer, "%d", &Value);
  if (ArgNb == 1)
    {
      SubFunction SubFProp;
      Component CompProp;
      GCD *CircuitData;
      int ComponentID; 
      
      CircuitData = GetCircuitData();
      ComponentID = GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(ComponentEditWindow), ObjID));
      GetComponentProperties(CircuitData, ComponentID, &CompProp, False);
      GetSubFunctionProperties(CircuitData, CompProp.SubFunctionID, &SubFProp);
      Value += SubFProp.Reference.x;

      mm_Label = gtk_object_get_data(GTK_OBJECT(ComponentEditWindow), "XMillimeterLabel");
      in_Label = gtk_object_get_data(GTK_OBJECT(ComponentEditWindow), "XInchLabel");
      
      sprintf(LabelValue,"%6.2f", SquareToMillimeter(Value));
      gtk_label_set_text(GTK_LABEL(mm_Label), LabelValue);
      sprintf(LabelValue,"%6.2f", SquareToInch(Value));
      gtk_label_set_text(GTK_LABEL(in_Label), LabelValue);
    }
}

void on_YEntryComponent_changed (GtkEditable *editable, GtkWidget *ComponentEditWindow)
{
  GtkWidget *mm_Label, *in_Label;
  int Value, ArgNb;
  char *Buffer, LabelValue[BufferLength];

  Buffer = gtk_entry_get_text(GTK_ENTRY(editable));
  ArgNb = sscanf(Buffer, "%d", &Value);
  if (ArgNb == 1)
    {
      SubFunction SubFProp;
      Component CompProp;
      GCD *CircuitData;
      int ComponentID; 
      
      CircuitData = GetCircuitData();
      ComponentID = GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(ComponentEditWindow), ObjID));
      GetComponentProperties(CircuitData, ComponentID, &CompProp, False);
      GetSubFunctionProperties(CircuitData, CompProp.SubFunctionID, &SubFProp);
      Value += SubFProp.Reference.y;

      mm_Label = gtk_object_get_data(GTK_OBJECT(ComponentEditWindow), "YMillimeterLabel");
      in_Label = gtk_object_get_data(GTK_OBJECT(ComponentEditWindow), "YInchLabel");
      
      sprintf(LabelValue,"%6.2f", SquareToMillimeter(Value));
      gtk_label_set_text(GTK_LABEL(mm_Label), LabelValue);
      sprintf(LabelValue,"%6.2f", SquareToInch(Value));
      gtk_label_set_text(GTK_LABEL(in_Label), LabelValue);
    }
}

void cb_ChooseLogFile (GtkButton *button, GtkWidget *PreferencesWindow)
{
  GtkWidget *Window, *LogFileEntry;
  Window = create_ChooseLogFile();
  LogFileEntry = gtk_object_get_data(GTK_OBJECT(PreferencesWindow), "LogFileEntry");
  gtk_object_set_data(GTK_OBJECT(Window), "LogFileEntry", LogFileEntry);
  gtk_widget_show(Window);
}

void cb_SetLogFileName (GtkButton *button, GtkWidget *FileSelect)
{
  char *FileName;
  GtkWidget *Entry;
  Entry = gtk_object_get_data(GTK_OBJECT(FileSelect), "LogFileEntry");
  FileName = gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileSelect));
  gtk_entry_set_text(GTK_ENTRY(Entry), FileName);
}

void cb_SetLinkProperty(GtkButton *button, GtkWidget *LinkEditWindow)
{
  GtkWidget *LinkWidthSpin;
  int LinkWidth = 0;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  LinkWidthSpin = gtk_object_get_data(GTK_OBJECT(LinkEditWindow), "WidthSpin");
  LinkWidth = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(LinkWidthSpin));
  
  SetLinkWidth(CircuitData, NoID, LinkWidth);
  UpdateLLClist();
  UpdateDLClist();
}


