
#include <stdio.h>
#include <stdlib.h>
#include "misc.h"
#include "equipot.h" 

ErrorCheck MakeEquiPot (int Attach, Circuit Plate, RoadMap Map, EquiPotential *pEqui, Dep *DepList)
{
  int *LinkableTab=NULL, *AttachConnectedTab=NULL, *LinkConnectedTab=NULL;
  int CurrentLinkDep, CurrentAttachDep, DepCounter, NextFreePosition, Line, EquiPotSize,
    LinkProcessedCounter,  AttachProcessedCounter, LinkConnectedCounter, CurrentLinkConnected, 
    LinkConnectedSize, LinkableCounter, LinkableSize, AttachConnectedCounter, CurrentAttachConnected,
    AttachConnectedSize, AttachLocationCounter, PathCounter;

  Boolean  NewFound, *LinkProcessedTab = NULL, *AttachProcessedTab= NULL;
  ErrorCheck MatchStart, MatchEnd;
  
  /* LinkableTab : Liens deja traces dans l equipotentielle */
  /* LinkProcessedTab : (Boolean) indique qu un lien a connecte directement ( sans trous ) au point d attache */
  /* LinkConnectedTab : (int ) tableau contenant les 'Link Processed' */
  /* AttachProcessedTab : (Boolean) indique qu un point d attache est connecte directement au point d attache */
  /* AttachConnectedTab : (int ) tableau contenant les 'Attach Processed' */
  pEqui->Size = 0;
  pEqui->PointTab = NULL;
  
  if ((Plate.LinkNb == 0) || (Plate.AttachNb == 0))
    return AllOk;
    
  LinkableTab = (int *) malloc (sizeof(int) * Plate.LinkNb);
  LinkProcessedTab  = (Boolean *) malloc (sizeof(Boolean) *  Plate.LinkNb);
  LinkConnectedTab  = (int *) malloc (sizeof(int) * Plate.LinkNb);
  AttachProcessedTab  = (Boolean *) malloc (sizeof(Boolean) *  Plate.AttachNb);
  AttachConnectedTab  = (int *) malloc (sizeof(int) * Plate.AttachNb);

  for (LinkProcessedCounter = 0; LinkProcessedCounter <  Plate.LinkNb ; LinkProcessedCounter++)
    LinkProcessedTab[LinkProcessedCounter] = False;
  for (AttachProcessedCounter = 0; AttachProcessedCounter <  Plate.AttachNb ; AttachProcessedCounter++)
    AttachProcessedTab[AttachProcessedCounter] = False;

  LinkableSize = 0;
  LinkConnectedSize = 0;
  AttachConnectedSize = 0;

  for (LinkableCounter = 0 ; LinkableCounter < Plate.AttachTab[Attach].Size ; LinkableCounter++)
    {
      Line = Plate.AttachTab[Attach].Attach2Link[LinkableCounter];
      if (Map.Line[Line].JobDone == True)
	{
	  LinkableTab[LinkableSize] = Line;
	  LinkableSize++;
	}
    }

  AttachProcessedTab[Attach] = True;
  AttachConnectedTab[0]  = Attach;
  AttachConnectedSize = 1;
  
  do
    {
      NewFound = False;
      /* rajoute les dependances pour les lien 'LINKPROCESSED' en verifiant que ca n a pas ete fait */
      for( LinkConnectedCounter = 0  ; LinkConnectedCounter < LinkConnectedSize ; LinkConnectedCounter++)
	{
	  CurrentLinkConnected = LinkConnectedTab[LinkConnectedCounter];
	  for (DepCounter = 0 ; DepCounter < Map.Line[CurrentLinkConnected].DepSize ; DepCounter++ )
	    {
	      CurrentLinkDep = Map.Line[CurrentLinkConnected].DepTab[DepCounter].Nb;
	      CurrentAttachDep = Map.Line[CurrentLinkConnected].DepTab[DepCounter].Nb;

	      if ( (Map.Line[CurrentLinkConnected].DepTab[DepCounter].Type == LinkDep) 
		   && (LinkProcessedTab[CurrentLinkDep] == False))
		{
		  NewFound = True;
		  LinkProcessedTab[CurrentLinkDep] = True;
		  LinkConnectedTab[LinkConnectedSize] = CurrentLinkDep;
		  LinkConnectedSize++;	      
		}
	      
	      if ( (Map.Line[CurrentLinkConnected].DepTab[DepCounter].Type == AttachDep) 
		   && (AttachProcessedTab[CurrentAttachDep] == False) )
		{
		  NewFound = True;
		  AttachProcessedTab[CurrentAttachDep] = True;
		  AttachConnectedTab[AttachConnectedSize] = CurrentAttachDep;
		  AttachConnectedSize++;	      
		}
	    }
	}
      
      for( LinkableCounter = 0  ; LinkableCounter < LinkableSize ; LinkableCounter++)
	{
	  Line =  LinkableTab[LinkableCounter];
	  MatchStart = FindNbInTab(Plate.LinkTab[Line].Start, AttachConnectedTab, AttachConnectedSize);
	  MatchEnd = FindNbInTab(Plate.LinkTab[Line].End, AttachConnectedTab, AttachConnectedSize);
	  if  ( (LinkProcessedTab[Line]==False) && (MatchStart == Found) && (MatchEnd == NotFound))
	    /* une des deux extremites est dans la liste des points directement connectes a Attach */
	    {
	      NewFound = True;
	      AttachConnectedTab[AttachConnectedSize] = Plate.LinkTab[Line].End ;
	      AttachConnectedSize++;
	    }
	  
	  if  ( (LinkProcessedTab[Line]==False) && (MatchStart == NotFound) && (MatchEnd == Found) )
	    /* une des deux extremites est dans la liste des points directement connectes a Attach */
	    {
	      NewFound = True;
	      AttachConnectedTab[AttachConnectedSize] = Plate.LinkTab[Line].Start ;
	      AttachConnectedSize++;
	    }

	  if ( (LinkProcessedTab[Line]==False) && ( (MatchStart== Found) || (MatchEnd == Found)) )
	    {
	      LinkProcessedTab[Line]= True;
	      LinkConnectedTab[LinkConnectedSize] = Line;
	      LinkConnectedSize++;
	    }
	}
    } while (NewFound ==True);

  /***************/
  if (DepList != NULL)
    {
      DepList->Size = LinkConnectedSize +  AttachConnectedSize;
      DepList->Tab  = (DepCarac *) malloc ( DepList->Size * sizeof(DepCarac));
      DepCounter = 0;

      /* remplit le tableau de dependances */
      for (LinkConnectedCounter = 0 ; LinkConnectedCounter < LinkConnectedSize ; LinkConnectedCounter++)
	{
	  DepList->Tab[DepCounter].Type =  LinkDep;
	  DepList->Tab[DepCounter].Nb = LinkConnectedTab[LinkConnectedCounter];
	  DepCounter++;
	}
      
      for (AttachConnectedCounter = 0 ; AttachConnectedCounter < AttachConnectedSize ; AttachConnectedCounter++)
	{
	  DepList->Tab[DepCounter].Type =  AttachDep;
	  DepList->Tab[DepCounter].Nb = AttachConnectedTab[AttachConnectedCounter];
	  DepCounter++;
	}
    }
  /***************/
  EquiPotSize = 0;
  for (AttachConnectedCounter = 0 ; AttachConnectedCounter < AttachConnectedSize; AttachConnectedCounter++)
    {
      CurrentAttachConnected = AttachConnectedTab[AttachConnectedCounter];
      EquiPotSize += Plate.AttachTab[CurrentAttachConnected].CoreAttachLocationNb;
    }
  
  for (LinkConnectedCounter = 0 ; LinkConnectedCounter < LinkConnectedSize; LinkConnectedCounter++)
    {
      CurrentLinkConnected = LinkConnectedTab[LinkConnectedCounter];
      EquiPotSize += Map.Line[CurrentLinkConnected].CorePathSize;
    }
  
  pEqui->Size = EquiPotSize;
  pEqui->PointTab = (Point *) malloc ( sizeof(Point) * pEqui->Size);
  
  NextFreePosition = 0;
  for (AttachConnectedCounter = 0; AttachConnectedCounter < AttachConnectedSize ; AttachConnectedCounter++ )
    {
      CurrentAttachConnected = AttachConnectedTab[AttachConnectedCounter];
      for (AttachLocationCounter = 0 ; AttachLocationCounter < Plate.AttachTab[CurrentAttachConnected].CoreAttachLocationNb ; AttachLocationCounter++)
	{	
	  pEqui->PointTab[NextFreePosition].x = Plate.AttachTab[CurrentAttachConnected].CoreAttachLocation[AttachLocationCounter].x;
	  pEqui->PointTab[NextFreePosition].y = Plate.AttachTab[CurrentAttachConnected].CoreAttachLocation[AttachLocationCounter].y;
	  NextFreePosition++;
	}
    }
  
  for (LinkConnectedCounter = 0 ; LinkConnectedCounter < LinkConnectedSize ; LinkConnectedCounter++ )
    {
      CurrentLinkConnected = LinkConnectedTab[LinkConnectedCounter];
      for (PathCounter = 0 ; PathCounter < Map.Line[CurrentLinkConnected].CorePathSize; PathCounter++)
	{
	  pEqui->PointTab[NextFreePosition].x  =  Map.Line[CurrentLinkConnected].PathTab[PathCounter].x;
	  pEqui->PointTab[NextFreePosition].y  =  Map.Line[CurrentLinkConnected].PathTab[PathCounter].y;
	  NextFreePosition++;
	}
    }

  free(AttachConnectedTab);
  free(AttachProcessedTab);
  free(LinkConnectedTab);
  free(LinkProcessedTab);
  free(LinkableTab);
  return Found;
}

ErrorCheck MakeVortex(Circuit *pPlate, RoadMap Map, int Currentx, int Currenty, EquiPotential *pVortexEqui)
{
  int LinkVortex, AttachVortex;

  if (IsSquareAttach(pPlate->SquareTab[Currentx][Currenty].SquareState))
    /* le vortex est sur un point d attache */
    AttachVortex = pPlate->SquareTab[Currentx][Currenty].AttachLinkNb;
  else
    { /* le vortex est sur une piste */
      LinkVortex = pPlate->SquareTab[Currentx][Currenty].AttachLinkNb;
      AttachVortex = pPlate->LinkTab[LinkVortex].Start;
    }
      
  /* maintenant on cree l equipot du vortex */
  MakeEquiPot(AttachVortex, *pPlate, Map, pVortexEqui, NULL);
  
  return AllOk ;
} 

ErrorCheck AddEquiPot(EquiPotential *Equi1, int CurrentSize, EquiPotential Equi2)
{
  Point *Result;
  int  ResultCounter,  Counter;
  
  Result = (Point *) malloc(sizeof(Point) * ( (CurrentSize * 8) + Equi2.Size) );
  for (Counter = 0 , ResultCounter = 0 ; Counter < Equi1->Size ; Counter++, ResultCounter++)
    {
      Result[ResultCounter].x =  Equi1->PointTab[Counter].x;
      Result[ResultCounter].y =  Equi1->PointTab[Counter].y;
    }
  
  for (Counter = 0 ; Counter < Equi2.Size ; Counter++, ResultCounter++)
    {
      Result[ResultCounter].x =  Equi2.PointTab[Counter].x;
      Result[ResultCounter].y =  Equi2.PointTab[Counter].y;
    }
  
  free(Equi1->PointTab);
  Equi1->Size +=  Equi2.Size;
  Equi1->PointTab = (Point *) malloc(sizeof(Point)* ( (8*CurrentSize) +  Equi2.Size) );
  
  for (Counter = 0 ; Counter < Equi1->Size ; Counter++)
    {
      Equi1->PointTab[Counter].x =  Result[Counter].x;
      Equi1->PointTab[Counter].y =  Result[Counter].y;
    }

  free(Result);
  return AllOk;
}
  
ErrorCheck FindInterEquiPot(EquiPotential Equi1, EquiPotential Equi2, Point *pMeetPoint)
{
  int EquiCounter1,EquiCounter2;

  for (EquiCounter1 = 0 ; EquiCounter1 < Equi1.Size ; EquiCounter1++)
    for (EquiCounter2 = 0 ; EquiCounter2 < Equi2.Size; EquiCounter2++)
      {
	if ( (Equi1.PointTab[EquiCounter1].x == Equi2.PointTab[EquiCounter2].x)
	     &&  (Equi1.PointTab[EquiCounter1].y == Equi2.PointTab[EquiCounter2].y) )
	  {
	    if (pMeetPoint != NULL)
	      {
		pMeetPoint->x = Equi1.PointTab[EquiCounter1].x;
		pMeetPoint->y = Equi1.PointTab[EquiCounter1].y;
	      }
	    return Found;
	  }
      }
  return NotFound;
}

ErrorCheck IsSameEquiPot(Circuit *pPlate, int AttachLinkNb, int SquareState, int CurrentLineNb)
{
  int Counter;
  Boolean SameEquiPot; 
  
  SameEquiPot = False;

  if (IsSquareAttach(SquareState))
    {
      for (Counter = 0 ; (SameEquiPot == False) && (Counter < pPlate->AttachTab[AttachLinkNb].Size) ; Counter++)
	if (pPlate->AttachTab[AttachLinkNb].Attach2Link[Counter] == CurrentLineNb)
	  SameEquiPot = True;
    }
  else
    {
      for (Counter = 0 ; (SameEquiPot == False) && (Counter < pPlate->LinkTab[AttachLinkNb].LinkSize) ; Counter++)
	if (pPlate->LinkTab[AttachLinkNb].Link2Link[Counter] == CurrentLineNb)
	  SameEquiPot = True;
    }

  if (SameEquiPot == True)
    return Found;
  else
    return NotFound;
}  
   
	 
	
  




