
#include <stdlib.h>
#include <stdio.h>
#include "findpath.h"
#include "roadncircuit.h"
#include "misc.h"
#include "equipot.h"

ErrorCheck FindPath (Circuit *pPlate, int CurrentLineNb, RoadMap *pMap, Point MeetPoint)
{     
  Boolean NextFound, DepFound;
  int Level2Find, PathCounter, DiagonalCounter, Counter, DiagonalSize, PathSize, SegSize, x, y, Currentx,Currenty, 
    Newx, Newy, VortexDoor, DepSize, DepNb, Basex, Basey, StartPointNb, EndPointNb, DirectionCounter, DirectionTabSize;
  EquiPotential Current, End;
  Direction LastDir, CurrentDir, CurrentDirection, DirectionTab[8];
  Point *DiagonalTab= NULL, *PathTab = NULL;
  Segment *SegTab = NULL;
  Point LastPoint;
  DepCarac *DepTab = NULL;
  DepType Type;
  ErrorCheck Match;
  Dep DepList;
  
  StartPointNb = pPlate->LinkTab[CurrentLineNb].Start;
  EndPointNb = pPlate->LinkTab[CurrentLineNb].End;
    
  MakeEquiPot(StartPointNb, *pPlate, *pMap, &Current, NULL); /* on utilise current pour le depart */
  MakeEquiPot(EndPointNb, *pPlate, *pMap, &End, &DepList);
  
  Match = FindInterEquiPot(Current, End, NULL);
  if (Match==Found)
    {
      pMap->Line[CurrentLineNb].SegSize = 0;
      pMap->Line[CurrentLineNb].SegTab= NULL;
      pMap->Line[CurrentLineNb].PathSize = 0;
      pMap->Line[CurrentLineNb].PathTab = NULL;
      pMap->Line[CurrentLineNb].DiagonalSize = 0;
      pMap->Line[CurrentLineNb].DiagonalTab = NULL;
      pMap->Line[CurrentLineNb].DepSize = DepList.Size;
      pMap->Line[CurrentLineNb].DepTab = DepList.Tab;
      pMap->Line[CurrentLineNb].JobDone = True;
      free(Current.PointTab);
      free(End.PointTab);
      return Found;
    }
  else
    {
      free(Current.PointTab);
      free(End.PointTab);
      if (DepList.Size != 0)
	free(DepList.Tab);
    }

  PathSize =  pPlate->SquareTab[MeetPoint.x][MeetPoint.y].CalculatingLevelNb * 2;
  PathTab  = (Point *) malloc (PathSize * sizeof(Point));
 
  DiagonalSize =  pPlate->SquareTab[MeetPoint.x][MeetPoint.y].CalculatingLevelNb;
  DiagonalTab  = (Point *) malloc (DiagonalSize * sizeof(Point));

  SegSize =  pPlate->SquareTab[MeetPoint.x][MeetPoint.y].CalculatingLevelNb;
  SegTab  = (Segment *) malloc (SegSize * sizeof(Segment));

  DepTab = (DepCarac *) malloc ( (pPlate->LinkNb+pPlate->AttachNb) * sizeof(DepCarac));
  DepSize = 0;

  x = MeetPoint.x;
  y = MeetPoint.y;
  LastPoint.x = MeetPoint.x;
  LastPoint.y = MeetPoint.y;
  
  LastDir = CurrentDir = NoDirection;
  Level2Find = pPlate->SquareTab[MeetPoint.x][MeetPoint.y].CalculatingLevelNb - 1;
  Newx = NoX;
  Newy = NoY; 
  PathCounter = 0; 
  DiagonalCounter = 0;
  SegSize = 0;
  do 
    {
      PathTab[PathCounter].x = x;
      PathTab[PathCounter].y = y;
      PathCounter++;
      
      NextFound=False;
      if ((pPlate->SquareTab[x][y].CalculatingVortexLineNb == CurrentLineNb))
	{
	  VortexDoor = pPlate->SquareTab[x][y].CalculatingVortexNb;
	  
	  SegTab[SegSize].Start.x = LastPoint.x;
	  SegTab[SegSize].Start.y = LastPoint.y;
	  SegTab[SegSize].End.x = x;
	  SegTab[SegSize].End.y = y;
	  SegSize++;
	  
	  if (IsSquareAttach(pPlate->SquareTab[x][y].SquareState))
	    Type = AttachDep;
	  else
	    Type = LinkDep;

	  DepNb = pPlate->SquareTab[x][y].AttachLinkNb;
	  DepFound = False;
	  for (Counter = 0 ; (DepFound == False) && (Counter < DepSize) ; Counter++)
	    if ((DepTab[Counter].Type == Type)  && (DepTab[Counter].Nb == DepNb))
	      DepFound = True;
	  
	  if (DepFound == False)
	    {
	      DepTab[DepSize].Type = Type;
	      DepTab[DepSize].Nb = DepNb;
	      DepSize++;
	    }
	    

	  x =  pPlate->VortexTab[VortexDoor].VortexExit.x ; 
	  y =  pPlate->VortexTab[VortexDoor].VortexExit.y ; 	  	  
	  PathTab[PathCounter].x = x;
	  PathTab[PathCounter].y = y;
	  PathCounter++;
	  
	  CurrentDir = NoDirection;
	  LastPoint.x = x;
	  LastPoint.y = y;
	}

      ComputeDirection(pPlate, LastDir, DirectionTab, &DirectionTabSize);
      for (DirectionCounter = 0 ; (NextFound == False) && (DirectionCounter < DirectionTabSize) ; DirectionCounter++)
	{
	  Level2Find = pPlate->SquareTab[x][y].CalculatingLevelNb - 1;
	  CurrentDirection = DirectionTab[DirectionCounter]; 
	  Currentx = x + ForwardDirection[CurrentDirection][0];
	  Currenty = y + ForwardDirection[CurrentDirection][1];

	  if ((pPlate->SquareTab[Currentx][Currenty].CalculatingLineNb == CurrentLineNb)   /* meme ligne */
	      && (pPlate->SquareTab[Currentx][Currenty].CalculatingLevelNb == Level2Find)) /* niveau recherche */  
	    {
	      NextFound = True;
	      Newx = Currentx;
	      Newy = Currenty;
	      
	      LastDir = CurrentDir; 
	      CurrentDir = CurrentDirection;

	      if (IsDiagonalDirection(CurrentDirection))
		{
		  Basex = x + BaseDirection[ Direction2DiagonalType(CurrentDirection) ][0];
		  Basey = y + BaseDirection[ Direction2DiagonalType(CurrentDirection) ][1];
		  SetFullFourCorners(Basex, Basey, pPlate->SquareTab);
		  
		  DiagonalTab[DiagonalCounter].x = Basex;
		  DiagonalTab[DiagonalCounter].y = Basey;
		  DiagonalCounter++;
		}
	    }
	}
      /* ******** */
      if (NextFound == False) 
	{
	  if (PathTab != NULL)
	    free(PathTab);
	  if (DiagonalTab != NULL)
	    free(DiagonalTab);
	  if (SegTab != NULL)
	    free(SegTab);
	  if (DepTab != NULL) 
	    free(DepTab);
	  return NotFound;
	}
   
      if ((CurrentDir != LastDir) && (LastDir!=NoDirection))
	{ /* on repart du point nouvellement choisi */
	  SegTab[SegSize].Start.x = LastPoint.x;
	  SegTab[SegSize].Start.y = LastPoint.y;
	  SegTab[SegSize].End.x = x;
	  SegTab[SegSize].End.y = y;  
	  SegSize++;
	  LastPoint.x = x;
	  LastPoint.y = y;
	}

      if ((Level2Find == 1) )
	{ /* arrivee en bout de piste ou au bout d un morceau de piste */ 
	  SegTab[SegSize].Start.x = LastPoint.x;
	  SegTab[SegSize].Start.y = LastPoint.y;
	  SegTab[SegSize].End.x = Newx;
	  SegTab[SegSize].End.y = Newy;
	  SegSize++;
	}
      if (!IsSquareUsed(pPlate->SquareTab[Newx][Newy].SquareState))
	{
	  SetSquareUsed(pPlate->SquareTab[Newx][Newy].SquareState);
	  pPlate->SquareTab[Newx][Newy].AttachLinkNb = CurrentLineNb; 
	}
      
      x = Newx;
      y = Newy;
      Level2Find--;
    } while (Level2Find != 0 ); /* on a deja trouve le niveau 1 c est a dire le point de depart 
				   Level2Find est egal a 0 */
  PathTab[PathCounter].x = x;
  PathTab[PathCounter].y = y;
  PathCounter++;
  

  /* PATH ***************************** */
  
  pMap->Line[CurrentLineNb].PathSize =  PathCounter;
  pMap->Line[CurrentLineNb].PathTab  = (Point *) malloc (pMap->Line[CurrentLineNb].PathSize * sizeof(Point));
  
  for (Counter = 0 ; Counter < pMap->Line[CurrentLineNb].PathSize ; Counter++)
     {
       pMap->Line[CurrentLineNb].PathTab[Counter].x = PathTab[Counter].x;
       pMap->Line[CurrentLineNb].PathTab[Counter].y = PathTab[Counter].y;
     }
	
  /* DIAGONAL ************************* */
  pMap->Line[CurrentLineNb].DiagonalSize =  DiagonalCounter;
  if (pMap->Line[CurrentLineNb].DiagonalSize != 0)
    {
      pMap->Line[CurrentLineNb].DiagonalTab  = (Point *) malloc (pMap->Line[CurrentLineNb].DiagonalSize * sizeof(Point));
      for (Counter = 0 ; Counter < pMap->Line[CurrentLineNb].DiagonalSize ; Counter++)
	{
	  pMap->Line[CurrentLineNb].DiagonalTab[Counter].x = DiagonalTab[Counter].x;
	  pMap->Line[CurrentLineNb].DiagonalTab[Counter].y = DiagonalTab[Counter].y;
	}
    }
  else
    pMap->Line[CurrentLineNb].DiagonalTab = NULL;

   /* SEGMENT ************************** */
   pMap->Line[CurrentLineNb].SegSize =  SegSize;
   if (pMap->Line[CurrentLineNb].SegSize != 0)
     {
       pMap->Line[CurrentLineNb].SegTab  = (Segment *) malloc (pMap->Line[CurrentLineNb].SegSize * sizeof(Segment));
       for (Counter = 0 ; Counter < pMap->Line[CurrentLineNb].SegSize ; Counter++)
	 {
	   pMap->Line[CurrentLineNb].SegTab[Counter].Start.x = SegTab[Counter].Start.x;
	   pMap->Line[CurrentLineNb].SegTab[Counter].Start.y = SegTab[Counter].Start.y;
	   pMap->Line[CurrentLineNb].SegTab[Counter].End.x = SegTab[Counter].End.x;
	   pMap->Line[CurrentLineNb].SegTab[Counter].End.y = SegTab[Counter].End.y;
	 }
     }
   else
     pMap->Line[CurrentLineNb].SegTab = NULL;
   /* DEPENDANCE ********************** */
   pMap->Line[CurrentLineNb].DepSize = DepSize;
   if (pMap->Line[CurrentLineNb].DepSize != 0)
     {
       pMap->Line[CurrentLineNb].DepTab = (DepCarac *) malloc (sizeof(DepCarac) * DepSize);
       for (Counter = 0 ; Counter < pMap->Line[CurrentLineNb].DepSize ; Counter++)
	 {
	   pMap->Line[CurrentLineNb].DepTab[Counter].Type = DepTab[Counter].Type;
	   pMap->Line[CurrentLineNb].DepTab[Counter].Nb =   DepTab[Counter].Nb;
	 }
     }
   else 
     pMap->Line[CurrentLineNb].DepTab = NULL;

   pMap->Line[CurrentLineNb].JobDone = True;
   if (PathTab != NULL)
     free(PathTab);
   if (DiagonalTab != NULL)
     free(DiagonalTab);
   if (SegTab != NULL)
     free(SegTab);
   if (DepTab != NULL) 
     free(DepTab);

  return Found;
}
