
#include "libset.h"
#include <stdlib.h>
#include <gnome.h>
#include <stdio.h>
#include "libtypes.h"
#include "spot.h"
#include "layout.h"
#include "compdesc.h"

ErrorCheck LoadLibSet(ComponentLibrary *CompLib, char *LibSetFileName, GtkWidget *Text)
{
  FILE *LibSetFile;
  SearchLocation SearchLocationBuffer;
  LibToLoad LibToLoadBuffer;
  Boolean Continue;
  char Buffer[BufferLength];

  LibSetFile = fopen(LibSetFileName,"r");
  
  if (LibSetFile == NULL)
    {
      sprintf(Buffer,"Error Opening LibSetFile %s\n", LibSetFileName);
      gtk_text_insert(GTK_TEXT(Text), NULL, NULL, NULL, Buffer, -1);
      return FileAccessError;
    }

  sprintf(Buffer, "\tScanned Directories\n");
  gtk_text_insert(GTK_TEXT(Text), NULL, NULL, NULL, Buffer, -1);
  Continue = True;
  do
    {
      fgets(Buffer, BufferLength, LibSetFile);
      sscanf(Buffer,"%[^\n]", SearchLocationBuffer.DirectoryName);
      if (strcmp (Buffer,"\n") != 0)
	{
	  sprintf(Buffer, "%s\n", SearchLocationBuffer.DirectoryName);
	  gtk_text_insert(GTK_TEXT(Text), NULL, NULL, NULL, Buffer, -1);
 	  AddSearchLocation(CompLib, SearchLocationBuffer);
	}
      else Continue  = False;
    }
  while (Continue == True);
  
  Continue = True;
  do
    {
      fgets(Buffer, BufferLength, LibSetFile);
      sscanf(Buffer,"%[^\n]", LibToLoadBuffer.LibName);
      if (strcmp (Buffer,"\n") != 0)
	{
	  AddSpotLibToLoad(CompLib, LibToLoadBuffer);
	}
      else Continue  = False;
    }
  while (Continue == True);
  
  Continue = True;
  do
    {
      fgets(Buffer, BufferLength, LibSetFile);
      sscanf(Buffer,"%[^\n]", LibToLoadBuffer.LibName);
      if (strcmp (Buffer,"\n") != 0)
	{
	  AddLayoutLibToLoad(CompLib, LibToLoadBuffer);
	}
      else Continue  = False;
    }
  while (Continue == True);

  Continue = True;
  do
    {
      fgets(Buffer, BufferLength, LibSetFile);
      sscanf(Buffer,"%[^\n]", LibToLoadBuffer.LibName);
      if (strcmp (Buffer,"\n") != 0)
	AddCompDescLibToLoad(CompLib, LibToLoadBuffer);
      else Continue  = False;
    }
  while (Continue == True);
   
  return AllOk;
}

ErrorCheck AddSearchLocation(ComponentLibrary *CompLib, SearchLocation Location)
{
  SearchLocation *NewLocation, *LocationCursor;
  
  NewLocation = NULL;
  LocationCursor = CompLib->LocationList;
  while (LocationCursor != NULL)
    {
      NewLocation = LocationCursor;
      LocationCursor = LocationCursor->pNext;
    }
  
  if (NewLocation != NULL)
    {
      NewLocation->pNext = (SearchLocation *) malloc (sizeof(SearchLocation));
      LocationCursor = NewLocation->pNext;
    }
  else 
    {
      CompLib->LocationList = (SearchLocation *) malloc (sizeof(SearchLocation));
      LocationCursor = CompLib->LocationList;
    }

  strncpy(LocationCursor->DirectoryName, Location.DirectoryName, DirectoryNameLength);
  LocationCursor->pNext = NULL;
  return AllOk;
}



















  
  
