#ifndef LIBTYPES_H
#define LIBTYPES_H

#include "commontypes.h"

#define SpotNameLength 16
#define LayoutNameLength 16
#define LayoutClassLength 16
#define CompDescNameLength 20
#define CompDescClassLength 16
#define LibNameLength 64
#define PinNameLength 10
#define DirectoryNameLength  128
#define BufferLength 256 /* doit pouvoir contenir n importe quel element  */


typedef struct SpotDef{
  char SpotName[SpotNameLength];
  int SpotSize;
  int CoreSpotSize;
  int InvisibleSpotSize;
  Point *SpotLocation;
  Point *CoreSpotLocation;
  Point *InvisibleSpotLocation;
  struct SpotDef *pNext;
} SpotDef;

typedef struct LayoutDef{
  char LayoutName[LayoutNameLength];
  char LayoutClass[LayoutClassLength];
  int PinNb;
  Point *PinPosition;
  char **SpotNameTab;
  int BetweenPinsSize;
  int CompoInSize;
  int CompoOutSize;
  Point *BetweenPinsPosition;
  Point *CompoInPosition;;
  Point *CompoOutPosition;;
  struct LayoutDef *pNext;
} LayoutDef;

typedef struct CompDescDef{
  char CompDescName[CompDescNameLength];
  char CompDescClass[CompDescClassLength];
  char LayoutName[LayoutNameLength];
  char LayoutClass[LayoutClassLength];
  int PinNb;
  char **PinNameTab;
  struct CompDescDef *pNext;
} CompDescDef;

typedef struct SearchLocation{
  char DirectoryName[DirectoryNameLength];
  struct SearchLocation *pNext;
} SearchLocation;

typedef struct LibToLoad{
  char LibName[LibNameLength];
  struct LibToLoad *pNext;
} LibToLoad;
  
typedef struct {
  SpotDef *SpotDefList;
  LayoutDef *LayoutDefList;
  CompDescDef *CompDescDefList;
  
  SpotDef DefaultSpot ;
  LayoutDef DefaultLayout;
  CompDescDef DefaultCompDesc;
  
  SearchLocation *LocationList;
  LibToLoad *SpotLibList;
  LibToLoad *LayoutLibList;
  LibToLoad *CompDescLibList;  
} ComponentLibrary;

 
#endif /* LIBTYPES_H */
