#ifndef LINK_H
#define LINK_H

#include "xrmtypes.h"

extern int NewLinkID(GCD *CircuitData,int SetLinkID);

extern ErrorCheck AddLink(GCD *CircuitData, int LinkID);
extern ErrorCheck EditLink(GCD *CircuitData, Boolean DoSelected, int LinkID, int StartAttachID, int EndAttachID);
extern ErrorCheck UpdateLink(GCD *CircuitData, int LinkID);

extern ErrorCheck DisplayLink(GCD *CircuitData);
extern ErrorCheck DeleteLink(GCD *CircuitData, int LinkID);
extern ErrorCheck DisplayLinkBuffer(GCD *CircuitData);

extern ErrorCheck GetLinkProperties(GCD *CircuitData, int LinkID, Link *LinkProp);

extern ErrorCheck GetSelectLink(GCD *CircuitData, int* TabSelectedLink, int *TabSize);
extern ErrorCheck GetUnSelectLink(GCD *CircuitData, int* TabSelectedLink, int *TabSize);
extern ErrorCheck GetAllLink(GCD *CircuitData, int* TabLink);

extern ErrorCheck SetLinkToDraw(GCD *CircuitData, int LinkID);
extern ErrorCheck SetLinkNotToDraw(GCD *CircuitData, int LinkID);

extern ErrorCheck GetLinkNumber(GCD *CircuitData, int *LinkNb);

extern ErrorCheck SelectLink(GCD *CircuitData, int LinkID);
extern ErrorCheck UnSelectLink(GCD *CircuitData, int LinkID);

extern ErrorCheck LinkRoutingIDToID(GCD *CircuitData, int RoutingID, int *ID);
extern ErrorCheck LinkIDToRoutingID(GCD *CircuitData, int ID, int *RoutingID);
extern ErrorCheck SetLinkRoutingID(GCD *CircuitData, int LinkID, int RoutingID);
extern ErrorCheck UnDrawLink(GCD *CircuitData, int LinkID);
extern ErrorCheck GetLinkIDFromCoordinates(GCD *CircuitData, int x, int y, int *LinkID);
extern ErrorCheck GetLinkSegTab(GCD *CircuitData, int LinkID, FigPath *FPData);
extern ErrorCheck SetLinkColor(GCD *CircuitData, int LinkID, int Red, int Green, int Blue);
extern ErrorCheck ExtendByColor(GCD *CircuitData);
extern ErrorCheck UnDrawAllLinks(GCD *CircuitData);
extern ErrorCheck SetLinkWidth(GCD *CircuitData, int LinkID, int LinkWidth);
extern ErrorCheck SelectLinkAsDLink(GCD *CircuitData);

#endif /* LINK_H */
