
#include "linkwindow.h"
#include "xrmtypes.h"
#include "liste.h"
#include "link.h"
#include "circuitviewwindow.h"
#include "mainwindow.h"
#include "subfunction.h"
#include "component.h"
#include "attachpoint.h"
#include "dlink.h"
#include "autosort.h"
#include "interface.h"
#include "drawtracks.h"
#include "componentwindow.h"
#include "magicrouter.h"
#include "miscwindows.h"
#include "support_custom.h"

void cb_SelectLLClist(GtkWidget *LLClist, gint row, gint column, GdkEventButton *event, gpointer data)
{
  gpointer LinkID;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  LinkID = gtk_clist_get_row_data( GTK_CLIST(LLClist), row);
  SelectLink(CircuitData, GPOINTER_TO_INT(LinkID));
  UpdateLinkStateDLClist(GPOINTER_TO_INT(LinkID));
  UpdateCircuitView(UCVSelection);
  CircuitData->Info.NewModification = True;
}

void cb_UnSelectLLClist(GtkWidget *LLClist, gint row, gint column, GdkEventButton *event, gpointer data)
{
  gpointer LinkID;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  LinkID = gtk_clist_get_row_data( GTK_CLIST(LLClist),   row);
  UnSelectLink(CircuitData, GPOINTER_TO_INT(LinkID));
  UpdateLinkStateDLClist(GPOINTER_TO_INT(LinkID));
  UpdateCircuitView(UCVSelection);
  CircuitData->Info.NewModification = True;
}
void UpdateLinkStateLLClist(int LinkID)
{
  int RowData;
  GtkWidget *LLClist;
  GCD *CircuitData;
  Link LinkProp;
  DrawLink DLinkProp;
  
  CircuitData = GetCircuitData();
  LLClist = CircuitData->Info.LLClist;
  RowData = gtk_clist_find_row_from_data( GTK_CLIST(LLClist), GINT_TO_POINTER(LinkID));
  if (RowData != -1)
    {
      GetLinkProperties(CircuitData,  LinkID, &LinkProp);
      GetDLinkProperties(CircuitData, LinkID, &DLinkProp);
      CreateLinkStatePixmap(CircuitData, LinkProp, DLinkProp, LLClist, RowData, False); 
    }
}

void cb_AddLink(GtkWidget *Button,  gpointer LLClist )
{
  if (IRQ(True) == False)
    return;
  NewLink(False);
  IRQ(False);
}

void NewLink(Boolean Select)
{
  int NewID, RowNb;
  Link LinkProp;
  DrawLink DLinkProp;
  GtkWidget *LLClist;
  gchar *NewLink[LLColumnNb] = {"", "??? - ???", "??? - ???", "- / -"};
  GCD *CircuitData;
  GtkStyle *Style;
  GdkColor Color;

  CircuitData = GetCircuitData();
  NewID  = NewLinkID(CircuitData, NoID);
  
  LLClist = CircuitData->Info.LLClist;
  RowNb = gtk_clist_append( GTK_CLIST(LLClist), NewLink);
  gtk_clist_set_row_data( GTK_CLIST(LLClist), RowNb, GINT_TO_POINTER(NewID));
  
  AddLink(CircuitData, NewID);
  GetLinkProperties(CircuitData , NewID, &LinkProp);
  if (CircuitData->Info.Opt.NoLinkColor == False)
    {
      Color.red = LinkProp.LinkColor.Red;
      Color.green = LinkProp.LinkColor.Green;
      Color.blue = LinkProp.LinkColor.Blue;
      Style = gtk_style_copy(GTK_WIDGET(LLClist)->style);
      Style->bg[GTK_STATE_SELECTED] = Color;
      Style->fg[GTK_STATE_NORMAL] = Color;
      gtk_clist_set_row_style(GTK_CLIST(LLClist), RowNb, Style);
    }
  CreateLinkStatePixmap(CircuitData, LinkProp, DLinkProp, LLClist, RowNb, False);
  /* DLinkProp ne sera pas lu */
  if (Select == False)
    UnSelectLink(CircuitData, NewID);
  else 
    {
      int RowSize, *RowTab, RowCounter, RowData;
      GetLinkNumber( CircuitData, &RowSize);
      if (RowSize != 0)
	{
	  RowTab = (int *) malloc (RowSize* sizeof(int));
	  GetAllLink( CircuitData, RowTab);
	  
	  for (RowCounter = 0 ; RowCounter < RowSize ; RowCounter++)
	    {
	      RowData = gtk_clist_find_row_from_data( GTK_CLIST( LLClist), GINT_TO_POINTER(RowTab[RowCounter]));
	      gtk_clist_unselect_row( GTK_CLIST( LLClist), RowData, 0);
	    }
	  free(RowTab);
	  gtk_clist_select_row( GTK_CLIST( LLClist), RowNb, 0);
	}
    }
  CircuitData->Info.NewModification = True;
}

void cb_SelectAllLink(GtkWidget *Button,  gpointer LLClist )
{
  int  RowNb, RowCounter, RowData, *RowTab;

  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  GetLinkNumber( CircuitData, &RowNb);
  if (RowNb ==0)
    {  
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(LLClist));
  RowTab = (int *) malloc (RowNb * sizeof(int));
  GetAllLink( CircuitData, RowTab);

  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
       RowData = gtk_clist_find_row_from_data( GTK_CLIST( LLClist), GINT_TO_POINTER(RowTab[RowCounter])); 
      gtk_clist_select_row( GTK_CLIST( LLClist), RowCounter, 0);
    }

  free(RowTab);
  gtk_clist_thaw(GTK_CLIST(LLClist));
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_SelectLinkAsDLink(GtkWidget *Button,  gpointer DLClist )
{
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  SelectLinkAsDLink(CircuitData);
  CircuitData->Info.NewModification = True;
  UpdateLLClist();
  IRQ(False);
}

void cb_SelectNoneLink(GtkWidget *Button,  gpointer LLClist)
{
  int RowNb, RowCounter, RowData, *RowTab;
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetLinkNumber( CircuitData, &RowNb);
  if (RowNb == 0)
    {
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(LLClist));
  RowTab = (int *) malloc (RowNb * sizeof(int));
  GetAllLink( CircuitData, RowTab);

  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( LLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_unselect_row( GTK_CLIST( LLClist), RowData, 0);
    }
  free(RowTab);

  gtk_clist_thaw(GTK_CLIST(LLClist));
  CircuitData->Info.NewModification = True;
  IRQ(False);
}

void cb_SelectInvertLink(GtkWidget *Button,  gpointer LLClist )
{
  int RowUnNb, RowNb, RowCounter, RowData, LinkNb, *RowTab, *RowUnTab;
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetLinkNumber(CircuitData, &LinkNb);
  if (LinkNb == 0)
    {
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(LLClist));
  RowTab = (int *) malloc (LinkNb * sizeof(int));
  RowUnTab = (int *) malloc (LinkNb * sizeof(int));
  GetSelectLink( CircuitData, RowTab, &RowNb);
  GetUnSelectLink( CircuitData, RowUnTab, &RowUnNb);

  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( LLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_unselect_row( GTK_CLIST( LLClist), RowData, 0);
    }

  for (RowCounter = 0 ; RowCounter < RowUnNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data(GTK_CLIST( LLClist), GINT_TO_POINTER(RowUnTab[RowCounter]));
      gtk_clist_select_row( GTK_CLIST( LLClist), RowData, 0);
    }
  free(RowUnTab);
  free(RowTab);
  gtk_clist_thaw(GTK_CLIST(LLClist));
  CircuitData->Info.NewModification = True;
  IRQ(False);
  }

void cb_CutLink( GtkWidget *Button, gpointer LLClist )
{
  int RowNb, RowCounter, LinkNb, RowData, *RowTab;
  GCD *CircuitData;
  GtkWidget *DLClist;
  Link LinkProp;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();

  GetLinkNumber( CircuitData, &LinkNb);
  RowTab = (int *) malloc( sizeof(int) * LinkNb);

  GetSelectLink( CircuitData, RowTab, &RowNb );
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      GetLinkProperties(CircuitData, RowTab[RowCounter],  &LinkProp);
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( LLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_remove( GTK_CLIST(LLClist), RowData);
      if (IsLinkDLSelected(LinkProp.State))
	{
	  DLClist = CircuitData->Info.DLClist;
	  RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
	  gtk_clist_remove( GTK_CLIST(DLClist), RowData);
	}
      DeleteLink(CircuitData, RowTab[RowCounter]);
    }
  UpdateLLClist();
  UpdateDLClist();
  UpdateCircuitView(UCVModification);
  CircuitData->Info.NewModification = True;
  free(RowTab);
  IRQ(False);
}

void cb_AddLinkToDrawList(GtkWidget *Button,  gpointer LLClist)
{
  GtkWidget *DLClist;
  int RowNb, RowCounter, LinkNb, *RowTab;
  Link LinkProp;
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  DLClist = CircuitData->Info.DLClist;

  GetLinkNumber(CircuitData, &LinkNb);
  RowTab = (int *) malloc( sizeof(int) * LinkNb);

  GetSelectLink( CircuitData, RowTab, &RowNb);
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      GetLinkProperties(CircuitData, RowTab[RowCounter], &LinkProp);
      if ( !IsLinkFull(LinkProp.State) || IsLinkDLSelected(LinkProp.State))
	printf(" cannot add to draw list a link %d not full or already in DList\n", LinkProp.IDNumber);
      else
	{
	  AddLinkToDrawList(CircuitData, RowTab[RowCounter]);
	  SetLinkToDraw(CircuitData, RowTab[RowCounter]);
	  UnSelectDLink(CircuitData, RowTab[RowCounter]);
	}
    }
  UpdateLLClist();
  UpdateDLClist();
  CircuitData->Info.NewModification = True;
  free(RowTab);
  IRQ(False);
}
void cb_EditLink(GtkWidget *Button, GtkWidget *LLClist)
{
  GtkWidget *LinkEditWindow, *LinkWidthSpin;
  GCD *CircuitData;
  Link *LinkCursor;
  float SpinWidth;
  int Width;

  Boolean WidthDifferent, FirstWidth, NonEmptySelection;
  
  CircuitData = GetCircuitData();

  LinkCursor = CircuitData->ListLink;
  NonEmptySelection = False;
  while ( (LinkCursor != NULL) && (NonEmptySelection == False))
    {
      if (IsLinkSelected(LinkCursor->State))
	NonEmptySelection = True;
      LinkCursor = LinkCursor->pNext;
    }
    
  if (NonEmptySelection == False)
    return;
  
  WidthDifferent = False;
  FirstWidth = True;
  LinkCursor = CircuitData->ListLink;
  Width = 0;
  while ((LinkCursor != NULL) && (WidthDifferent == False))
    {
      if (IsLinkSelected(LinkCursor->State))
	{
	  if ((FirstWidth == False) && (Width != LinkCursor->LinkWidth))
	    WidthDifferent = True;
	  
	  if (FirstWidth == True)
	    {
	      FirstWidth = False;
	      Width = LinkCursor->LinkWidth;
	    }
	}
      LinkCursor = LinkCursor->pNext;
    }
  LinkEditWindow = create_LinkEditWindow();


  SpinWidth = Width;
  LinkWidthSpin = gtk_object_get_data(GTK_OBJECT(LinkEditWindow), "WidthSpin");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(LinkWidthSpin), SpinWidth);

    
      
  gtk_widget_show(LinkEditWindow);
}
/* **************************************************************************************************** */
/* **************************************************************************************************** */
void cb_SelectDLClist(GtkWidget *DLClist, gint row, gint column, GdkEventButton *Event, gpointer data)
{
  gpointer LinkID;
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  LinkID = gtk_clist_get_row_data( GTK_CLIST(DLClist), row);
  SelectDLink(CircuitData, GPOINTER_TO_INT(LinkID));
  UpdateLinkStateLLClist(GPOINTER_TO_INT(LinkID));
  UpdateCircuitView(UCVSelection);
  CircuitData->Info.NewModification = True;
}

void cb_UnSelectDLClist(GtkWidget *DLClist, gint row, gint column, GdkEventButton *event, gpointer data)
{
  gpointer LinkID;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  LinkID = gtk_clist_get_row_data( GTK_CLIST(DLClist),   row);
 
  UnSelectDLink(CircuitData, GPOINTER_TO_INT(LinkID));
  UpdateLinkStateLLClist(GPOINTER_TO_INT(LinkID));
  UpdateCircuitView(UCVSelection);
  CircuitData->Info.NewModification = True;
}

void UpdateLinkStateDLClist(int LinkID)
{
  int RowData;
  GtkWidget *DLClist;
  GCD *CircuitData;
  Link LinkProp;
  DrawLink DLinkProp;
  
  CircuitData = GetCircuitData();
  DLClist = CircuitData->Info.DLClist;
  RowData = gtk_clist_find_row_from_data( GTK_CLIST(DLClist), GINT_TO_POINTER(LinkID));
  if (RowData != -1)
    {
      GetLinkProperties(CircuitData,  LinkID, &LinkProp);
      GetDLinkProperties(CircuitData, LinkID, &DLinkProp);
      CreateLinkStatePixmap(CircuitData, LinkProp, DLinkProp, DLClist, RowData, True); 
    }
}

void cb_SelectAllDLink( GtkWidget *Button, gpointer DLClist )
{
  int  RowNb, RowCounter, RowData, *RowTab;
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();

  GetDLinkNumber( CircuitData, &RowNb);
  if (RowNb == 0)
    {
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(DLClist));
  RowTab = (int *) malloc (RowNb * sizeof(int));

  GetAllDLink( CircuitData, RowTab, &RowNb, Maybe);
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_select_row( GTK_CLIST( DLClist), RowData, 0);
    }

  CircuitData->Info.NewModification = True;
  free(RowTab);
  gtk_clist_thaw(GTK_CLIST(DLClist));
  IRQ(False);
}

void cb_SelectNoneDLink(GtkWidget *Button,  gpointer DLClist )
{
  int RowNb, RowCounter, RowData, *RowTab;
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetDLinkNumber( CircuitData, &RowNb);
  if (RowNb == 0)
    {
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(DLClist));

  RowTab = (int *) malloc (RowNb * sizeof(int));
  GetAllDLink( CircuitData, RowTab, &RowNb, Maybe);
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_unselect_row( GTK_CLIST( DLClist), RowData, 0);
    }
  free(RowTab);
  gtk_clist_thaw(GTK_CLIST(DLClist));

  CircuitData->Info.NewModification = True;
  IRQ(False);
}

void cb_SelectInvertDLink(GtkWidget *Button,  gpointer DLClist )
{
  int RowUnNb, RowNb, RowCounter, RowData, LinkNb;
  int *RowTab, *RowUnTab;
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetDLinkNumber(CircuitData, &LinkNb);
  if (LinkNb == 0)
    {
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(DLClist));

  RowTab = (int *) malloc (LinkNb * sizeof(int));
  RowUnTab = (int *) malloc (LinkNb * sizeof(int));

  GetSelectDLink( CircuitData, RowTab, &RowNb);
  GetUnSelectDLink( CircuitData, RowUnTab, &RowUnNb);

  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_unselect_row( GTK_CLIST( DLClist), RowData, 0);
    }

  for (RowCounter = 0 ; RowCounter < RowUnNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data(GTK_CLIST( DLClist), GINT_TO_POINTER(RowUnTab[RowCounter]));
      gtk_clist_select_row( GTK_CLIST( DLClist), RowData, 0);
    }
  free(RowUnTab);
  free(RowTab);
  gtk_clist_thaw(GTK_CLIST(DLClist));

  CircuitData->Info.NewModification = True;
  IRQ(False);
}

void cb_CutDLink(GtkWidget *Button,  gpointer DLClist )
{
  int RowNb, RowCounter, *RowTab, DLinkNb, RowData;
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetDLinkNumber( CircuitData, &DLinkNb);
  RowTab = (int *) malloc( sizeof(int) * DLinkNb);

  GetSelectDLink( CircuitData, RowTab, &RowNb );
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_remove( GTK_CLIST(DLClist), RowData);
      DeleteDLink(CircuitData, RowTab[RowCounter]);
    }
  UpdateLLClist();
  UpdateDLClist();
  UpdateCircuitView(UCVModification);
  CircuitData->Info.NewModification = True;
  free(RowTab);
  IRQ(False);
}

void cb_AutoSort(GtkWidget *Button, GtkWidget *DLClist)
{
  GCD *CircuitData; 

  if (IRQ(True) == False)
    return;
  CircuitData =  GetCircuitData();
  AutoSort(CircuitData);
  UpdateDLClist();
  CircuitData->Info.NewModification = True;
  IRQ(False);
}

void UpdateLLClist(void)
{
  GCD *CircuitData;
  Link LinkProp;
  DrawLink DLinkProp;
  Component CompoStartProp, CompoEndProp;
  AttachPoint AttachStartProp, AttachEndProp;
  int *LinkIDTab, LinkNb, Counter, NewRow;
  GtkWidget *LLClist;
  GtkStyle *Style;
  GdkColor Color;

  char Buffer[BufferLength], *StringPointer;
  gchar *NewLink[LLColumnNb] = { "","","",""};
  
  CircuitData =  GetCircuitData();
  CircuitData->Info.NewModification = True;
  LLClist = CircuitData->Info.LLClist;
   
  gtk_clist_freeze(GTK_CLIST(LLClist));
  gtk_clist_clear(GTK_CLIST(LLClist));

  GetLinkNumber(CircuitData, &LinkNb);
  if (LinkNb == 0 )
    { 
      gtk_clist_thaw(GTK_CLIST(LLClist));
      return;
    }
  
  LinkIDTab = (int *) malloc(sizeof(int) * LinkNb);
  GetAllLink(CircuitData, LinkIDTab);
  Style = gtk_style_copy(GTK_WIDGET(LLClist)->style);
  for (Counter = 0 ; Counter < LinkNb ; Counter++)
    {
      NewRow = gtk_clist_append( GTK_CLIST(LLClist), NewLink);
      gtk_clist_set_row_data( GTK_CLIST(LLClist), NewRow, GINT_TO_POINTER(LinkIDTab[Counter]));
      
      GetLinkProperties(CircuitData , LinkIDTab[Counter], &LinkProp);
      GetDLinkProperties(CircuitData , LinkIDTab[Counter], &DLinkProp); 
      /* si le lien n est pas dans la DL les valeurs de DLinkProp ne seront pas lues */
      
      if (CircuitData->Info.Opt.NoLinkColor == False)
	{
/* 	  Color.red = LinkProp.LinkColor.Red; */
/* 	  Color.green = LinkProp.LinkColor.Green; */
/* 	  Color.blue = LinkProp.LinkColor.Blue; */
	  Color.red = 0xff;
	  Color.green = 0x00;
	  Color.blue = 0x00;
	  Style->bg[GTK_STATE_SELECTED] = Color;
	  Style->fg[GTK_STATE_NORMAL] = Color;
	  gtk_clist_set_row_style(GTK_CLIST(LLClist), NewRow, Style);
	}
      CreateLinkStatePixmap(CircuitData, LinkProp, DLinkProp, LLClist, NewRow, False);
      if (LinkProp.StartAttachID != ExceptionAttach)
	{
	  GetAttachPointProperties(CircuitData, LinkProp.StartAttachID, &AttachStartProp);
	  GetComponentProperties(CircuitData, AttachStartProp.ComponentID, &CompoStartProp, False);
	  sprintf(Buffer, "%s - %s", CompoStartProp.ComponentName, AttachStartProp.AttachPointName);
	  StringPointer = Buffer;
	  gtk_clist_set_text(GTK_CLIST(LLClist), NewRow, 1, StringPointer);
	}
      else 
	gtk_clist_set_text(GTK_CLIST(LLClist), NewRow, 1, "??? - ???");

      if (LinkProp.EndAttachID != ExceptionAttach)
	{
	  GetAttachPointProperties(CircuitData, LinkProp.EndAttachID, &AttachEndProp);
	  GetComponentProperties(CircuitData, AttachEndProp.ComponentID, &CompoEndProp, False);
	  sprintf(Buffer, "%s - %s", CompoEndProp.ComponentName, AttachEndProp.AttachPointName);
	  StringPointer = Buffer;
	  gtk_clist_set_text(GTK_CLIST(LLClist), NewRow, 2, StringPointer);
	}
      else 
	gtk_clist_set_text(GTK_CLIST(LLClist), NewRow, 2, "??? - ???");

      if (IsLinkFull(LinkProp.State))
	sprintf(Buffer, " %3d / %3d ", LinkProp.LinkWidth, LinkProp.LinkLength);
      else
	sprintf(Buffer, " %3d / - ", LinkProp.LinkWidth);
      
      StringPointer = Buffer;
      gtk_clist_set_text(GTK_CLIST(LLClist), NewRow, 3, StringPointer);

      if (IsLinkSelected(LinkProp.State))
	gtk_clist_select_row( GTK_CLIST( LLClist), NewRow, 0);
    }

  gtk_clist_thaw(GTK_CLIST(LLClist));
  free(LinkIDTab);
}
void UpdateDLClist(void)
{
  GCD *CircuitData;
  DrawLink DLinkProp;
  Link LinkProp;
  Component CompoStartProp, CompoEndProp;
  AttachPoint AttachStartProp, AttachEndProp;
  int *DLinkIDTab, DLinkNb, Counter, NewRow;
  GtkStyle *Style = NULL;
  GdkColor Color;
  GtkWidget *DLClist;
  gchar *NewDLink[DLColumnNb] = { "", "", "", "", ""};
  char Buffer[BufferLength], *StringPointer;

  CircuitData =  GetCircuitData();
  CircuitData->Info.NewModification = True;
  DLClist = CircuitData->Info.DLClist;

  gtk_clist_freeze(GTK_CLIST(DLClist));
  gtk_clist_clear(GTK_CLIST(DLClist));

  GetDLinkNumber(CircuitData, &DLinkNb);
  if (DLinkNb == 0 )
    { 
      gtk_clist_thaw(GTK_CLIST(DLClist));
      return;
    }
  
  DLinkIDTab = (int *) malloc(sizeof(int) * DLinkNb);
  GetAllDLink(CircuitData, DLinkIDTab, &DLinkNb, Maybe);
  Style = gtk_style_copy(GTK_WIDGET(DLClist)->style);
  for (Counter = 0 ; Counter < DLinkNb ; Counter++)
    {
      NewRow = gtk_clist_append( GTK_CLIST(DLClist), NewDLink);
      gtk_clist_set_row_data( GTK_CLIST(DLClist), NewRow, GINT_TO_POINTER(DLinkIDTab[Counter]));

      GetLinkProperties(CircuitData, DLinkIDTab[Counter], &LinkProp);
      GetDLinkProperties(CircuitData, DLinkIDTab[Counter], &DLinkProp);
      /* si le lien n est pas dans la DL les valeurs de DLinkProp ne seront pas lues */
      if (CircuitData->Info.Opt.NoLinkColor == False)
	{
	  Color.red = LinkProp.LinkColor.Red;
	  Color.green = LinkProp.LinkColor.Green;
	  Color.blue = LinkProp.LinkColor.Blue;
	  Style->bg[GTK_STATE_SELECTED] = Color;
	  Style->fg[GTK_STATE_NORMAL] = Color;
	  gtk_clist_set_row_style(GTK_CLIST(DLClist), NewRow, Style);
	}
           
      CreateLinkStatePixmap(CircuitData, LinkProp, DLinkProp, DLClist, NewRow, True);
      
      GetAttachPointProperties(CircuitData, LinkProp.StartAttachID, &AttachStartProp);
      GetAttachPointProperties(CircuitData, LinkProp.EndAttachID, &AttachEndProp);
      GetComponentProperties(CircuitData, AttachStartProp.ComponentID, &CompoStartProp, False);
      GetComponentProperties(CircuitData, AttachEndProp.ComponentID, &CompoEndProp, False);
      sprintf(Buffer, "%s - %s", CompoStartProp.ComponentName, AttachStartProp.AttachPointName);
      StringPointer = Buffer;
      gtk_clist_set_text(GTK_CLIST(DLClist), NewRow, 1, StringPointer);

      sprintf(Buffer, "%s - %s", CompoEndProp.ComponentName, AttachEndProp.AttachPointName);
      StringPointer = Buffer;
      gtk_clist_set_text(GTK_CLIST(DLClist), NewRow, 2, StringPointer);
      
      sprintf(Buffer," %3d / %3d ", DLinkProp.LinkWidth, DLinkProp.LinkLength);
      StringPointer = Buffer;
      gtk_clist_set_text(GTK_CLIST(DLClist), NewRow, 3, StringPointer);

      if (LinkProp.RoutedOrder != NoOrder)
	sprintf(Buffer," %3d ", LinkProp.RoutedOrder);
      else 
	sprintf(Buffer," -NoOrder-  ");
      
      StringPointer = Buffer;
      gtk_clist_set_text(GTK_CLIST(DLClist), NewRow, 4, StringPointer);
     
      if (IsDLinkSelected(DLinkProp.State))
	gtk_clist_select_row( GTK_CLIST( DLClist), NewRow, 0);
    }
  gtk_clist_thaw(GTK_CLIST(DLClist));
  
  free(DLinkIDTab);
}

void CreateLinkStatePixmap(GCD *CircuitData, Link LinkProp, DrawLink DLinkProp, GtkWidget *XLClist, int Row, Boolean SelectionFromLinkList)
{ /* modified version of create_pixmap() from glade */
  GtkWidget *pixmap;
  GdkColormap *colormap;
  GdkPixmap *gdkpixmap;
  GdkBitmap *mask;
  gchar file[BufferLength];
  FILE *PixmapFile;
  gchar filename[BufferLength];
  char Buffer[BufferLength];
  
  if (!IsLinkFull(LinkProp.State))
    {
      if ((LinkProp.StartAttachID == ExceptionAttach) && (LinkProp.EndAttachID == ExceptionAttach))
	strncpy(filename, "xroadmaker/notfull.xpm", BufferLength);
      else
	{
	  if (LinkProp.StartAttachID == ExceptionAttach) 
	    strncpy(filename, "xroadmaker/endok.xpm", BufferLength);
	  if (LinkProp.EndAttachID == ExceptionAttach) 
	    strncpy(filename, "xroadmaker/startok.xpm", BufferLength);
	}
      strncpy(Buffer, "Not Full", BufferLength);
    }
  
  if (IsLinkFull(LinkProp.State) && !IsLinkDLSelected(LinkProp.State))
    {
      strncpy(filename, "xroadmaker/full.xpm", BufferLength);
      strncpy(Buffer, "Full", BufferLength);
    }
  
  if (IsLinkFull(LinkProp.State) && IsLinkDLSelected(LinkProp.State) 
      && !IsLinkRouted(LinkProp.State) && 
      (((SelectionFromLinkList == True)  && !IsLinkSelected(LinkProp.State)) 
       || ((SelectionFromLinkList == False) && !IsDLinkSelected(DLinkProp.State)))) 
    {
      strncpy(filename, "xroadmaker/track.xpm", BufferLength);
      strncpy(Buffer, "ToBeRouted", BufferLength);
    }
  
  if (IsLinkFull(LinkProp.State) && IsLinkDLSelected(LinkProp.State) 
      && !IsLinkRouted(LinkProp.State) &&
      (((SelectionFromLinkList == True)  && IsLinkSelected(LinkProp.State)) 
       || ((SelectionFromLinkList == False) && IsDLinkSelected(DLinkProp.State)))) 
    {
      strncpy(filename, "xroadmaker/trackselect.xpm", BufferLength);
      strncpy(Buffer, "ToBeRouted", BufferLength);
    }
    
  if (IsLinkFull(LinkProp.State) && IsLinkDLSelected(LinkProp.State) 
      && IsLinkRouted(LinkProp.State) &&
      ( ((SelectionFromLinkList == True)  && !IsLinkSelected(LinkProp.State)) 
       || ((SelectionFromLinkList == False) && !IsDLinkSelected(DLinkProp.State)))) 
    {
      strncpy(filename, "xroadmaker/road.xpm", BufferLength);
      strncpy(Buffer, "Routed", BufferLength);
    }
  if (IsLinkFull(LinkProp.State) && IsLinkDLSelected(LinkProp.State) 
      && IsLinkRouted(LinkProp.State) && 
      (((SelectionFromLinkList == True)  && IsLinkSelected(LinkProp.State)) 
       || ((SelectionFromLinkList == False) && IsDLinkSelected(DLinkProp.State)))) 
    {
      strncpy(filename, "xroadmaker/roadselect.xpm", BufferLength);
      strncpy(Buffer, "Routed", BufferLength);
    }
  
  filename[BufferLength-1] = '\0';
  Buffer[BufferLength-1] = '\0';
  
  if (CircuitData->Info.Opt.NoLinkIcon == True)
    gtk_clist_set_text(GTK_CLIST(XLClist), Row, 0, Buffer);
  else
    {
      sprintf(file,"%s/%s",  XROADMAKER_PIXMAP_PATH, filename);
      
      if ((PixmapFile = fopen(file, "r")) == NULL)
	{
	  g_warning (_("Couldn't find pixmap file: %s"), file);
	  pixmap = create_dummy_pixmap (XLClist, FALSE);
	}
      
      colormap = gtk_widget_get_colormap (XLClist);
      gdkpixmap = gdk_pixmap_colormap_create_from_xpm (NULL, colormap, &mask,
						       NULL, file);
      if (gdkpixmap == NULL)
	{
	  g_warning (_("Couldn't create pixmap from file: %s"), file);
	  pixmap =  create_dummy_pixmap (XLClist, FALSE);
	}
      gtk_clist_set_pixmap(GTK_CLIST(XLClist), Row, 0, gdkpixmap, mask);
      gdk_pixmap_unref (gdkpixmap);
      gdk_bitmap_unref (mask);
     }
  
}

void cb_ScrollUp(GtkWidget *Button, GtkWidget *LinkWindow)
{
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  ScrollUp(CircuitData);
  UpdateDLClist();
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_ScrollDown(GtkWidget *Button, GtkWidget *LinkWindow)
{
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  ScrollDown(CircuitData);
  UpdateDLClist();
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_ScrollTop(GtkWidget *Button, GtkWidget *LinkWindow)
{
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  ScrollTop(CircuitData);
  UpdateDLClist();
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_ScrollBottom(GtkWidget *Button, GtkWidget *LinkWindow)
{
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  ScrollBottom(CircuitData);
  UpdateDLClist();
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_SelectAllRoutedDLink (GtkButton *button, GtkWidget *DLClist)
{
  int  RowNb, RowCounter, RowData, *RowTab, DLinkNb;
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetDLinkNumber( CircuitData, &RowNb);
  if (RowNb == 0)
    {
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(DLClist));
  RowTab = (int *) malloc (RowNb * sizeof(int));
    
  GetAllDLink( CircuitData, RowTab, &DLinkNb, Maybe);
  for (RowCounter = 0 ; RowCounter < DLinkNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_unselect_row( GTK_CLIST( DLClist), RowData, 0);
    }

  GetAllDLink( CircuitData, RowTab, &DLinkNb, True);
  for (RowCounter = 0 ; RowCounter < DLinkNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_select_row( GTK_CLIST( DLClist), RowData, 0);
    }

  free(RowTab);
  gtk_clist_thaw(GTK_CLIST(DLClist));
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
  
void cb_SelectAllUnRoutedDLink (GtkButton *button,  GtkWidget *DLClist)
{
  int  RowNb, RowCounter, RowData, *RowTab, DLinkNb;

  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetDLinkNumber( CircuitData, &RowNb);
  if (RowNb == 0)
    {
      IRQ(False);
      return;
    }
  gtk_clist_freeze(GTK_CLIST(DLClist));

  RowTab = (int *) malloc (RowNb * sizeof(int));

  GetAllDLink( CircuitData, RowTab, &DLinkNb, Maybe);
  for (RowCounter = 0 ; RowCounter < DLinkNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_unselect_row( GTK_CLIST( DLClist), RowData, 0);
    }

  GetAllDLink( CircuitData, RowTab, &DLinkNb, False);
  for (RowCounter = 0 ; RowCounter < DLinkNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      gtk_clist_select_row( GTK_CLIST( DLClist), RowData, 0);
    }
  
  free(RowTab);
  gtk_clist_thaw(GTK_CLIST(DLClist));
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_UnRouteDLink (GtkButton *button,  GtkWidget *DLClist)
{
  GtkWidget *Window;
  
  Window = create_LinkUndrawWarning();
  gtk_widget_show(Window);
}
void cb_CFM_UnRouteDLink (GtkButton *button,  GtkWidget *Window)
{
  GtkWidget *DLClist;
  int RowNb, RowCounter, *RowTab, DLinkNb, RowData;
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  DLClist = CircuitData->Info.DLClist;
  GetDLinkNumber( CircuitData, &DLinkNb);
  RowTab = (int *) malloc( sizeof(int) * DLinkNb);

  GetSelectDLink( CircuitData, RowTab, &RowNb );
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    {
      RowData = gtk_clist_find_row_from_data( GTK_CLIST( DLClist), GINT_TO_POINTER(RowTab[RowCounter]));
      UnDrawLink(CircuitData, RowTab[RowCounter]);
    }

  CircuitData->Info.NewModification = True;
  UpdateCircuitView(UCVModification);
  UpdateLLClist();
  UpdateDLClist();
  free(RowTab);
  IRQ(False);
}

void cb_StartRouting (GtkButton *button, gpointer user_data)
{
  GCD *CircuitData;
  int AttachNb, DLinkNb, IntegritySize, TabSize;
  Integrity *IntegrityTab = NULL;
  ErrorCheck Check = Found;
  GtkWidget *Window, *ProgressBarTrack, *ProgressBarRouter, *RouterLabel, *TrackLabel, *OkRouter, *Separator, 
    *RouterStatus;
  
  if (IRQ(True) == False)
    return;
  CircuitData =  GetCircuitData();
  GetAttachPointNumber(CircuitData, &AttachNb);
  GetDLinkNumber(CircuitData, &DLinkNb);
  if ((AttachNb == 0) || (DLinkNb == 0))
    {
      Window = create_NoDLinkNoAttach();
      gtk_widget_show(Window);
      IRQ(False);
      return;
    }
  if (CircuitData->Info.NamedFile == False)
    {
      Window = create_NoNameInfo();
      gtk_widget_show(Window);
      IRQ(False);
      return;
    }

  GetAttachPointNumber(CircuitData, &TabSize);
  TabSize = 2 * TabSize + DLinkNb;
  IntegritySize = 0;
  if (TabSize != 0)
    {
      IntegrityTab = (Integrity *)malloc(sizeof(Integrity) * TabSize);
      CheckCircuitIntegrity(CircuitData, IntegrityTab, &IntegritySize);
      
      if (IntegritySize != 0)
	{
	  ShowCircuitIntegrity(IntegrityTab, IntegritySize);
	  free(IntegrityTab);
	  return;
	}
      else
	free(IntegrityTab);
    }
 
  CircuitData->Info.RouterCancelRequest = False;
  RouterStatus = create_RouterStatusWindow();
  OkRouter = gtk_object_get_data(GTK_OBJECT(RouterStatus), "OkRouter");
  gtk_widget_set_sensitive(GTK_WIDGET(OkRouter), FALSE);
  CircuitData->Info.ProgressBarRouter = gtk_object_get_data(GTK_OBJECT(RouterStatus), "ProgressBarRouter");
  CircuitData->Info.ProgressBarTrack = gtk_object_get_data(GTK_OBJECT(RouterStatus), "ProgressBarTrack");
  CircuitData->Info.RouterLabel = gtk_object_get_data(GTK_OBJECT(RouterStatus), "RouterLabel");
  CircuitData->Info.TrackLabel = gtk_object_get_data(GTK_OBJECT(RouterStatus), "TrackLabel");
  if (CircuitData->Info.Opt.UseMagic == True)
    {
      gtk_widget_show(RouterStatus);
      Check = MagicRouting(CircuitData);
    }
  else
    {
      gtk_widget_hide(GTK_WIDGET(CircuitData->Info.ProgressBarRouter));
      gtk_widget_hide(GTK_WIDGET(CircuitData->Info.RouterLabel));
      Separator = gtk_object_get_data(GTK_OBJECT(RouterStatus), "Separator");
      gtk_widget_hide(GTK_WIDGET(Separator));
      gtk_widget_show(RouterStatus);
  
      Check = MediumRouting(CircuitData, False);
    }
  
  gtk_widget_set_sensitive(GTK_WIDGET(OkRouter), TRUE);
  if (Check == NotFound) 
    {
      if (CircuitData->Info.RouterCancelRequest == False)
	Window = create_RouterFail();
      else
	Window = create_RouterCancel();
      
      gtk_widget_show(Window);
    }
      
  UpdateCircuitView(UCVModification);
  CircuitData->Info.NewModification = True;
  UpdateLLClist();
  UpdateDLClist();
  IRQ(False);
}
void cb_Paint (GtkButton *button, GtkWidget *ColorPicker)
{
  GCD *CircuitData;
  int RowNb, *RowTab, RowCounter;
  gushort Red, Green, Blue, Alpha;
  
  if (IRQ(True) == False)
    return;
  gnome_color_picker_get_i16(GNOME_COLOR_PICKER(ColorPicker), &Red, &Green, &Blue, &Alpha);
    
  CircuitData = GetCircuitData();
  GetLinkNumber( CircuitData, &RowNb);
  if (RowNb ==0)
    return;
  RowTab = (int *) malloc (RowNb * sizeof(int));
  GetSelectLink(CircuitData, RowTab, &RowNb);
 
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    SetLinkColor(CircuitData, RowTab[RowCounter], Red, Green, Blue);

  UpdateLLClist();
  UpdateDLClist();
  free(RowTab);
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_ExtendColor (GtkButton *button, gpointer user_data)
{
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  ExtendByColor(CircuitData);
  UpdateLLClist();
  IRQ(False);
}
void cb_PaintDLink (GtkButton *button, GtkWidget *ColorPicker)
{
  GCD *CircuitData;
  int RowNb, *RowTab, RowCounter;
  gushort Red, Green, Blue, Alpha;
  
  if (IRQ(True) == False)
    return;
  gnome_color_picker_get_i16(GNOME_COLOR_PICKER(ColorPicker), &Red, &Green, &Blue, &Alpha);
    
  CircuitData = GetCircuitData();
  GetDLinkNumber( CircuitData, &RowNb);
  if (RowNb ==0)
    return;

  RowTab = (int *) malloc (RowNb * sizeof(int));
  GetSelectDLink(CircuitData, RowTab, &RowNb);
 
  for (RowCounter = 0 ; RowCounter < RowNb ; RowCounter++)
    SetLinkColor(CircuitData, RowTab[RowCounter], Red, Green, Blue);

  UpdateLLClist();
  UpdateDLClist();
  free(RowTab);
  CircuitData->Info.NewModification = True;
  IRQ(False);
}
void cb_ExtendColorDLink (GtkButton *button, gpointer user_data)
{
  GCD *CircuitData;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  ExtendByColorDLink(CircuitData);
  UpdateDLClist();
  IRQ(False);
}
  
