
#include "xrmtypes.h"
#include "menu.h"
#include "mainwindow.h"
#include "interface.h"
#include "filemng.h"
#include "circuitviewwindow.h"
#include "liste.h"
#include "fig.h"
#include "attachpoint.h"
#include "miscwindows.h"

/* Menu File */ /** ************************************ **/
/* New */
void on_New_Circuit_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  if (CircuitData->Info.NewModification == True)
    {
      GtkWidget *NewWarning;
      
      NewWarning = create_NewWarning();
      gtk_widget_show(NewWarning);
    }
  else
    on_New();
}

void on_CFM_Save_and_New_activate(GtkButton *button, gpointer user_data)
{
  GtkWidget *Window;
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  if ( CircuitData->Info.NamedFile == False)
    {
      Window = create_SaveAndNewWindow();     
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(Window), CircuitData->Info.Opt.CircuitDirectory);
      gtk_widget_show( Window);
    }
  else
    {
      if (IRQ(True) == False)
	return;
      if (on_Save(NULL) == AllOk)
	on_New();
      IRQ(False);
    }
}
void on_CFM_New_activate(GtkButton *button, gpointer user_data)
{
  if (IRQ(True) == False)
    return;
  on_New();
  IRQ(False);
}
/* Open */
void on_Open_Circuit_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  if (CircuitData->Info.NewModification == True)
    {
      GtkWidget *OpenWarning;

      OpenWarning = create_OpenWarning();
      gtk_widget_show(OpenWarning);
    }
  else
    {
      if (IRQ(True) == False)
	return;
      on_Open();
      IRQ(False);
    }
}
void on_CFM_Save_and_Open_activate(GtkButton *button, gpointer user_data)
{
  GtkWidget *Window;
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  if (CircuitData->Info.NamedFile == False)
    {
      Window = create_SaveAndOpenWindow();
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(Window), CircuitData->Info.Opt.CircuitDirectory);
      gtk_widget_show( Window);
    }
  else
    {
      if (IRQ(True) == False)
	return;
      if (on_Save(NULL) == AllOk)
	on_Open();
      IRQ(False);
    }
}

void on_CFM_Open_activate(GtkButton *button, gpointer user_data)
{
  if (IRQ(True) == False)
    return;
  on_Open();
  IRQ(False);
}
/* Revert */
void on_Revert_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  if (CircuitData->Info.NamedFile == False)
    {
      GtkWidget *RevertErrorWindow;
      RevertErrorWindow = create_RevertError();
      gtk_widget_show(RevertErrorWindow);
    }
  else
    {
      GtkWidget *RevertWarning;
      RevertWarning = create_RevertWarning();
      gtk_widget_show(RevertWarning);
    }
}
void on_CFM_Revert_activate(GtkButton *button, gpointer user_data)
{
  if (IRQ(True) == False)
    return;
  on_Revert();
  IRQ(False);
}
/* Exit */
void on_Exit_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  if (CircuitData->Info.NewModification == True)
    {
      GtkWidget *ExitWarning;

      ExitWarning = create_ExitWarning();
      gtk_widget_show(ExitWarning);
    }
  else
    {
      if (IRQ(True) == False)
	return;
      on_Exit();
    }
}
void on_CFM_Save_and_Exit_activate(GtkButton *button, gpointer user_data)
{
  GtkWidget *Window;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  if ( CircuitData->Info.NamedFile == False)
    {
      Window = create_SaveAndExitWindow();
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(Window), CircuitData->Info.Opt.CircuitDirectory);
      gtk_widget_show( Window);
    }
  else
    {
      if (IRQ(True) == False)
	return;
      if (on_Save(NULL) == AllOk)
	on_Exit();
    }
}
void on_CFM_Exit_activate(GtkButton *button, gpointer user_data)
{
  if (IRQ(True) == False)
    return;
  on_Exit();
}
/* New */
void on_New(void)
{
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  OpenEmptyFile(CircuitData);
  CircuitData->Info.NamedFile = False;
  CircuitData->Info.NewModification = False;
  UpdateCircuitView(UCVModification);
}

/* Open */
void on_Open(void)
{
  GtkWidget *FileSelect;
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  FileSelect = create_CircuitOpenWindow ();
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(FileSelect), CircuitData->Info.Opt.CircuitDirectory);
  gtk_widget_show(FileSelect);
}
void cb_OpenFileDialog (GtkWidget *Window, GtkWidget *FileSelect)
{
  gchar  *FileToOpen;
  ErrorCheck Check;
  GtkWidget *FileInfoWindow, *Text;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  FileToOpen = gtk_file_selection_get_filename (GTK_FILE_SELECTION (FileSelect));
  
  Text = NULL;
  FileInfoWindow = NULL;
  if (CircuitData->Info.Opt.OpenInformation == True)
    {
      FileInfoWindow = create_FileInfoWindow();
      Text = gtk_object_get_data(GTK_OBJECT(FileInfoWindow), "FileInfoText");
    }
  Check = OpenCircuitFile(CircuitData, FileToOpen, Text);
  
  if (Check == FileAccessError)
    {
      GtkWidget *Window;
      if (FileInfoWindow != NULL)
	gtk_widget_show(FileInfoWindow);
      Window = create_OpenError();
      gtk_widget_show(Window);
    }
  else
    {
      if (FileInfoWindow != NULL)
	gtk_widget_show(FileInfoWindow);
      CircuitData->Info.NamedFile = True;
      strncpy(CircuitData->Info.CircuitFileName, FileToOpen, FileNameLength);
      CircuitData->Info.CircuitFileName[FileNameLength-1] = '\0';
      CircuitData->Info.NewModification = False;
    }
}
/* Save */
void on_Save_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget *Window;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  if (CircuitData->Info.NamedFile == False)
    {
      Window = create_CircuitSaveWindow();
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(Window), CircuitData->Info.Opt.CircuitDirectory);
      gtk_widget_show( Window);
    }
  else
    {
      if (IRQ(True) == False)
	return;
      on_Save(NULL);
      IRQ(False);
    }
}

void on_Save_As_activate (GtkMenuItem *menuitem, gpointer user_data)
{

  GtkWidget *Window;
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  Window = create_CircuitSaveWindow();
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(Window), CircuitData->Info.Opt.CircuitDirectory);
  gtk_widget_show(Window);
}

void cb_SaveFileDialog (GtkWidget *Widget, GtkWidget *Window)
{
  gchar  *FileToSave;
  
  if (IRQ(True) == False)
    return;
  FileToSave = gtk_file_selection_get_filename (GTK_FILE_SELECTION (Window));
  
  on_Save(FileToSave);
  IRQ(False);
}

ErrorCheck on_Save(char *FileName)
{
  char *CircuitFileName;
  ErrorCheck Check;
  GtkWidget *FileInfoWindow, *Text;
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  if (FileName == NULL)
    CircuitFileName = CircuitData->Info.CircuitFileName;
  else
    CircuitFileName = FileName;

  Text = NULL;
  FileInfoWindow = NULL;
  if (CircuitData->Info.Opt.SaveInformation == True)
    {
      FileInfoWindow = create_FileInfoWindow();
      Text = gtk_object_get_data(GTK_OBJECT(FileInfoWindow), "FileInfoText");
    }
  Check = SaveCircuitFile(CircuitData, CircuitFileName, Text);
  
  if (Check == FileAccessError)
    {
      GtkWidget *Window;
      
      if (FileInfoWindow != NULL)
	gtk_widget_destroy(FileInfoWindow);
      
      Window = create_SaveError();
      gtk_widget_show(Window);
      return FileAccessError;
    }
  else
    {
      if (FileInfoWindow != NULL)
	gtk_widget_show(FileInfoWindow);
      strncpy(CircuitData->Info.CircuitFileName, CircuitFileName, FileNameLength);
      CircuitData->Info.CircuitFileName[FileNameLength-1] = '\0';
      CircuitData->Info.NamedFile = True;
      CircuitData->Info.NewModification = False;
      return AllOk;
    }
}

void on_Revert(void)
{
  char *CircuitFileName;
  ErrorCheck Check;
  GtkWidget *FileInfoWindow, *Text;
  GCD *CircuitData;

  CircuitData =  GetCircuitData();
  CircuitFileName = CircuitData->Info.CircuitFileName;
  Text = NULL;
  FileInfoWindow = NULL;
  
  if (CircuitData->Info.Opt.RevertInformation == True)
    { 
      FileInfoWindow = create_FileInfoWindow(); 
      Text = gtk_object_get_data(GTK_OBJECT(FileInfoWindow), "FileInfoText");
    }
  Check = OpenCircuitFile(CircuitData, CircuitFileName, Text);
  
  if (Check == FileAccessError)
    {
      GtkWidget *Window;
      
      if (FileInfoWindow != NULL)
	gtk_widget_destroy(FileInfoWindow);
      Window = create_OpenError();
      gtk_widget_show(Window);
    }
  else
    {
      if (FileInfoWindow != NULL)
	gtk_widget_show(FileInfoWindow);
      CircuitData->Info.NewModification = True;
      UpdateCircuitView(UCVModification);
    }
}

void on_Exit(void)
{
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  DeleteCircuitData(CircuitData, True);
  gtk_main_quit(); 
}

void cb_SaveAndNewFileDialog_activate (GtkButton *button, GtkWidget *Window)
{
  gchar  *FileToSave;
  
  if (IRQ(True) == False)
    return;

  FileToSave = gtk_file_selection_get_filename (GTK_FILE_SELECTION (Window));
  if (on_Save(FileToSave) == AllOk)
    on_New();
  IRQ(False);
}


void
cb_SaveAndOpenFileDialog_activate (GtkButton *button, GtkWidget *Window)
{
  gchar  *FileToSave;
  
  if (IRQ(True) == False)
    return;
  FileToSave = gtk_file_selection_get_filename (GTK_FILE_SELECTION (Window));
  
  if (on_Save(FileToSave) == AllOk)
    on_Open();
  IRQ(False);
}

void cb_SaveAndExitFileDialog_activate (GtkButton *button, GtkWidget *Window)
{
  gchar  *FileToSave;

  if (IRQ(True) == False)
    return;
  FileToSave = gtk_file_selection_get_filename (GTK_FILE_SELECTION (Window));
  
  if (on_Save(FileToSave) == AllOk)
    on_Exit();
  else
    IRQ(False);
}

/* ***************  Fin du menu File */
/* Menu Window ***********************/
void on_Show_Component_Tree_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget  *WindowToShow;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  WindowToShow = CircuitData->Info.ComponentWindow;
  gtk_widget_show(WindowToShow);
  gdk_window_raise(GTK_WIDGET(WindowToShow)->window);
}


void on_Hide_Component_Tree_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget *WindowToHide;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  WindowToHide = CircuitData->Info.ComponentWindow;
  gtk_widget_hide(WindowToHide);
}
void on_Show_Link_Window_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget  *WindowToShow;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  WindowToShow = CircuitData->Info.LinkWindow;
  gtk_widget_show(WindowToShow);
  gdk_window_raise(GTK_WIDGET(WindowToShow)->window);
}

void on_Hide_Link_Window_activate(GtkMenuItem *menuitem, gpointer user_data)
{
 GtkWidget  *WindowToHide;
 GCD *CircuitData;
 
 CircuitData = GetCircuitData();
 WindowToHide = CircuitData->Info.LinkWindow;
 gtk_widget_hide(WindowToHide);
}

void on_Show_Circuit_View_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget  *WindowToShow;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  WindowToShow = CircuitData->Info.CircuitViewWindow;
  gtk_widget_show(WindowToShow);
  gdk_window_raise(GTK_WIDGET(WindowToShow)->window);
  UpdateCircuitView(UCVDemand);
}

void on_Hide_Circuit_View_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget  *WindowToHide;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  WindowToHide = CircuitData->Info.CircuitViewWindow;
  gtk_widget_hide(WindowToHide);
}

void on_Show_All_Windows_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget  *WindowToShow;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();

  WindowToShow = CircuitData->Info.ComponentWindow;
  gtk_widget_show(WindowToShow);
  gdk_window_raise(GTK_WIDGET(WindowToShow)->window);
  WindowToShow = CircuitData->Info.LinkWindow;
  gtk_widget_show(WindowToShow);
  gdk_window_raise(GTK_WIDGET(WindowToShow)->window);
  WindowToShow = CircuitData->Info.CircuitViewWindow;
  gtk_widget_show(WindowToShow);
  gdk_window_raise(GTK_WIDGET(WindowToShow)->window);
}

void on_Hide_All_Windows_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget  *WindowToHide;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();

  WindowToHide = CircuitData->Info.ComponentWindow;
  gtk_widget_hide(WindowToHide);
  WindowToHide = CircuitData->Info.LinkWindow;
  gtk_widget_hide(WindowToHide);
  WindowToHide = CircuitData->Info.CircuitViewWindow;
  gtk_widget_hide(WindowToHide);
}

void on_About_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  if (CircuitData->Info.AboutWindow == NULL)
    CircuitData->Info.AboutWindow = create_AboutWindow();
  gtk_widget_show (CircuitData->Info.AboutWindow);
  gdk_window_raise(GTK_WIDGET(CircuitData->Info.AboutWindow)->window);
}

void cb_ExportXFig_activate (GtkMenuItem *menuitem, gpointer data)
{
  GtkWidget *Window;
  GCD *CircuitData;
  int TabSize, IntegritySize;
  Integrity *IntegrityTab;

  CircuitData = GetCircuitData();
  GetAttachPointNumber(CircuitData, &TabSize);
  IntegrityTab = (Integrity *)malloc(sizeof(Integrity) * TabSize);
  
  CheckCircuitIntegrity(CircuitData, IntegrityTab, &IntegritySize);
  if (IntegritySize != 0)
    ShowCircuitIntegrity(IntegrityTab, IntegritySize);
  else
    {
      Window = create_FigSaveWindow();
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(Window), CircuitData->Info.Opt.CircuitDirectory);
      gtk_widget_show(Window);
    }
}
void cb_FigSaveFialog (GtkButton *button, GtkWidget *FileSelect)
{
  gchar  *FileToOpen;
  ErrorCheck Check;
  GCD *CircuitData;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  FileToOpen = gtk_file_selection_get_filename (GTK_FILE_SELECTION (FileSelect));
    
  Check = ExportToFig(CircuitData, FileToOpen, CircuitData->CompLib);
  if (Check == FileAccessError)
    {
      GtkWidget *Window;
      Window = create_FigExportError();
      gtk_widget_show(Window);
    }
  IRQ(False);
}


void cb_UpdateCircuitView_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  UpdateCircuitView(UCVDemand);
}

void on_Center_View_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  CircuitData->Info.CVOrigin.x = 0;
  CircuitData->Info.CVOrigin.y = 0;
  UpdateCircuitView(UCVDemand);
}
