
#include "misc.h"
#include <stdio.h>

ErrorCheck FindNbInTab (int Nb, int *Tab, int TabSize)
{
  int Counter;
  for (Counter = 0; Counter < TabSize; Counter++)
    if (Nb == Tab[Counter])
      return Found;
  return NotFound;
}

ErrorCheck DisplayCircuit (Circuit Plate)
{
  int Counterx, Countery;
  for (Countery = 0; Countery < Plate.Height; Countery++)
    {
      for (Counterx = 0; Counterx < Plate.Width; Counterx++)
	if ( IsSquareUsed(Plate.SquareTab[Counterx][Countery].SquareState))
	  if (Plate.SquareTab[Counterx][Countery].AttachLinkNb != NoAttachLink)
	    printf("+%2d",Plate.SquareTab[Counterx][Countery].AttachLinkNb); 
	  else printf("---");
	else 
	  {
	    if ( IsFeatherUsed(Plate.SquareTab[Counterx][Countery].SquareState))
	      printf("***");
	    else
	      printf("%3d",Plate.SquareTab[Counterx][Countery].CalculatingLevelNb); 
	  }
      printf("\n");
    }
  return Found;
}

ErrorCheck DisplayEquiPot(EquiPotential Equi)
{
  int Counter;

  for (Counter = 0; Counter < Equi.Size ; Counter++)
    printf("Equi: Pt %d  %3d %3d\n",Counter, Equi.PointTab[Counter].x, Equi.PointTab[Counter].y);

  return AllOk;
}

ErrorCheck DisplayPath(RoadMap Map, int RoadNb)
{
  int Counter;

  for (Counter = 0; Counter < Map.Line[RoadNb].PathSize ; Counter++)
      printf("Equi %d : Point %d ... x %d  y %d\n", RoadNb,Counter, Map.Line[RoadNb].PathTab[Counter].x,
	     Map.Line[RoadNb].PathTab[Counter].y);
      
  return AllOk;
}

ErrorCheck DisplayDep(RoadMap Map, int RoadNb)
{
  int Counter;

  for (Counter = 0; Counter < Map.Line[RoadNb].DepSize ; Counter++)
    printf("Equi %d : Dep %d  Type %d ... Nb: %d\n", RoadNb,Counter, Map.Line[RoadNb].DepTab[Counter].Type,
	   Map.Line[RoadNb].DepTab[Counter].Nb);

  return AllOk;
}

ErrorCheck DisplaySeg(RoadMap Map)
{
  int Counter,Counter2;

  for (Counter = 0; Counter < Map.Size ; Counter++)
    for (Counter2 = 0 ; Counter2 < Map.Line[Counter].SegSize; Counter2++)
      printf("Road %d : Segment %d ... x %d  y %d x %d y %d\n", Counter,Counter2, Map.Line[Counter].SegTab[Counter2].Start.x,
	     Map.Line[Counter].SegTab[Counter2].Start.y, Map.Line[Counter].SegTab[Counter2].End.x,
	     Map.Line[Counter].SegTab[Counter2].End.y);

  return AllOk;
}

void DisplayCircuitProp (Circuit Board)
{
  int Counter, Counter2;
  printf("\t********************Circuit Properties Display********************\n");
  printf("Attach Point %d --> %p\n ", Board.AttachNb, Board.AttachTab);
  printf("Link %d --> %p\n", Board.LinkNb, Board.LinkTab);
  printf("Width %d\n",Board.Width);
  printf("Heigth %d\n",Board.Height);
  printf("Area %d --> %p\n",Board.AreaNb, Board.AreaTab);
  printf("Vortex %d --> %p\n",Board.VortexNb, Board.VortexTab);
  
  for (Counter = 0 ; Counter < Board.LinkNb ; Counter++)
   {
     printf("%d: %d ---> %d  -------  %d \n", Counter, Board.LinkTab[Counter].Start,  Board.LinkTab[Counter].End, 
	    Board.LinkTab[Counter].LinkSize);
     
     for (Counter2 = 0 ; Counter2 <  Board.LinkTab[Counter].LinkSize ; Counter2++)
       printf("%d: %d ---> \n", Counter2, Board.LinkTab[Counter].Link2Link[Counter2]);
   }
  
   for (Counter = 0 ; Counter < Board.AttachNb ; Counter++)
     {
       printf("%d: Size %d AttachLocationSize %d\n", Counter, Board.AttachTab[Counter].Size,Board.AttachTab[Counter].AttachLocationNb );
       for (Counter2 = 0 ; Counter2 <  Board.AttachTab[Counter].AttachLocationNb ; Counter2++)
	 printf("%d: x %d y %d  --->\n",Counter2, Board.AttachTab[Counter].AttachLocation[Counter2].x,Board.AttachTab[Counter].AttachLocation[Counter2].y);   
       
       for (Counter2 = 0 ; Counter2 <  Board.AttachTab[Counter].Size ; Counter2++)
	 printf("%d: Attach 2 Link %d \n", Counter2, Board.AttachTab[Counter].Attach2Link[Counter2]);
     }

   for (Counter = 0 ; Counter < Board.AreaNb ; Counter++)
     {
       printf("%d: Level %d Left %d Right %d Top %d Bottom %d\n", Counter, Board.AreaTab[Counter].Level,Board.AreaTab[Counter].LeftLimit, Board.AreaTab[Counter].RightLimit, Board.AreaTab[Counter].TopLimit, Board.AreaTab[Counter].BottomLimit);
     }
}
