
#include <stdlib.h>
#include <gnome.h>
#include "interface.h"
#include "miscwindows.h"
#include "liste.h"
#include "subfunction.h"
#include "component.h"
#include "attachpoint.h"
#include "dlink.h"
#include "filemng.h"

void cb_CheckCircuit (GtkMenuItem *menuitem, gpointer user_data)
{
  int IntegritySize, TabSize;
  Integrity *IntegrityTab = NULL;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  GetAttachPointNumber(CircuitData, &TabSize);
  IntegritySize = 0;
  if (TabSize != 0)
    {
      IntegrityTab = (Integrity *)malloc(sizeof(Integrity) * TabSize);
      CheckCircuitIntegrity(CircuitData, IntegrityTab, &IntegritySize);
    }

  if (IntegritySize != 0)
    ShowCircuitIntegrity(IntegrityTab, IntegritySize);
  else
    {
      GtkWidget *Window;
      Window = create_NoError();
      gtk_widget_show(Window);
    }
  if (IntegrityTab != NULL)
    free(IntegrityTab);
}

void ShowCircuitIntegrity(Integrity *IntegrityTab, int Size)
{
  GtkWidget *Window, *ErrorClist;
  
  Window = create_CircuitIntegrityWindow();
  ErrorClist = gtk_object_get_data(GTK_OBJECT(Window), "ErrorClist");
  FullErrorClist(ErrorClist, IntegrityTab, Size);
  gtk_widget_show(Window);
}

void FullErrorClist(GtkWidget *ErrorClist, Integrity *IntegrityTab, int Size)
{
  char Buffer[BufferLength*4]; /* car contient 4 noms */
  gchar *NewError[ErrorListColumnNb] = { "","",""};
  GCD *CircuitData;
  Component CompProp, CompProp2;
  SubFunction SubFProp, SubFProp2;
  DrawLink DLinkProp;
  int Counter, NewRow;
  CircuitData = GetCircuitData();
  
  gtk_clist_freeze(GTK_CLIST(ErrorClist));
  gtk_clist_clear(GTK_CLIST(ErrorClist));

  for (Counter = 0 ; Counter < Size ; Counter++)
    {
      NewRow = gtk_clist_append( GTK_CLIST(ErrorClist), NewError);
      switch (IntegrityTab[Counter].Priority)
	{
	case CriticalPriority : sprintf(Buffer,"Critical"); 
	  break;
	case WarningPriority : sprintf(Buffer,"Warning");
	  break;
	default : sprintf(Buffer,"Common");
	}
      gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 0, Buffer);
      
      switch (IntegrityTab[Counter].Type)
	{
	case OverlappingAttach : 
	  sprintf(Buffer,"Overlapping attachs"); 
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 1, Buffer);
	  
	  GetComponentProperties(CircuitData, 
				 IntegrityTab[Counter].TypeDependent.Overlap.ComponentInvolved, 
				 &CompProp, False); 
	  GetSubFunctionProperties(CircuitData, CompProp.SubFunctionID, &SubFProp);
	  GetComponentProperties(CircuitData, 
				 IntegrityTab[Counter].TypeDependent.Overlap.OtherComponentInvolved, 
				 &CompProp2, False); 
	  GetSubFunctionProperties(CircuitData, CompProp2.SubFunctionID, &SubFProp2);
	  
	  sprintf(Buffer, "at  %4d %4d -> Comp %s from %s and Comp %s from %s",
		  IntegrityTab[Counter].TypeDependent.Overlap.Location.x, 
		  IntegrityTab[Counter].TypeDependent.Overlap.Location.y, 
		  CompProp.ComponentName, SubFProp.Name,
		  CompProp2.ComponentName, SubFProp2.Name);
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 2, Buffer);
	  gtk_clist_set_row_data(GTK_CLIST(ErrorClist), NewRow, GINT_TO_POINTER(CompProp.IDNumber));
	  break;
	case OutOfCircuit : 
	  sprintf(Buffer,"Out of circuit");
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 1, Buffer);

	  GetComponentProperties(CircuitData,
				 IntegrityTab[Counter].TypeDependent.Out.ComponentInvolved, 
				 &CompProp, False); 
	  GetSubFunctionProperties(CircuitData, CompProp.SubFunctionID, &SubFProp);
	  
	  sprintf(Buffer, "at %4d %4d -> Comp %s from %s", 
		  IntegrityTab[Counter].TypeDependent.Out.Location.x, 
		  IntegrityTab[Counter].TypeDependent.Out.Location.y, 
		  CompProp.ComponentName, SubFProp.Name);
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 2, Buffer);
	  gtk_clist_set_row_data(GTK_CLIST(ErrorClist), NewRow, GINT_TO_POINTER(CompProp.IDNumber));
	  break;
	case LinkOutOfCircuit : 
	  sprintf(Buffer,"Out of circuit");
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 1, Buffer);
	  GetDLinkProperties(CircuitData ,IntegrityTab[Counter].TypeDependent.LinkOut.LinkInvolved, &DLinkProp);
	  sprintf(Buffer, "at %4d %4d -> Link %d", 
		  IntegrityTab[Counter].TypeDependent.LinkOut.Location.x, 
		  IntegrityTab[Counter].TypeDependent.LinkOut.Location.y, DLinkProp.RoutedOrder);
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 2, Buffer);
	  gtk_clist_set_row_data(GTK_CLIST(ErrorClist), NewRow, 
				 GINT_TO_POINTER(IntegrityTab[Counter].TypeDependent.LinkOut.LinkInvolved));
	  break;
	case SpotMissing : 
	  sprintf(Buffer,"Spot Missing");
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 1, Buffer);
	  sprintf(Buffer,"Spot %s Used in Comp %s from %s", 
		  IntegrityTab[Counter].TypeDependent.SpotMissing.SpotName,
		  IntegrityTab[Counter].TypeDependent.SpotMissing.ComponentName, 
		  IntegrityTab[Counter].TypeDependent.SpotMissing.SubFunctionName);
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 2, Buffer);
	  break;
	case LayoutMissing : 
	  sprintf(Buffer,"Layout Missing");
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 1, Buffer);
	  sprintf(Buffer,"Layout %s Used in Comp %s from %s",
		  IntegrityTab[Counter].TypeDependent.LayoutMissing.LayoutName,
		  IntegrityTab[Counter].TypeDependent.LayoutMissing.ComponentName, 
		  IntegrityTab[Counter].TypeDependent.LayoutMissing.SubFunctionName);
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 2, Buffer);
	  break;
	case CompDescMissing : 
	  sprintf(Buffer,"CompDesc Missing");
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 1, Buffer);
	  sprintf(Buffer,"CompDesc %s Used in Comp %s from %s", 
		  IntegrityTab[Counter].TypeDependent.CompDescMissing.CompDescName,
		  IntegrityTab[Counter].TypeDependent.CompDescMissing.ComponentName, 
		  IntegrityTab[Counter].TypeDependent.CompDescMissing.SubFunctionName);
	  gtk_clist_set_text(GTK_CLIST(ErrorClist), NewRow, 2, Buffer);
	  break;
	}
    }
  gtk_clist_thaw(GTK_CLIST(ErrorClist));
}
      
      
void on_ErrorClist_select_row (GtkCList *ErrorClist, gint row, gint column, GdkEvent *event, GtkWidget *Window)
{
  gpointer CompID;
  GCD *CircuitData;
  GtkWidget *RootTree, *TreeItem;

  CircuitData = GetCircuitData();
  RootTree = CircuitData->Info.CTComponentTree;
  
  CompID = gtk_clist_get_row_data( GTK_CLIST(ErrorClist), row);
  if ( GetIIDForComponent(CircuitData, GPOINTER_TO_INT(CompID), (void **) &TreeItem) == Found)
      gtk_tree_select_child(GTK_TREE(RootTree), GTK_WIDGET(TreeItem));
}

void on_ErrorClist_unselect_row (GtkCList *ErrorClist, gint row, gint column, GdkEvent *event, GtkWidget *Window)
{
  gpointer CompID;
  GCD *CircuitData;
  GtkWidget *RootTree, *TreeItem;

  CircuitData = GetCircuitData();
  RootTree = CircuitData->Info.CTComponentTree;
  
  CompID = gtk_clist_get_row_data( GTK_CLIST(ErrorClist), row);
  if ( GetIIDForComponent(CircuitData, GPOINTER_TO_INT(CompID), (void **) &TreeItem) == Found)
      gtk_tree_unselect_child(GTK_TREE(RootTree), GTK_WIDGET(TreeItem));
}


void cb_RefreshErrorClist (GtkButton *button, GtkWidget *ErrorClist)
{
  int IntegritySize, TabSize;
  Integrity *IntegrityTab;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  GetAttachPointNumber(CircuitData, &TabSize);
  IntegrityTab = (Integrity *)malloc(sizeof(Integrity) * TabSize);
  
  CheckCircuitIntegrity(CircuitData, IntegrityTab, &IntegritySize);
  FullErrorClist(ErrorClist, IntegrityTab, IntegritySize);
}

void on_ChooseDirectory_clicked (GtkButton *button, GtkWidget *Entry)
{
  GtkWidget *ChooseDirWindow;
  
  ChooseDirWindow = create_ChooseDirectoryWindow();
  gtk_object_set_data(GTK_OBJECT(ChooseDirWindow), DirectoryEntry, Entry);
  gtk_widget_show(ChooseDirWindow);
}

void on_SetDirectory_clicked (GtkButton *button, GtkWidget *FileSelect)
{
  GtkWidget *Entry;
  char *Buffer;

  Buffer = gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileSelect));
  Entry = gtk_object_get_data(GTK_OBJECT(FileSelect), DirectoryEntry);
  gtk_entry_set_text(GTK_ENTRY(Entry), Buffer);
}
  
  
void UpdateRouterStatusWindow(GCD *CircuitData, int RouterNb, int TotalRouter, int TrackNb, int TotalTrack)
{
  char Buffer[BufferLength];
  gfloat percentage;
  if ( CircuitData->Info.RouterCancelRequest == True)
    return;

  sprintf(Buffer, "Current Router Process %d / %d", RouterNb, TotalRouter);
  gtk_label_set_text(GTK_LABEL(CircuitData->Info.RouterLabel), (char *) Buffer);
  
  sprintf(Buffer, "Routed Track  %d / %d", TrackNb, TotalTrack);
  gtk_label_set_text(GTK_LABEL(CircuitData->Info.TrackLabel), (char *) Buffer);
  
  percentage = ((float) RouterNb) / TotalRouter;
  gtk_progress_set_percentage(GTK_PROGRESS(CircuitData->Info.ProgressBarRouter), percentage);

  percentage = ((float) TrackNb) / TotalTrack;
  gtk_progress_set_percentage(GTK_PROGRESS(CircuitData->Info.ProgressBarTrack), percentage);
}

void on_CancelRouter_clicked (GtkButton *button, GtkWidget *RouterStatusWindow)
{
  GCD *CircuitData;
  CircuitData  = GetCircuitData();
  CircuitData->Info.RouterCancelRequest = True;
  gtk_widget_destroy(RouterStatusWindow);
}

void on_LoadBest_clicked (GtkButton *button, gpointer user_data)
{
  GtkWidget *Window;
  char BestFile[BufferLength+5];
  GCD *CircuitData;
  ErrorCheck Check;

  CircuitData = GetCircuitData();
  sprintf(BestFile,"%s.Best", CircuitData->Info.CircuitFileName);

  Check = OpenCircuitFile(CircuitData, BestFile, NULL);
  if (Check != AllOk)
    {
      Window = create_OpenError();
      gtk_widget_show(Window);
    }
}
