
#include "popupmenu.h"

#include "interface.h"
#include "xrmtypes.h"
#include "liste.h"
#include "attachpoint.h"
#include "component.h"
#include "subfunction.h"
#include "link.h"
#include "circuitviewwindow.h"
#include "componentwindow.h"
#include "mainwindow.h"
#include "editwindows.h"
#include "linkwindow.h"

ErrorCheck GetIDFromCoordinates(int x, int y, int IDRef, int *SelectedID, Boolean Select)
{
  ErrorCheck Check;
  int ID = NoID;
  GCD *CircuitData;
  
  CircuitData = GetCircuitData();
  Check = NotFound;
  switch ( IDRef)
    {
    case AttachIDRef : 
      Check = GetAttachPointIDFromCoordinates(CircuitData, x, y, &ID);
      break;
    case ComponentIDRef : 
      Check = GetComponentIDFromCoordinates(CircuitData, x, y, &ID);
      break;
    case SubFunctionIDRef : 
      Check = GetSubFunctionIDFromCoordinates(CircuitData, x, y, &ID);
      break;
    case LinkIDRef : 
      Check = GetLinkIDFromCoordinates(CircuitData, x, y, &ID);
      break;
    default : printf(" Coord Type Invalid !\n");
    }

  if (Check == Found)
    {
      *SelectedID = ID;
      if (Select == True)
	SelectFromID(ID);
    }

  return Check;
} 
void
Popup_EditCircuit_activate         (GtkMenuItem     *menuitem,
				    gpointer         user_data)
{
  if (IRQ(True) == False)
    return;
  
  EditWithID(0, NoX, NoY);
  IRQ(False);
}
      
void
Popup_NewSubFunction_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ 
  int x, y, SubFID;
  GtkWidget *RootItem;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
 
  RootItem = CircuitData->Info.CTRootItem;
  SubFID = NewSubFunctionID(CircuitData, NoID);
  AddSubFunction(CircuitData, SubFID);
  AddWithIDUnder(SubFID, RootItem);
  EditWithID(SubFID, CircuitData->Info.PointerLocation.x, CircuitData->Info.PointerLocation.y);
  IRQ(False);
}

void
Popup_EditSubFunction_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;

  Check = GetIDFromCoordinates(x, y, SubFunctionIDRef, &ID, True);
  if (Check == Found) 
    EditWithID(ID, NoX, NoY);
  IRQ(False);
}

void
Popup_CutSubFunction_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetIDFromCoordinates(x, y, SubFunctionIDRef, &ID, True);
  
  if (Check == Found) 
    CutWithID(ID);
  IRQ(False);
} 

void
Popup_CopySubFunction_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetIDFromCoordinates(x, y, SubFunctionIDRef, &ID, True);
  if (Check == Found) 
    CopyWithID(ID);
  IRQ(False);
}

void
Popup_PasteSubFunction_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y;
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  PasteWithID(CircuitIDRef, x, y);
  IRQ(False);
}

void
Popup_SelectSubfunction_activate       (GtkMenuItem     *menuitem,
					gpointer         user_data)
{
  int x, y, ID;
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  GetIDFromCoordinates(x, y, SubFunctionIDRef, &ID, True);
  IRQ(False);
}

void
Popup_NewComponent_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ 
  GtkWidget *Window;
  GCD *CircuitData;
  int SubFunctionNb;

  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetSubFunctionNumber(CircuitData, &SubFunctionNb);
  if (SubFunctionNb != 0)
    {
      Window = create_ChooseSubFunctionNewComponent();
      FullChooseSubFunctionWindow(Window);
    }
  else 
    {
      Window = create_NoSubFunctionError();
      gtk_widget_show(Window);
    }
  IRQ(False);
}
void
Popup_EditComponent_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetIDFromCoordinates(x, y, ComponentIDRef, &ID, True);
  if (Check == Found) 
    EditWithID(ID, NoX, NoY);
  IRQ(False);
}

void
Popup_CutComponent_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetIDFromCoordinates(x, y, ComponentIDRef, &ID, True);
  if (Check == Found) 
    CutWithID(ID);
  IRQ(False);
}

void
Popup_CopyComponent_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetIDFromCoordinates(x, y, ComponentIDRef, &ID, True);
  if (Check == Found) 
    CopyWithID(ID);
  IRQ(False);
}

void
Popup_PasteComponent_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *Window;
  GCD *CircuitData;
  int SubFunctionNb;
  
  if (IRQ(True) == False)
    return;
  CircuitData = GetCircuitData();
  GetSubFunctionNumber(CircuitData, &SubFunctionNb);
  if (SubFunctionNb != 0)
    {
      Window = create_ChooseSubFunctionPastedComponent();
      FullChooseSubFunctionWindow(Window);
    }
  else 
    {
      Window = create_NoSubFunctionError();
      gtk_widget_show(Window);
    }
  IRQ(False);
}

void
Popup_SelectComponent_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  GetIDFromCoordinates(x, y, ComponentIDRef, &ID, True);
  IRQ(False);
}
void
Popup_SetStartPoint_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetSelectedAttachPointID(CircuitData, &ID);
  if (Check == Found) 
   SetExtremityWithID(ID, True);
  IRQ(False);
}

void
Popup_SetEndPoint_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetSelectedAttachPointID(CircuitData, &ID);
  if (Check == Found) 
    SetExtremityWithID(ID, False);
  IRQ(False);
}

void
Popup_EditAttachPoint_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  ErrorCheck Check;
  GCD *CircuitData;
  CircuitData = GetCircuitData();

  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  Check = GetIDFromCoordinates(x, y, AttachIDRef, &ID, True);
  
  if (Check == Found) 
    EditWithID(ID, NoX, NoY);
  IRQ(False);
}

void
Popup_SelectAttachPoint_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  GetIDFromCoordinates(x, y, AttachIDRef, &ID, True);
  IRQ(False);
}

void
Popup_NewLink_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (IRQ(True) == False)
    return;
  NewLink(True);
  IRQ(False);
}

void
Popup_SelectLink_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int x, y, ID;
  GCD *CircuitData;
  CircuitData = GetCircuitData();
  
  if (IRQ(True) == False)
    return;
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  GetIDFromCoordinates(x, y, LinkIDRef, &ID, True);
  IRQ(False);
}


void FullChooseSubFunctionWindow(GtkWidget *Window)
{
  GtkWidget *SFClist;
  gchar *NewSubFunction[1];
  int NewRow;
  SubFunction *SubFCursor;
  GCD *CircuitData;

  CircuitData = GetCircuitData();
  SFClist = gtk_object_get_data(GTK_OBJECT(Window), "SFClist");

  gtk_clist_freeze(GTK_CLIST(SFClist));
  SubFCursor = CircuitData->ListSubFunction;
  while (SubFCursor != NULL)
    {
      NewSubFunction[0] = SubFCursor->Name;
      NewRow = gtk_clist_append(GTK_CLIST(SFClist), NewSubFunction);
      gtk_clist_set_row_data(GTK_CLIST(SFClist), NewRow, GINT_TO_POINTER(SubFCursor->IDNumber));

      if (NewRow == 0)
	gtk_clist_select_row(GTK_CLIST(SFClist), NewRow, 0);
      
      SubFCursor = SubFCursor->pNext;
    }
  gtk_clist_thaw(GTK_CLIST(SFClist));
  gtk_widget_show(Window);
}

void on_SubFunctionList_select_row(GtkWidget *SFClist, gint row, gint column, GdkEventButton *event, GtkWidget *Window)
{
  int SubFID;

  SubFID = GPOINTER_TO_INT(gtk_clist_get_row_data(GTK_CLIST(SFClist), row));
  gtk_object_set_data(GTK_OBJECT(Window), ObjID, GINT_TO_POINTER(row));
  if (IsSubFunctionID(SubFID))
    SelectFromID(SubFID);
}

void on_SubFunctionList_unselect_row(GtkWidget *SFClist, gint row, gint column, GdkEventButton *event, GtkWidget *Window)
{
  gtk_object_set_data(GTK_OBJECT(Window), ObjID, GINT_TO_POINTER(NoID));
}

void cb_SetNewComponentSubFunction (GtkButton *button, GtkWidget *Window)
{
  GtkWidget *SFClist, *RootItem;
  int Row, SubFID, CompID, x, y;
  GCD *CircuitData;
  SubFunction SubFProp;

  CircuitData = GetCircuitData();
  SFClist = gtk_object_get_data(GTK_OBJECT(Window), "SFClist");
  Row = GPOINTER_TO_INT( gtk_object_get_data(GTK_OBJECT(Window), ObjID));
  if (Row == NoID)
    {
      printf(" No Sub Function Selected!!!\n");
      return;
    }

  SubFID = GPOINTER_TO_INT(gtk_clist_get_row_data( GTK_CLIST(SFClist), Row));
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;

  GetSubFunctionProperties(CircuitData, SubFID, &SubFProp);
  x -= SubFProp.Reference.x;
  y -= SubFProp.Reference.y;

  GetIIDForSubFunction(CircuitData, SubFID, (void **)&RootItem);
  CompID = NewComponentID(CircuitData, NoID);
  AddComponent(CircuitData, CompID, SubFID);
  AddWithIDUnder(CompID, RootItem);
  EditWithID(CompID, x, y);
}

void
cb_SetPastedComponentSubFunction          (GtkButton       *button,
                                        GtkWidget *Window)
{
  GtkWidget *SFClist;
  int Row, SubFID,x, y;
  GCD *CircuitData;
  SubFunction SubFProp;

  CircuitData = GetCircuitData();
  SFClist = gtk_object_get_data(GTK_OBJECT(Window), "SFClist");
  Row = GPOINTER_TO_INT( gtk_object_get_data(GTK_OBJECT(Window), ObjID));
  if (Row == NoID)
    {
      printf(" No Sub Function Selected!!!\n");
      return;
    }

  SubFID = GPOINTER_TO_INT(gtk_clist_get_row_data( GTK_CLIST(SFClist), Row));
  x = CircuitData->Info.PointerLocation.x;
  y = CircuitData->Info.PointerLocation.y;
  
  GetSubFunctionProperties(CircuitData, SubFID, &SubFProp);
  x -= SubFProp.Reference.x;
  y -= SubFProp.Reference.y;
  PasteWithID(SubFID, x, y);
}
void cb_SelectFromID (GtkButton *button, GtkWidget *Window)
{
  int ID, ArgNb;
  char *Buffer;
  GtkWidget *IDEntry;

  IDEntry = gtk_object_get_data(GTK_OBJECT(Window), "IDEntry");
  Buffer = gtk_entry_get_text(GTK_ENTRY(IDEntry));
  
  ArgNb = sscanf(Buffer, "%d", &ID);
  if (ArgNb ==1)
    SelectFromID(ID);
}
void Popup_SelectFromID_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget *Window;
  Window = create_SelectFromIDWindow();
  gtk_widget_show(Window);
}


