
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "spot.h"
#include "componentlibrary.h"

ErrorCheck LoadSpotLib(ComponentLibrary *CompLib, char *SpotFileName)
{
  int SpotNb, SpotCounter, Counter; 
  FILE *SpotFile;
  SpotDef SpotBuffer;
  
  SpotFile = fopen(SpotFileName,"r");
  if (SpotFile == NULL)
    {
      printf(" Error Opening SpotFile %s\n", SpotFileName);
      return FileAccessError;
    }
 
  fscanf(SpotFile, "%d\n", &SpotNb);
  for (SpotCounter = 0 ; SpotCounter < SpotNb ; SpotCounter++)
    {
      fscanf(SpotFile,"%[^\n]\n", SpotBuffer.SpotName);
      fscanf(SpotFile,"%d %d %d\n", &(SpotBuffer.SpotSize), &(SpotBuffer.CoreSpotSize),
	     &(SpotBuffer.InvisibleSpotSize));
      if (SpotBuffer.SpotSize != 0)
	SpotBuffer.SpotLocation = (Point *) malloc(sizeof(Point) * SpotBuffer.SpotSize);
      if (SpotBuffer.CoreSpotSize != 0)
	SpotBuffer.CoreSpotLocation = (Point *) malloc(sizeof(Point) * SpotBuffer.CoreSpotSize);
      if (SpotBuffer.InvisibleSpotSize != 0)
	SpotBuffer.InvisibleSpotLocation = (Point *) malloc(sizeof(Point) * SpotBuffer.InvisibleSpotSize);
      
      for (Counter = 0 ; Counter < SpotBuffer.CoreSpotSize ; Counter++)
	fscanf(SpotFile,"%d %d\n", &(SpotBuffer.CoreSpotLocation[Counter].x), 
	       &(SpotBuffer.CoreSpotLocation[Counter].y));
      for (Counter = 0 ; Counter < SpotBuffer.SpotSize ; Counter++)
	fscanf(SpotFile,"%d %d\n", &(SpotBuffer.SpotLocation[Counter].x), 
	       &(SpotBuffer.SpotLocation[Counter].y));
      for (Counter = 0 ; Counter < SpotBuffer.InvisibleSpotSize ; Counter++)
	fscanf(SpotFile,"%d %d\n", &(SpotBuffer.InvisibleSpotLocation[Counter].x), 
	       &(SpotBuffer.InvisibleSpotLocation[Counter].y));
      
      AddSpotDef(CompLib, SpotBuffer);
      if (SpotBuffer.SpotSize != 0)
	free(SpotBuffer.SpotLocation);
      if (SpotBuffer.CoreSpotSize != 0)
	free(SpotBuffer.CoreSpotLocation);
      if (SpotBuffer.InvisibleSpotSize != 0)
	free(SpotBuffer.InvisibleSpotLocation);
    }
  fclose(SpotFile);
  return AllOk;
}
ErrorCheck AddSpotDef( ComponentLibrary *CompLib, SpotDef SpotDefProp)
{
  SpotDef *SpotDefCursor, *SpotDefCursorPrevious, *NewSpotDef;
  Boolean SpotFound;
  int Counter;
  
  SpotFound = False;
  
  SpotDefCursor = CompLib->SpotDefList;
  SpotDefCursorPrevious  = NULL;
  
  while ( (SpotDefCursor != NULL ) && (SpotFound == False))
    {
      if ( strcmp(SpotDefCursor->SpotName, SpotDefProp.SpotName) >= 0 )
	SpotFound = True;
      else
	{
	  SpotDefCursorPrevious = SpotDefCursor;
	  SpotDefCursor = SpotDefCursor->pNext;
	}
    }

  NewSpotDef = (SpotDef *) malloc( sizeof(SpotDef));
  NewSpotDef->pNext = SpotDefCursor;
  if (SpotDefCursorPrevious != NULL)
    SpotDefCursorPrevious->pNext = NewSpotDef;
  else 
    CompLib->SpotDefList =  NewSpotDef;
   
  strncpy(NewSpotDef->SpotName, SpotDefProp.SpotName, SpotNameLength);
  NewSpotDef->SpotName[SpotNameLength-1] = '\0';
  NewSpotDef->SpotSize =  SpotDefProp.SpotSize;
  NewSpotDef->CoreSpotSize =  SpotDefProp.CoreSpotSize;
  NewSpotDef->InvisibleSpotSize =  SpotDefProp.InvisibleSpotSize;
  if ( NewSpotDef->SpotSize != 0)
    NewSpotDef->SpotLocation = (Point *) malloc( sizeof(Point) *   NewSpotDef->SpotSize);
  if ( NewSpotDef->CoreSpotSize != 0)
    NewSpotDef->CoreSpotLocation = (Point *) malloc( sizeof(Point) *   NewSpotDef->CoreSpotSize);
  if ( NewSpotDef->InvisibleSpotSize != 0)
    NewSpotDef->InvisibleSpotLocation = (Point *) malloc( sizeof(Point) *   NewSpotDef->InvisibleSpotSize);

  for (Counter =  0 ; Counter <  NewSpotDef->SpotSize ; Counter++ )
    NewSpotDef->SpotLocation[Counter]  =  SpotDefProp.SpotLocation[Counter];
  for (Counter =  0 ; Counter <  NewSpotDef->CoreSpotSize ; Counter++ )
    NewSpotDef->CoreSpotLocation[Counter]  =  SpotDefProp.CoreSpotLocation[Counter];
  for (Counter =  0 ; Counter <  NewSpotDef->InvisibleSpotSize ; Counter++ )
    NewSpotDef->InvisibleSpotLocation[Counter]  =  SpotDefProp.InvisibleSpotLocation[Counter];
  
  return AllOk;
}

ErrorCheck AddSpotLibToLoad(ComponentLibrary *CompLib, LibToLoad SpotLib)
{
  LibToLoad *NewSpot, *SpotCursor;
  
  NewSpot = NULL;
  SpotCursor = CompLib->SpotLibList;
  while (SpotCursor != NULL)
    {
      NewSpot = SpotCursor;
      SpotCursor = SpotCursor->pNext;
    }
  
  if (NewSpot != NULL)
    {
      NewSpot->pNext = (LibToLoad *) malloc (sizeof(LibToLoad));
      SpotCursor = NewSpot->pNext;
    }
  else 
    {
      CompLib->SpotLibList = (LibToLoad *) malloc (sizeof(LibToLoad));
      SpotCursor = CompLib->SpotLibList;
    }

  strncpy(SpotCursor->LibName, SpotLib.LibName, LibNameLength);
  SpotCursor->pNext = NULL;
  return AllOk;
}

ErrorCheck GetSpotProperties(ComponentLibrary *CompLib, char *SpotName, SpotDef *SpotProp, Boolean WithSpotLocation)
{
  int Counter;
  SpotDef *SpotCursor;
  Boolean SpotFound;
  
  SpotCursor = CompLib->SpotDefList;
  printf("%p\n", SpotCursor);
  SpotFound = False;
  while ((SpotCursor != NULL) && (SpotFound ==False))
    {
      printf("1:%s| 2:%s| %d\n", SpotName, SpotCursor->SpotName, strcmp(SpotName, SpotCursor->SpotName));
      if (strcmp(SpotName, SpotCursor->SpotName) == 0)
	{
	  SpotFound = True;
	  strncpy(SpotProp->SpotName, SpotCursor->SpotName, SpotNameLength);
	  SpotProp->SpotName[SpotNameLength-1] = '\0';

	  SpotProp->SpotSize = SpotCursor->SpotSize;
	  SpotProp->CoreSpotSize = SpotCursor->CoreSpotSize;
	  SpotProp->InvisibleSpotSize = SpotCursor->InvisibleSpotSize;
	  if (WithSpotLocation == True)
	    {
	      for (Counter = 0  ; Counter < SpotCursor->SpotSize ; Counter++)
		SpotProp->SpotLocation[Counter] = SpotCursor->SpotLocation[Counter];
	      for (Counter = 0  ; Counter < SpotCursor->CoreSpotSize ; Counter++)
		SpotProp->CoreSpotLocation[Counter] = SpotCursor->CoreSpotLocation[Counter];
	      for (Counter = 0  ; Counter < SpotCursor->InvisibleSpotSize ; Counter++)
		SpotProp->InvisibleSpotLocation[Counter] = SpotCursor->InvisibleSpotLocation[Counter];
	    }
	}
      SpotCursor = SpotCursor->pNext;
    }
  if (SpotFound == True)
    return Found;
  else return NotFound;
}

ErrorCheck CheckSpot(ComponentLibrary *CompLib, char *SpotName)
{
  Boolean SpotFound;
  SpotDef *SpotCursor;
  
  SpotCursor = CompLib->SpotDefList;
  SpotFound = False;
  while ((SpotCursor != NULL) && (SpotFound == False))
    {
      if (strcmp(SpotName, SpotCursor->SpotName) == 0)
	SpotFound = True;
      SpotCursor = SpotCursor->pNext;
    }
  
  if (SpotFound == True)
    return Found;
  else return NotFound;
}

ErrorCheck AutoRangeSpot(SpotDef SpotBuffer, int *LeftLimit, int *RightLimit, int *UpLimit, int *DownLimit)
{ 
  int  Counter, LeftBorder, RightBorder, UpBorder, DownBorder;
  
  LeftBorder = -1; 
  RightBorder = +1;
  DownBorder = -1; 
  UpBorder = +1;
  for (Counter = 0 ; Counter < SpotBuffer.CoreSpotSize ; Counter++)
    {
      if (SpotBuffer.CoreSpotLocation[Counter].x > RightBorder)
	RightBorder = SpotBuffer.CoreSpotLocation[Counter].x;
      if (SpotBuffer.CoreSpotLocation[Counter].x < LeftBorder)
	LeftBorder = SpotBuffer.CoreSpotLocation[Counter].x;
      if (SpotBuffer.CoreSpotLocation[Counter].y > UpBorder)
	UpBorder = SpotBuffer.CoreSpotLocation[Counter].y;
      if (SpotBuffer.CoreSpotLocation[Counter].y < DownBorder)
	DownBorder = SpotBuffer.CoreSpotLocation[Counter].y;
    }
  for (Counter = 0 ; Counter < SpotBuffer.SpotSize ; Counter++)
    {
      if (SpotBuffer.SpotLocation[Counter].x > RightBorder)
	RightBorder = SpotBuffer.SpotLocation[Counter].x;
      if (SpotBuffer.SpotLocation[Counter].x < LeftBorder)
	LeftBorder = SpotBuffer.SpotLocation[Counter].x;
      if (SpotBuffer.SpotLocation[Counter].y > UpBorder)
	UpBorder = SpotBuffer.SpotLocation[Counter].y;
      if (SpotBuffer.SpotLocation[Counter].y < DownBorder)
	DownBorder = SpotBuffer.SpotLocation[Counter].y;
    }
  LeftBorder--;
  RightBorder++;
  UpBorder++;
  DownBorder--;

  *LeftLimit = LeftBorder;
  *RightLimit = RightBorder;
  *UpLimit = UpBorder;
  *DownLimit = DownBorder;
  
  return AllOk;
}

ErrorCheck DisplaySpotLib(ComponentLibrary *CompLib)
{
  SpotDef *SpotCursor;
  
  SpotCursor = CompLib->SpotDefList;
  printf("Spot Lib\n");
  while(SpotCursor != NULL)
    {
      printf("------------------------------\n");
      printf("%s\n", SpotCursor->SpotName);
      printf("%d %d %d\n",SpotCursor->SpotSize, SpotCursor->CoreSpotSize, SpotCursor->InvisibleSpotSize);
      SpotCursor = SpotCursor->pNext;
    }
  return AllOk;
}
  
